/*
===============================================================================
  GkLibrary.s :  fthi Graphic User Interface jLbg Cu[
===============================================================================

	Copyright (C) 2007-2012  Masahiko Watanabe
	Revision Id.:  Rev.2012.12.12

-----------------------------------------------------------------------------*/

/*****/  // fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  px	#comment
/*****/

/*****  // fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  px	print
/*****/

#set  p		print

#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

//-----------------------------------------------------------------------------

function	^ModuleInit()
{
	^DefValue = null;	// ӁF ^DefValue ̒l͕ύXsI

	if( ^IsGkLibInit'exist? )
		return;

	#pc	"GK Library: Initialization Start!";

	#pv	^Kernel32 = ::DLL.Link( "KERNEL32", "sys" );
	#pv	^User32 = ::DLL.Link( "USER32", "sys" );
	#pv	^Gdi32 = ::DLL.Link( "GDI32", "sys" );
	#pv	^COMCTL32 = ::DLL.Link( "COMCTL32", "sys" );
	#pv	^COMDLG32 = ::DLL.Link( "COMDLG32", "sys" );
	#pv	^Shell32 = ::DLL.Link( "SHELL32", "sys" );

	#pv	^RegisterClassEx = ^User32.GetEntry( "RegisterClassExW" );
	#pv	^UnregisterClass = ^User32.GetEntry( "UnregisterClassW" );
	#pv	^AdjustWindowRectEx = ^User32.GetEntry( "AdjustWindowRectEx" );
	#pv	^CreateWindowEx = ^User32.GetEntry( "CreateWindowExW" );
	#pv	^CreateDialogIndirectParam = ^User32.GetEntry( "CreateDialogIndirectParamW" );
	#pv	^DestroyWindow = ^User32.GetEntry( "DestroyWindow" );
	#pv	^ShowWindow = ^User32.GetEntry( "ShowWindow" );
	#pv	^UpdateWindow = ^User32.GetEntry( "UpdateWindow" );
	#pv	^GetMessage = ^User32.GetEntry( "GetMessageW" );
	#pv	^PeekMessage = ^User32.GetEntry( "PeekMessageW" );
	#pv	^TranslateMessage = ^User32.GetEntry( "TranslateMessage" );
	#pv	^DispatchMessage = ^User32.GetEntry( "DispatchMessageW" );
	#pv	^SendMessage = ^User32.GetEntry( "SendMessageW" );
	#pv	^PostMessage = ^User32.GetEntry( "PostMessageW" );
	#pv	^PostQuitMessage = ^User32.GetEntry( "PostQuitMessage" );
	#pv	^DefWindowProc = ^User32.GetEntry( "DefWindowProcW" );
//	#pv	^CallWindowProc = ^User32.GetEntry( "CallWindowProcW" );
	#pv	^IsDialogMessage = ^User32.GetEntry( "IsDialogMessageW" );
	#pv	^GetDC = ^User32.GetEntry( "GetDC" );
	#pv	^GetWindowDC = ^User32.GetEntry( "GetWindowDC" );
	#pv	^ReleaseDC = ^User32.GetEntry( "ReleaseDC" );
	#pv	^BeginPaint = ^User32.GetEntry( "BeginPaint" );
	#pv	^EndPaint = ^User32.GetEntry( "EndPaint" );
	#pv	^GetClientRect = ^User32.GetEntry( "GetClientRect" );
	#pv	^DrawText = ^User32.GetEntry( "DrawTextW" );
	#pv	^TabbedTextOut = ^User32.GetEntry( "TabbedTextOutW" );
	#pv	^LoadIcon = ^User32.GetEntry( "LoadIconW" );
	#pv	^LoadCursor = ^User32.GetEntry( "LoadCursorW" );
	#pv	^EnableWindow = ^User32.GetEntry( "EnableWindow" );
	#pv	^SetFocus = ^User32.GetEntry( "SetFocus" );
	#pv	^SetWindowText = ^User32.GetEntry( "SetWindowTextW" );
	#pv	^GetWindowText = ^User32.GetEntry( "GetWindowTextW" );
	#pv	^MoveWindow = ^User32.GetEntry( "MoveWindow" );
	#pv	^SetForegroundWindow = ^User32.GetEntry( "SetForegroundWindow" );
	#pv	^ScrollWindowEx = ^User32.GetEntry( "ScrollWindowEx" );
	#pv	^SetTimer = ^User32.GetEntry( "SetTimer" );
	#pv	^KillTimer = ^User32.GetEntry( "KillTimer" );
	#pv	^SetMenu = ^User32.GetEntry( "SetMenu" );
	#pv	^DrawMenuBar = ^User32.GetEntry( "DrawMenuBar" );
	#pv	^IsWindowVisible = ^User32.GetEntry( "IsWindowVisible" );
	#pv	^IsWindowEnabled = ^User32.GetEntry( "IsWindowEnabled" );
	#pv	^IsZoomed = ^User32.GetEntry( "IsZoomed" );
	#pv	^IsIconic = ^User32.GetEntry( "IsIconic" );
	#pv	^DrawEdge = ^User32.GetEntry( "DrawEdge" );
	#pv	^DrawFrameControl = ^User32.GetEntry( "DrawFrameControl" );
	#pv	^DrawIconEx = ^User32.GetEntry( "DrawIconEx" );
	#pv	^GetKeyState = ^User32.GetEntry( "GetKeyState" );
	#pv	^InvalidateRect = ^User32.GetEntry( "InvalidateRect" );
	#pv	^ValidateRect = ^User32.GetEntry( "ValidateRect" );
	#pv	^GetWindowRect = ^User32.GetEntry( "GetWindowRect" );
	#pv	^GetWindowInfo = ^User32.GetEntry( "GetWindowInfo" );
	#pv	^ScreenToClient = ^User32.GetEntry( "ScreenToClient" );
	#pv	^ClientToScreen = ^User32.GetEntry( "ClientToScreen" );
	#pv	^GetWindowLong = ^User32.GetEntry( "GetWindowLongW" );
	#pv	^SetWindowLong = ^User32.GetEntry( "SetWindowLongW" );
	#pv	^GetClassLong = ^User32.GetEntry( "GetClassLongW" );
	#pv	^SetClassLong = ^User32.GetEntry( "SetClassLongW" );
	#pv	^SetScrollRange = ^User32.GetEntry( "SetScrollRange" );
	#pv	^SetScrollPos = ^User32.GetEntry( "SetScrollPos" );
	#pv	^SetScrollInfo = ^User32.GetEntry( "SetScrollInfo" );
	#pv	^GetScrollInfo = ^User32.GetEntry( "GetScrollInfo" );
	#pv	^CreateMenu = ^User32.GetEntry( "CreateMenu" );
	#pv	^CreatePopupMenu = ^User32.GetEntry( "CreatePopupMenu" );
	#pv	^GetMenu = ^User32.GetEntry( "GetMenu" );
	#pv	^GetSystemMenu = ^User32.GetEntry( "GetSystemMenu" );
	#pv	^SetMenu = ^User32.GetEntry( "SetMenu" );
	#pv	^DestroyMenu = ^User32.GetEntry( "DestroyMenu" );
	#pv	^DrawMenuBar = ^User32.GetEntry( "DrawMenuBar" );
	#pv	^InsertMenu = ^User32.GetEntry( "InsertMenuW" );
	#pv	^DeleteMenu = ^User32.GetEntry( "DeleteMenu" );
	#pv	^RemoveMenu = ^User32.GetEntry( "RemoveMenu" );
	#pv	^EnableMenuItem = ^User32.GetEntry( "EnableMenuItem" );
	#pv	^CheckMenuItem = ^User32.GetEntry( "CheckMenuItem" );
	#pv	^TrackPopupMenuEx = ^User32.GetEntry( "TrackPopupMenuEx" );
	#pv	^SetCursor = ^User32.GetEntry( "SetCursor" );
	#pv	^SetCursorPos = ^User32.GetEntry( "SetCursorPos" );
	#pv	^GetCursorPos = ^User32.GetEntry( "GetCursorPos" );
	#pv	^SetCapture = ^User32.GetEntry( "SetCapture" );
	#pv	^ReleaseCapture = ^User32.GetEntry( "ReleaseCapture" );
	#pv	^GetSystemMetrics = ^User32.GetEntry( "GetSystemMetrics" );
	#pv	^GetSysColor = ^User32.GetEntry( "GetSysColor" );
	#pv	^SystemParametersInfo = ^User32.GetEntry( "SystemParametersInfoW" );
	#pv	^SetWindowRgn = ^User32.GetEntry( "SetWindowRgn" );
	#pv	^SetLayeredWindowAttributes = ^User32.GetEntry( "SetLayeredWindowAttributes" );
	#pv	^GetDesktopWindow = ^User32.GetEntry( "GetDesktopWindow" );
	#pv	^MessageBox = ^User32.GetEntry( "MessageBoxW" );
	#pv	^MessageBeep = ^User32.GetEntry( "MessageBeep" );
	#pv	^GetDlgItem = ^User32.GetEntry( "GetDlgItem" );
	#pv	^GetDlgItemInt = ^User32.GetEntry( "GetDlgItemInt" );
	#pv	^GetDlgItemText = ^User32.GetEntry( "GetDlgItemTextW" );
	#pv	^SendDlgItemMessage = ^User32.GetEntry( "SendDlgItemMessageW" );
	#pv	^SetDlgItemInt = ^User32.GetEntry( "SetDlgItemInt" );
	#pv	^SetDlgItemText = ^User32.GetEntry( "SetDlgItemTextW" );
	#pv	^GetMonitorInfo = ^User32.GetEntry( "GetMonitorInfoW" );
	#pv	^MonitorFromRect = ^User32.GetEntry( "MonitorFromRect" );

	#pv	^SelectObject = ^Gdi32.GetEntry( "SelectObject" );
	#pv	^GetDeviceCaps = ^Gdi32.GetEntry( "GetDeviceCaps" );
	#pv	^CreateCompatibleDC = ^Gdi32.GetEntry( "CreateCompatibleDC" );
	#pv	^CreateDC = ^Gdi32.GetEntry( "CreateDCW" );
	#pv	^DeleteDC = ^Gdi32.GetEntry( "DeleteDC" );
	#pv	^SaveDC = ^Gdi32.GetEntry( "SaveDC" );
	#pv	^RestoreDC = ^Gdi32.GetEntry( "RestoreDC" );
	#pv	^SetMapMode = ^Gdi32.GetEntry( "SetMapMode" );
	#pv	^SetWindowExtEx = ^Gdi32.GetEntry( "SetWindowExtEx" );
	#pv	^SetViewportExtEx = ^Gdi32.GetEntry( "SetViewportExtEx" );
	#pv	^SetWindowOrgEx = ^Gdi32.GetEntry( "SetWindowOrgEx" );
	#pv	^SetViewportOrgEx = ^Gdi32.GetEntry( "SetViewportOrgEx" );
	#pv	^DPtoLP = ^Gdi32.GetEntry( "DPtoLP" );
	#pv	^LPtoDP = ^Gdi32.GetEntry( "LPtoDP" );
	#pv	^SetGraphicsMode = ^Gdi32.GetEntry( "SetGraphicsMode" );
	#pv	^SetWorldTransform = ^Gdi32.GetEntry( "SetWorldTransform" );
	#pv	^GetStockObject = ^Gdi32.GetEntry( "GetStockObject" );
	#pv	^ExtCreatePen = ^Gdi32.GetEntry( "ExtCreatePen" );
	#pv	^CreatePen = ^Gdi32.GetEntry( "CreatePen" );
	#pv	^CreateSolidBrush = ^Gdi32.GetEntry( "CreateSolidBrush" );
	#pv	^CreateHatchBrush = ^Gdi32.GetEntry( "CreateHatchBrush" );
//	#pv	^CreateBrushIndirect = ^Gdi32.GetEntry( "CreateBrushIndirect" );
	#pv	^SetBrushOrgEx = ^Gdi32.GetEntry( "SetBrushOrgEx" );
	#pv	^DeleteObject = ^Gdi32.GetEntry( "DeleteObject" );
//	#pv	^GetObject = ^Gdi32.GetEntry( "GetObject" );
	#pv	^MoveToEx = ^Gdi32.GetEntry( "MoveToEx" );
	#pv	^LineTo = ^Gdi32.GetEntry( "LineTo" );
	#pv	^SetPixelV = ^Gdi32.GetEntry( "SetPixelV" );
	#pv	^GetPixel = ^Gdi32.GetEntry( "GetPixel" );
	#pv	^SetROP2 = ^Gdi32.GetEntry( "SetROP2" );
	#pv	^PatBlt = ^Gdi32.GetEntry( "PatBlt" );
	#pv	^Rectangle = ^Gdi32.GetEntry( "Rectangle" );
	#pv	^Ellipse = ^Gdi32.GetEntry( "Ellipse" );
	#pv	^RoundRect = ^Gdi32.GetEntry( "RoundRect" );
	#pv	^Polyline = ^Gdi32.GetEntry( "Polyline" );
	#pv	^SetPolyFillMode = ^Gdi32.GetEntry( "SetPolyFillMode" );
	#pv	^Polygon = ^Gdi32.GetEntry( "Polygon" );
	#pv	^PolyBezier = ^Gdi32.GetEntry( "PolyBezier" );
	#pv	^PolyBezierTo = ^Gdi32.GetEntry( "PolyBezierTo" );
	#pv	^Arc = ^Gdi32.GetEntry( "Arc" );
	#pv	^Pie = ^Gdi32.GetEntry( "Pie" );
	#pv	^CreateFontIndirect = ^Gdi32.GetEntry( "CreateFontIndirectW" );
	#pv	^GetTextMetrics = ^Gdi32.GetEntry( "GetTextMetricsW" );
	#pv	^GetTextFace = ^Gdi32.GetEntry( "GetTextFaceW" );
	#pv	^SetTextColor = ^Gdi32.GetEntry( "SetTextColor" );
	#pv	^SetBkColor = ^Gdi32.GetEntry( "SetBkColor" );
	#pv	^SetBkMode = ^Gdi32.GetEntry( "SetBkMode" );
	#pv	^SetTextAlign = ^Gdi32.GetEntry( "SetTextAlign" );
	#pv	^SetTextCharacterExtra = ^Gdi32.GetEntry( "SetTextCharacterExtra" );
	#pv	^SetTextJustification = ^Gdi32.GetEntry( "SetTextJustification" );
	#pv	^TextOut = ^Gdi32.GetEntry( "TextOutW" );
	#pv	^ExtTextOut = ^Gdi32.GetEntry( "ExtTextOutW" );
	#pv	^GetTextExtentExPoint = ^Gdi32.GetEntry( "GetTextExtentExPointW" );
	#pv	^CreateBitmap = ^Gdi32.GetEntry( "CreateBitmap" );
	#pv	^CreateCompatibleBitmap = ^Gdi32.GetEntry( "CreateCompatibleBitmap" );
	#pv	^CreateDIBitmap = ^Gdi32.GetEntry( "CreateDIBitmap" );
	#pv	^CreateDIBSection = ^Gdi32.GetEntry( "CreateDIBSection" );
	#pv	^StretchDIBits = ^Gdi32.GetEntry( "StretchDIBits" );
	#pv	^SetDIBColorTable = ^Gdi32.GetEntry( "SetDIBColorTable" );
	#pv	^SetDIBitsToDevice = ^Gdi32.GetEntry( "SetDIBitsToDevice" );
	#pv	^SetStretchBltMode = ^Gdi32.GetEntry( "SetStretchBltMode" );
	#pv	^StretchBlt = ^Gdi32.GetEntry( "StretchBlt" );
	#pv	^CreateRectRgn = ^Gdi32.GetEntry( "CreateRectRgn" );
	#pv	^CreateEllipticRgn = ^Gdi32.GetEntry( "CreateEllipticRgn" );
	#pv	^CreateRoundRectRgn = ^Gdi32.GetEntry( "CreateRoundRectRgn" );
	#pv	^CreatePolygonRgn = ^Gdi32.GetEntry( "CreatePolygonRgn" );
	#pv	^CombineRgn = ^Gdi32.GetEntry( "CombineRgn" );
	#pv	^FrameRgn = ^Gdi32.GetEntry( "FrameRgn" );
	#pv	^FillRgn = ^Gdi32.GetEntry( "FillRgn" );
	#pv	^SelectClipRgn = ^Gdi32.GetEntry( "SelectClipRgn" );
	#pv	^StartDoc = ^Gdi32.GetEntry( "StartDocW" );
	#pv	^EndDoc = ^Gdi32.GetEntry( "EndDoc" );
	#pv	^AbortDoc = ^Gdi32.GetEntry( "AbortDoc" );
	#pv	^StartPage = ^Gdi32.GetEntry( "StartPage" );
	#pv	^EndPage = ^Gdi32.GetEntry( "EndPage" );
	#pv	^SetAbortProc = ^Gdi32.GetEntry( "SetAbortProc" );

	#pv	^GetModuleHandle = ^Kernel32.GetEntry( "GetModuleHandleW" );
	#pv	^GlobalAlloc = ^Kernel32.GetEntry( "GlobalAlloc" );
	#pv	^GlobalFree = ^Kernel32.GetEntry( "GlobalFree" );
	#pv	^GlobalLock = ^Kernel32.GetEntry( "GlobalLock" );
	#pv	^GlobalUnlock = ^Kernel32.GetEntry( "GlobalUnlock" );
	#pv	^GlobalSize = ^Kernel32.GetEntry( "GlobalSize" );
	#pv	^GetTickCount = ^Kernel32.GetEntry( "GetTickCount" );
	#pv	^GetLastError = ^Kernel32.GetEntry( "GetLastError" );
	#pv	^FormatMessage = ^Kernel32.GetEntry( "FormatMessageW" );
	#pv	^FindResource = ^Kernel32.GetEntry( "FindResourceW" );
	#pv	^LoadResource = ^Kernel32.GetEntry( "LoadResource" );
	#pv	^LockResource = ^Kernel32.GetEntry( "LockResource" );
	#pv	^SizeofResource = ^Kernel32.GetEntry( "SizeofResource" );

	#pv	^InitCommonControls = ^COMCTL32.GetEntry( "InitCommonControls" );
	#pv	^InitCommonControlsEx = ^COMCTL32.GetEntry( "InitCommonControlsEx" );

	#pv	^GetOpenFileName = ^COMDLG32.GetEntry( "GetOpenFileNameW" );
	#pv	^GetSaveFileName = ^COMDLG32.GetEntry( "GetSaveFileNameW" );
	#pv	^PrintDlg = ^COMDLG32.GetEntry( "PrintDlgW" );
	#pv	^CommDlgExtendedError = ^COMDLG32.GetEntry( "CommDlgExtendedError" );

	#pv	^DragAcceptFiles = ^Shell32.GetEntry( "DragAcceptFiles" );
	#pv	^DragQueryFile = ^Shell32.GetEntry( "DragQueryFileW" );
	#pv	^DragQueryPoint = ^Shell32.GetEntry( "DragQueryPoint" );
	#pv	^DragFinish = ^Shell32.GetEntry( "DragFinish" );

	::DLL.SetCallback( ^WndProc );

	^hInstance = ^GetModuleHandle( 0 );

	MSG ::=
	{
		.hwnd		'ULONG;
		.message	'ULONG;
		.wParam		'ULONG;
		.lParam		'ULONG;
		.time		'ULONG;
		.x			'LONG;
		.y			'LONG;
	}
	^msg = ::Buffer( MSG'size );

	RECT ::=
	{
		.left	'LONG;
		.top	'LONG;
		.right	'LONG; 
		.bottom	'LONG;
	}
	PAINTSTRUCT ::=
	{
		.hdc			'ULONG;
		.fErase			'LONG;
		.rcPaint		= RECT;
		.fRestore		'LONG;
		.fIncUpdate		'LONG;
		.rgbReserved	'BYTE(32);
	}
	^ps'LONG( ( PAINTSTRUCT'size + 3 ) / 4 );

	^DRAWITEMSTRUCT ::=
	{
		.CtlType		'ULONG;
		.CtlID			'ULONG;
		.itemID			'ULONG;
		.itemAction		'ULONG;
		.itemState		'ULONG;
		.hwndItem		'ULONG;
		.hDC			'ULONG;
		.rcItem			= RECT;
		.itemData		'ULONG;
	}
	^SizeOfDRAWITEMSTRUCT = ^DRAWITEMSTRUCT'size;

	class ::GK.WindowBase	{}
	class ::GK.Window	 : ::GK.WindowBase	{}
	class ::GK.DlgWindow : ::GK.Window		{}
	class ::GK.Dialog	 : ::GK.Window		{}

	class ::GK.Graphics
	{
		.ExtTextMode = 0;	//#ETO_OPAQUE | #ETO_CLIPPED;
	}
	class ::GK.Image   : ::GK.Graphics	{}
	class ::GK.VFrame  : ::GK.Graphics	{}
	class ::GK.WndView : ::GK.Graphics	{}
	class ::GK.Printer : ::GK.Graphics	{}
//	class ::GK.MetaFile : ::GK.Graphics	{}

	class ::GK.Pen		{}
	class ::GK.Brush	{}

	class ::GK.Font
	{
		.PLAIN  = 0;		// ʏ
		.BOLD 	= 1;		// 
		.ITALIC	= 2;		// C^bN

		.Stock[ "AnsiFixed" ]  = #ANSI_FIXED_FONT;
		.Stock[ "AnsiVar" ]    = #ANSI_VAR_FONT;
		.Stock[ "SysFixed" ]   = #SYSTEM_FIXED_FONT;
		.Stock[ "SysVar" ]     = #SYSTEM_FONT;
		.Stock[ "DefaultGUI" ] = #DEFAULT_GUI_FONT;
	}

	class ::GK.Point	{}
	class ::GK.Line		{}
	class ::GK.Rect		{}
	class ::GK.Oval		{}
	class ::GK.RRect	{}
	class ::GK.Arc		{}
	class ::GK.Pie		{}
	class ::GK.Polygon	{}
	class ::GK.Polyline	{}
	class ::GK.Bitmap	{}
	class ::GK.Region	{}

	class ::GK.Cursor	{}
	class ::GK.Icon		{}

	class ::GK.TopMenu	{}
	class ::GK.Menu		{}
	class ::GK.SysMenu : ::GK.Menu	{}

	class ::GK.ScrollBar : ::GK.WindowBase	{}

	class ::GK.Button : ::GK.WindowBase
	{
		.Style[ "push" ]	= #BS_PUSHBUTTON;		// vbV{^
		.Style[ "default" ]	= #BS_DEFPUSHBUTTON;	// ftH[gvbV{^
		.Style[ "check" ]	= #BS_CHECKBOX;			// `FbN{bNXiԂ̓vOj
		.Style[ "radio" ]	= #BS_RADIOBUTTON;		// WI{^@@iԂ̓vOj
		.Style[ "group" ]	= #BS_GROUPBOX;			// O[v{bNX
		.Style[ "draw" ]	= #BS_OWNERDRAW;		// I[i[`{^
		//ijȊǑ`́Aʒl𒼐ڎwiȍ~̃EBWFbglj
	}

	class ::GK.Label : ::GK.WindowBase
	{
		.Style[ "left" ]	= #SS_LEFT;
		.Style[ "right" ]	= #SS_RIGHT;
		.Style[ "center" ]	= #SS_CENTER;
	}

	class ::GK.EditBox : ::GK.WindowBase
	{
		.Style[ "left" ]	= #ES_LEFT | #ES_AUTOHSCROLL;
	//	.Style[ "right" ]	= #ES_RIGHT | #ES_AUTOHSCROLL;
	//	.Style[ "center" ]	= #ES_CENTER | #ES_AUTOHSCROLL;
		.Style[ "multi" ]	= #ES_MULTILINE | #ES_LEFT | #ES_WANTRETURN |
					#ES_AUTOVSCROLL | #ES_AUTOHSCROLL | #WS_VSCROLL | #WS_HSCROLL;
	//	.Style[ "read-only" ] = #ES_READONLY | #ES_LEFT | #ES_MULTILINE | 
	//				#ES_AUTOVSCROLL | #ES_AUTOHSCROLL | #WS_VSCROLL | #WS_HSCROLL;
		.Style[ "password" ]  = #ES_PASSWORD | #ES_LEFT;
	}
	class ::GK.ComboBox : ::GK.WindowBase	{}
	class ::GK.ListBox  : ::GK.WindowBase	{}

	class ::GK.ToolBar	 : ::GK.WindowBase	{}
	class ::GK.StatusBar : ::GK.WindowBase	{}

	class ::GK.TreeView	 : ::GK.WindowBase	{}

	class ::GK.TrackBar    : ::GK.WindowBase	{}
	class ::GK.ProgressBar : ::GK.WindowBase	{}

	class ::GK.ToolTip : ::GK.WindowBase	{}

	//hDC = ^GetDC( #NULL );
	//^DefFont = ::GK.Font( "lr oSVbN",
	//	::round( 9.0 * ^GetDeviceCaps( hDC, #LOGPIXELSY ) / 72 )'int );
	//^ReleaseDC( #NULL, hDC );
	//^DefFont = ::GK.Font( "DefaultGUI" );
	//^DefFont = ::GK.Font( "SysFixed" );
	//^DefFont = ::GK.Font( "SysVar" );
	//^DefFont = ::GK.Font( "lr oSVbN", 12 );

	^WidgetId = 100;
	^NullRect = ::GK.Rect( 0,0,0,0 );
	^DegToRad = ::Math.arctan(-1,0) / 180;

//	INITCOMMONCONTROLSEX 'ULONG(2);
//	INITCOMMONCONTROLSEX(0) = 8;
//	INITCOMMONCONTROLSEX(1) = #ICC_WIN95_CLASSES;
//#pv	^InitCommonControlsEx( INITCOMMONCONTROLSEX );
	^InitCommonControls();

	^TBBUTTON 'ULONG(5);

	^TVITEM ::=
	{
		.mask			'ULONG;
		.hItem			'ULONG;
		.state			'ULONG;
		.stateMask		'ULONG;
		.pszText		'ULONG;		// char*
		.cchTextMax		'LONG;
		.iImage			'LONG;
		.iSelectedImage	'LONG;
		.cChildren		'LONG;
		.lParam			'ULONG;
	}

	^tv_buff = ::Buffer( 80 );

	::DLL.SetCallback( ^PrintAbortProc );

	::GK'AddScope( ^ModuleInit'up );

	^ParaProc? = #FALSE;		// sȂ
	^IsGkLibInit = #TRUE;
}

//-----------------------------------------------------------------------------

function	^ModuleTerm()
{
	if( ! ^IsGkLibInit'exist? )
		return;

	if( ^WndClassName )
		^UnregisterClass( ^WndClassName, ^hInstance );
	if( ^DlgClassName )
		^UnregisterClass( ^DlgClassName, ^hInstance );

	::DLL.ResetCallback( ^WndProc );
	::DLL.ResetCallback( ^PrintAbortProc );

	delete	^Shell32;
	delete	^COMDLG32;
	delete	^COMCTL32;
	delete	^Gdi32;
	delete	^User32;
	delete	^Kernel32;

	delete	::GK;
	delete	^IsGkLibInit;

	#pc	"GK Library: Termination End!";
}

//-----------------------------------------------------------------------------

#include  "GkWindow.mc"		// EBhE֘A
#include  "GkGraphics.mc"	// OtBbNX֘A
#include  "GkWidgets.mc"	// efthi

//-----------------------------------------------------------------------------

