/*
===============================================================================
  GkWindow.s :  fjCu EBhE֘A
===============================================================================

	Copyright (C) 2007-2012  Masahiko Watanabe
	Revision Id.:  Rev.2012.04.24

-----------------------------------------------------------------------------*/

function	::GK.WindowMsgLoop()
{
	if( ^ActWindow'count <= 0 )		// EBhEȂH
		return;

	Msg'ULONG( 7 );

	while( ^GetMessage( Msg, #NULL, 0, 0 ))
	{
		if( ^hDlgWnd  &&
			^IsDialogMessage( ^hDlgWnd, Msg ) )
			continue;

		^TranslateMessage( Msg );
		^DispatchMessage( Msg );

		while( ^ParaProc? )		// s
		{
			'yield;

			while( ^PeekMessage( Msg, #NULL, 0, 0, #PM_REMOVE ) )
			{
				if( Msg(1) == #WM_QUIT )	// MSG.message
					return;

				if( ^hDlgWnd  &&
					^IsDialogMessage( ^hDlgWnd, Msg ) )
					continue;

				^TranslateMessage( Msg );
				^DispatchMessage( Msg );
			}
		}
	}
}

function	::GK.SetParaProc( bool )
{
	^ParaProc? = bool;
}

//-----------------------------------------------------------------------------

function	^WndProc( hWnd, iMsg, wParam, lParam )
{
	//#px	"WndProc: ": hWnd'x, iMsg'x, wParam'x, lParam'x;

	if(( Wnd := ^ActWindow[ hWnd ] ) == null )
		goto DEF_WINDOW_PROC;

	switch( iMsg )
	{
	  case #WM_SIZE:
			Wnd::OnSize( Wnd.gc.Xd = lParam & 0xFFFF, Wnd.gc.Yd = lParam >> 16 );
			if( Wnd::StatusBar'exist? )
				^SendMessage( Wnd::StatusBar.hWnd, #WM_SIZE, wParam, lParam );
			return 0;

	  case #WM_PAINT:
			^BeginPaint( hWnd, ^ps );
			Wnd::OnPaint();
			^EndPaint( hWnd, ^ps );
			return 0;

	  case #WM_ERASEBKGND:
			if( Wnd::DlgBox? )
				break;
			return #TRUE;	//ijwi`́AOnPaint() ōsȂ

	//case #WM_SETCURSOR:
	//		Wnd::OnSetCursor( lParam & 0xFFFF );
	//		break;

	  case #WM_MOUSEMOVE:		//ij}EXʒu̓NCAgWn
			Wnd::OnMouseMove( lParam'SHORT'int, lParam >> 16, wParam );
			return 0;			//ijwParam ́A}EX{^̏ԃrbg

	  case #WM_LBUTTONDOWN:			// 1: {^
	  case #WM_LBUTTONUP:			// 2: @ V @
	  case #WM_LBUTTONDBLCLK:		// 3: @ V @_uNbN
	  case #WM_RBUTTONDOWN:			// 4: E{^
	  case #WM_RBUTTONUP:			// 5: @ V @
	  case #WM_RBUTTONDBLCLK:		// 6: @ V @_uNbN
	  case #WM_MBUTTONDOWN:			// 7: {^
	  case #WM_MBUTTONUP:			// 8: @ V @
	  case #WM_MBUTTONDBLCLK:		// 9: @ V @_uNbN
			Wnd::OnMouseButton(	//ij}EXʒu̓NCAgWn
				lParam'SHORT'int, lParam >> 16, wParam, iMsg );
			return 0;			//ijwParam ́A}EX{^̏ԃrbg

	  case #WM_MOUSEWHEEL:		//ij}EXʒu̓XN[Wn
			Wnd::OnMouseWheel( lParam'SHORT'int, lParam >> 16, wParam >> 16 );
			return 0;			//ijwParam ̏ 16-bit ́A]

	  case #WM_SETFOCUS:
			Wnd::OnGotFocus();
///			return 0;
			break;

	  case #WM_KILLFOCUS:
			Wnd::OnLostFocus();
///			return 0;
			break;

	  case #WM_SYSKEYDOWN:
			if(( wParam != #VK_F10 )  ||	//ijF10 ́AWM_KEYDOWN ł͗Ȃ
			   ( lParam & 0x20000000 ))		// ALT L[̉H
				break;
			// ALT L[Ȃ F10 L[ꍇ̂݁A͉ɍs

	  case #WM_KEYDOWN:		//ijI[gs[g
			//#pc	"WM_KEYDOWN: ", wParam'x, lParam'x;
			if( wParam <= 0xFF  &&
			   ( lParam & 0x20000000 ) == 0 )	// ALT L[̉ȂH
			{
				if( ^GetKeyState( #VK_CONTROL ) & 0x8000 )
					wParam |= #KCF_CTRL;
				if( ^GetKeyState( #VK_SHIFT ) & 0x8000 )
					wParam |= #KCF_SHIFT;
				if( lParam & 0x40000000 )	// I[gs[gɂR[hH
					wParam |= #KCF_REPEAT;
				Wnd::OnKeyDown( wParam );
			}
			return 0;

	  case #WM_SYSKEYUP:
			if(( wParam != #VK_F10 )  ||	//ijF10 ́AWM_KEYDOWN ł͗Ȃ
			   ( lParam & 0x20000000 ))		// ALT L[̉H
				break;
			// ALT L[Ȃ F10 L[𗣂ꍇ̂݁A͉ɍs

	  case #WM_KEYUP:
			if( wParam <= 0xFF &&
			   ( lParam & 0x20000000 ) == 0 )	// ALT L[̉ȂH
			{
				Wnd::OnKeyUp( wParam );	//ijSHIFT,CTRL̃tO͕tȂ
			}
			return 0;

	  case #WM_CHAR:
			Wnd::OnChar( wParam );
			return 0;

	  case #WM_COMMAND:
			//#pc	"WM_COMMAND: ", wParam'x, lParam'x;
			if( lParam == 0 )
			{
				if(( wParam >> 16 ) == 0 )	Wnd::OnMenu( wParam & 0xFFFF );
			  	else						Wnd::OnAccel( wParam & 0xFFFF );
			}
			else	// lParam : Rg[̃nh
			{		// HIWORD( wParam ) : ʒmR[h
					// LOWORD( wParam ) : ʃR[h
				switch(( wParam >> 16 ) & 0xFFFF )
				{
				  case #BN_CLICKED:  //ij{^́Ac[o[̏ꍇ
				  case #LBN_DBLCLK:
				  case #LBN_SELCHANGE:
				  case #CBN_SELCHANGE:
					if( Wnd::DlgBox? )
						Wnd::OnCommand( wParam,
							^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ] );
					else
						^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ]
								::OnCommand( wParam );
					break;

				//default:	// dvȒʒmłȂꍇ
				//	if( Wnd::DlgBox? )
				//		Wnd::OnCommandExt( wParam );
				//	else
				//		^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ]
				//			::OnCommandExt( wParam );
				//	break;
				}
			}
			break;

	  case #WM_SYSCOMMAND:
			if( Wnd::OnSysMenu( wParam ) )
				return 0;
			break;

	  case #WM_NOTIFY:
			//#pc	"WM_NOTIFY: ", iMsg'x, wParam'x, lParam'x, ^WidgetList[ ^GetWindowLong( lParam'ULONG'pv, #GWL_ID ) ], ( lParam + 4*2 )'ULONG'pv;
			if( Wnd::DlgBox? )
				Wnd::OnNotify( wParam, ( lParam + 4*2 )'ULONG'pv, lParam );
			else
				^WidgetList[ ^GetWindowLong( lParam'ULONG'pv, #GWL_ID ) ]
						::OnNotify( wParam, ( lParam + 4*2 )'ULONG'pv, lParam );
			return 0;

	  case #WM_MENUSELECT:		// j[ڂ̃nCCgԂω
			flag = wParam >> 16;				// j[ʃtO
			if( flag == -1  &&  lParam == 0 )	// nCCgŁH
				Wnd::OnMenuHilite( -1 );
			else
			if(	!( flag & #MF_SYSMENU ))		// VXej[ł͂ȂH
			{
				Wnd::OnMenuHilite(( flag & #MF_POPUP ) ? -1 : ( wParam & 0xFFFF ));
				//ij́AnCCgڂ̎ʔԍ
				//		( -1 ͂ǂ̎ʔԍΉڂnCCgłȂƂj
				return 0;
			}
			break;

	  case #WM_INITMENU:		// j[ANeBuɂȂ钼O
			Wnd::OnMenuShow();	// Kv΂Ńj[\eXV
			return 0;

	  case #WM_DRAWITEM:
			if( Wnd::DlgBox? )
				Wnd::OnDrawItem( lParam );
			else
				^WidgetList[ wParam & 0xFFFF ]::OnDrawItem( lParam );
			return #TRUE;

	//case #WM_CTLCOLORBTN:		//ij]̓ȂI
	//		if( @color = ^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ].color )
	//		{
	//			#pc "WM_CTLCOLORBTN", @color'x, wParam;
	//			^SetTextColor( wParam, @color );
	//			//return 0;
	//			return ^GetClassLong( lParam, #GCL_HBRBACKGROUND );
	//		}
	//		break;

	  case #WM_HSCROLL:
	  case #WM_VSCROLL:
			if( lParam )	// q̃XN[o[H
			{
				if( Wnd::DlgBox? )
					Wnd::OnScroll( wParam & 0xFFFF, wParam >> 16,
						^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ] );
				else
					^WidgetList[ ^GetWindowLong( lParam, #GWL_ID ) ]::
						OnScroll( wParam & 0xFFFF, wParam >> 16 );
			}
			//ijł́AEBhEt̕WXN[o[͑ΏۊO
			return 0;

	  case #WM_GETMINMAXINFO:	//ijɂ́AWM_CREATE ̑Oɂ
			if( Wnd::OnMinMaxInfo( lParam ) )
				return 0;
			break;

	  case #WM_TIMER:
			Wnd::OnTimer( wParam );
			return 0;

	  case #WM_DROPFILES:
			Wnd::OnDropFiles( wParam );
			^DragFinish( wParam );
			return 0;

	  case #WM_ACTIVATE:
			//#set	WA_INACTIVE  0
			^hDlgWnd = (( wParam & 0xFFFF ) != 0  &&  Wnd::DlgBox? ) ?
						hWnd : #NULL ;
			break;

	  case #WM_CLOSE:				// {EBhEĂǂ̊mF
	  case #WM_QUERYENDSESSION:		// OAEgĂǂ̊mF
			if( Wnd::OnClose() == -1 )
				return 0;			// {EBhE͕Ȃ
			^SetMenu( Wnd::hWnd, #NULL );
				//ijj[̔j́AfXgN^sȂ
			break;

	  case #WM_DESTROY:
			Wnd::OnDestroy();
			^ActWindow[ hWnd ] := null;
			delete ^ActWindow[ hWnd ];
			delete Wnd::gc;
			Wnd::hWnd = #NULL;
			Wnd::OnEnded();
			if( ^ActWindow'count <= 0 )		// EBhEȂH
				^PostQuitMessage(0);
			return 0;

	  case #WM_APP_END_DLG_WINDOW:
			^DlgWndList[ wParam ]::OnEnd();
			return 0;

	  default:
		    // AvŗLbZ[W
			if( #WM_APP <= iMsg  &&  iMsg <= #WM_APP_MAX )
				return Wnd::OnAppMessage( iMsg, wParam, lParam );
			// [U[ŗLbZ[W
			if( #WM_USER <= iMsg  &&  iMsg <= #WM_USER_MAX )
				return Wnd::OnUserMessage( iMsg, wParam, lParam );
			// Oo^bZ[W
			if( Wnd::ExtWndProc[ iMsg ]'exist? )
			{
				xp := Wnd::ExtWndProc[ iMsg ];
				return xp::obj.[ xp::func ]( wParam, lParam );
			}
			break;
	}
  DEF_WINDOW_PROC:	// ɁAwarp ŗ鎞
	return ^DefWindowProc( hWnd, iMsg, wParam, lParam );

  OnError:
	print ::ErrorMessage( $err_code, $err_info ), $err_func;
	return;
}

//=============================================================================

function ::GK.Window.OnCreate()			{}	// {EBhE
function ::GK.Window.OnClose()			{}	// {EBhE钼O
function ::GK.Window.OnDestroy()		{}	// {EBhEj
function ::GK.Window.OnEnded()			{}	// {EBhEI

function ::GK.Window.OnSize( x, y )		{}	// {EBhẼTCY̕ω
function ::GK.Window.OnPaint()			{}	// {EBhE̕`v鎞

function ::GK.Window.OnMouseMove( x, y, s )		 {}	// }EXړi{^Ȃj
function ::GK.Window.OnMouseButton( x, y, s, m ) {}	// }EX{^NbN
function ::GK.Window.OnMouseWheel( x, y, d )	 {}	// }EXzC[쎞

function ::GK.Window.OnSetCursor()		{}	// J[\`̐ݒv鎞

function ::GK.Window.OnGotFocus()		{}	// {EBhEL[{[htH[JX擾
function ::GK.Window.OnLostFocus()		{}	// {EBhEL[{[htH[JX

function ::GK.Window.OnKeyDown( vk )	{}	// L[iI[gs[gj
function ::GK.Window.OnKeyUp( vk )		{}	// L[𗣂
function ::GK.Window.OnChar( c )		{}	// R[h͎

function ::GK.Window.OnMenu( id )		{}	// j[ڂ̎siIj
function ::GK.Window.OnSysMenu( id )	{}	// VXej[ڂ̎siIj
function ::GK.Window.OnMenuShow()		{}	// j[ANeBuɂȂ钼O
function ::GK.Window.OnMenuHilite( id )	{}	// j[ڂ̃nCCgԂ̕ω

function ::GK.Window.OnAccel( id )		{}	// ANZ[^L[̉
function ::GK.Window.OnToolCommand( id ){}	// c[{^

function ::GK.Window.OnTimer( id )		{}	// ^C}[Ԍoߎ
function ::GK.Window.OnMinMaxInfo( p )	{}	// EBhETCY̍őEŏ̊m莞
function ::GK.Window.OnSysParaChange()	{}	// VXep[^ύX
function ::GK.Window.OnAppMessage( iMsg, wParam, lParam )	{}	// AvŗLbZ[W
function ::GK.Window.OnUserMessage( iMsg, wParam, lParam )	{}	// [U[ŗLbZ[W
function ::GK.Window.OnCopyData( id, bn, bp )	{}	// Rs[f[^M
function ::GK.Window.OnDropFiles( hDrop )		{}	// t@ChbOhbvꂽ

function ::GK.Window.OnIME_Notify( cmd )		{}	// IME ̏ԕω
function ::GK.Window.OnIME_CompoStart()			{}	// IME ϊJn
function ::GK.Window.OnIME_CompoChange( flags )	{}	// IME ϊԕω
function ::GK.Window.OnIME_CompoEnd()			{}	// IME ϊI

//-----------------------------------------------------------------------------

function ::GK.Window.Construct( Title, Xo, Yo, Xd, Yd, Style, ExtStyle, Owner )
{
//	if( ! ^WndClassName )
	{
#pc		^WndClassName;
#pc		^UnregisterClass( ^WndClassName, ^hInstance );

		^WndClassName = "GK_AppWindow";

		WNDCLASSEX ::=
		{
			.cbSize			'ULONG;
			.style			'ULONG	= #CS_HREDRAW | #CS_VREDRAW | #CS_DBLCLKS | #CS_OWNDC;
			.lpfnWndProc	'ULONG	= ^WndProc'addr;
			.cbClsExtra		'LONG	= 0;
			.cbWndExtra		'LONG	= 0;
			.hInstance		'ULONG	= ^hInstance;
			.hIcon			'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
			.hCursor		'ULONG	= ^LoadCursor( 0, #IDC_ARROW );
			.hbrBackground	'ULONG	= 0;
			.lpszMenuName	'ULONG	= 0;
			.lpszClassName	'ULONG	= ^WndClassName'addr;
			.hIconSm		'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
		}
		WNDCLASSEX.cbSize = WNDCLASSEX'size;

		wndclass = ::Buffer( WNDCLASSEX.cbSize );
		wndclass.Write( WNDCLASSEX );
		wndclass.Seek(0);

		#pc	wndclass;

		if( ^RegisterClassEx( wndclass ) == 0 )
		{
			#pc	"EBhENXo^sI";
			//return #NG;
		}
	}

	if( Title'type != "string" )	Title := "";
	if( Xo'type != "integer" )		Xo := #CW_USEDEFAULT;
	if( Yo'type != "integer" )		Yo := #CW_USEDEFAULT;
	if( Xd'type != "integer" )		Xd := #CW_USEDEFAULT;
	if( Yd'type != "integer" )		Yd := #CW_USEDEFAULT;
	if( Style'type != "integer" )	Style := #WS_OVERLAPPEDWINDOW;
	if( ExtStyle'type != "integer" )  ExtStyle := 0;

	#pc  "GK.Window.Construct", Title, Xo, Yo, Xd, Yd;

	.hWnd = ^CreateWindowEx(
				ExtStyle,				// extended window style
				^WndClassName,			// registered window class name
				Title,					// window title name
				Style,					// window style
				Xo,						// horizontal position of window
				Yo,						// vertical position of window
				Xd,						// window width
				Yd,						// window height
				Owner.hWnd,				// handle to parent or owner window
				#NULL,					// handle to menu, or child-window identifier
				^hInstance,				// handle to application instance
				#NULL					// pointer to window-creation data
			);
	if( .hWnd == #NULL )
	{
		print "EBhE쐬sI--- 0x": ^GetLastError()'x(8);
		print ::GK.GetSysErrMsg();
		return #NG;
	}
	^ActWindow[ .hWnd ] := this;
	.gc = ::GK.Graphics( ^GetDC( .hWnd ) );
	//^SetTextAlign( .gc.hdc, #TA_TOP | #TA_LEFT );	//ij̐ݒ̓ftH[g
	.DlgBox? = #FALSE;
	.OnCreate();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Window.Destruct()
{
	if( .hWnd )
	{
	#pc	"GK.Window.Destruct @1", .hWnd;
		^DestroyWindow( .hWnd );
	}
	#pc	"GK.Window.Destruct @2", .hWnd, this'name, ^ActWindow'count;
}

//-----------------------------------------------------------------------------

function ::GK.DlgWindow.Display( Title, Owner, Xo, Yo, Xd, Yd )
{
	if( .Owner := Owner )
		( Xo, Yo ) := Owner.ClientToScreen( Xo, Yo );

	.[ ::GK.Window.Construct ]( Title, Xo, Yo, Xd, Yd,
		#WS_CHILD | #WS_POPUP | #WS_CAPTION | #WS_SYSMENU | #WS_DLGFRAME,
		#WS_EX_DLGMODALFRAME,
		Owner );

	if( .hWnd == #NULL )
	{
		print "_CAOEBhE쐬sI";
		return #NG;
	}
	.Result = #FALSE;
	.[ ::GK.Window.Open ]();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.DlgWindow.OnCreate()
{
	.OnDisplay();
	if( .Owner )
		.Owner.Disable();
}

function ::GK.DlgWindow.OnDestroy()
{
	#pc	"OnDestroy #1";
	p := this'first;
	while( p'ref? )
	{
		if( p.owner == this )
		{
			t := p;
			p := this'next;
			#pc	t'name, t.id;
			delete ^WidgetList[ t.id ];
		}
		else
			p := this'next;
	}
	if( .Owner )
	{
		.Owner.Enable();
		.Owner.PostMessage( #WM_APP_END_DLG_WINDOW, this'addr, 0 );
		^DlgWndList[ this'addr ] := this;
	}
	#pc	"OnDestroy #2";
}

function ::GK.DlgWindow.OnKeyDown( vk )
{
	#pc	"OnKeyDown: ": vk'x(4);
	switch( vk & ~#KCF_REPEAT )
	{
	  case #VK_ESCAPE:	.Result = #FALSE;	.Close();	break;
	  case #VK_RETURN:	.Result = #TRUE;	.Close();	break;
	}
}

function ::GK.DlgWindow.OnPaint()
{
	.GetHotRect( R'STRUCT );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

function ::GK.DlgWindow.OnDisplay()	{}
function ::GK.DlgWindow.OnEnd()		{}

//-----------------------------------------------------------------------------

function ::GK.Dialog.Construct( hInst, ResId, Owner )
{
	#pc  "GK.Dialog.Construct", hInst, ResId, Owner;

	if( ! ^DlgClassName )	// _CAO{bNXp̃EBhENXo^H
	{
		^DlgClassName = "GK_DlgWindow";

		WNDCLASSEX ::=
		{
			.cbSize			'ULONG;
			.style			'ULONG	= #CS_HREDRAW | #CS_VREDRAW | #CS_DBLCLKS | #CS_OWNDC;
			.lpfnWndProc	'ULONG	= ^WndProc'addr;
			.cbClsExtra		'LONG	= 0;
			.cbWndExtra		'LONG	= 48;	// > DLGWINDOWEXTRA(=30)
			.hInstance		'ULONG	= ^hInstance;
			.hIcon			'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
			.hCursor		'ULONG	= ^LoadCursor( 0, #IDC_ARROW );
			.hbrBackground	'ULONG	= #COLOR_WINDOW;
			.lpszMenuName	'ULONG	= 0;
			.lpszClassName	'ULONG	= ^DlgClassName'addr;
			.hIconSm		'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
		}
		WNDCLASSEX.cbSize = WNDCLASSEX'size;

		wndclass = ::Buffer( WNDCLASSEX.cbSize );
		wndclass.Write( WNDCLASSEX );
		wndclass.Seek(0);

		#pc	wndclass;

		if( ^RegisterClassEx( wndclass ) == 0 )
		{
			#pc	"_CAO{bNXpEBhENXo^ -- sI";
			//return #NG;
		}
	}

	if( hInst == null  &&  ResId'type == "integer" )
		pTemp = ResId;
	else
	if(( hFind = ^FindResource( hInst, ResId, #RT_DIALOG )) == #NULL  ||
	   ( hLoad = ^LoadResource( hInst, hFind )) == #NULL  ||
	   ( pTemp = ^LockResource( hLoad )) == #NULL ) 
	{
		#pc ^GetLastError(), "\[X擾sI";
		return #NG;
	}
	#pc	hInst, ResId;
	#pc	( pTemp + 0 )'ULONG'pv'cbo'x(8), ( pTemp + 4 )'ULONG'pv'cbo'x(8), ( pTemp + 8 )'ULONG'pv'cbo'x(8), ( pTemp + 12 )'ULONG'pv'cbo'x(8);

	.DlgBox? = #TRUE;

	.hWnd = ^CreateDialogIndirectParam(
				^hInstance,		// handle to module
				pTemp,			// dialog box template
				Owner.hWnd,		// handle to owner window
				NULL,			// dialog box procedure
				NULL			// initialization value
			);
	if( .hWnd == #NULL )
	{
		#pc ^GetLastError(), "_CAO{bNX쐬sI";
		return #NG;
	}
	^ActWindow[ .hWnd ] := this;
	.gc = ::GK.Graphics( ^GetDC( .hWnd ) );
	.OnCreate();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Dialog.Destruct()
{
	if( .hWnd )
	{
	#pc	"GK.Dialog.Destruct @1", .hWnd;
		^DestroyWindow( .hWnd );
	}
	#pc	"GK.Dialog.Destruct @2", .hWnd, this'name, ^ActWindow'count;
}

//-----------------------------------------------------------------------------

function ::GK.Window.Open()
{
	^ShowWindow( .hWnd, #SW_SHOWNORMAL );
	^UpdateWindow( .hWnd );
	^SetForegroundWindow( .hWnd );
	#pc	"GK.Window.Open ", .hWnd;
}

function ::GK.Window.Close()
{
	^PostMessage( .hWnd, #WM_CLOSE, 0, 0 );
	//^SendMessage( .hWnd, #WM_CLOSE, 0, 0 );
	//^DestroyWindow( .hWnd );
	#pc	"GK.Window.Close ", .hWnd;
}

function ::GK.Window.Maximize()	{  ^ShowWindow( .hWnd, #SW_MAXIMIZE );  }
function ::GK.Window.Minimize()	{  ^ShowWindow( .hWnd, #SW_MINIMIZE );  }
function ::GK.Window.Restore()	{  ^ShowWindow( .hWnd, #SW_RESTORE );   }
function ::GK.Window.Max?()		{  return ^IsZoomed( .hWnd );  }
function ::GK.Window.Min?()		{  return ^IsIconic( .hWnd );  }

function ::GK.Window.MouseCaptOn()	{  ^SetCapture( .hWnd );  }
function ::GK.Window.MouseCaptOff()	{  ^ReleaseCapture();  }

function ::GK.Window.Scroll( dx, dy, R )
{
	if( R != null )
	{
		@R'LONG(4) = {  R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd  };
		R := @R;
	}
	#set	SW_INVALIDATE	2
	^ScrollWindowEx( .hWnd, dx, dy, R, R, #NULL, #NULL, #SW_INVALIDATE );
	//ijScrollWindow() ́AgȂ悤ɊĂ
}

function ::GK.Window.GetHotRect( R )
{
	R.Xo = ^ps(2);
	R.Yo = ^ps(3);
	R.Xd = ^ps(4) - ^ps(2);
	R.Yd = ^ps(5) - ^ps(3);
}

function ::GK.Window.GetAdjRect( R, IsMenu?, Style, ExtStyle )
{
	@R'LONG(4) = {  R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd  };

	if( IsMenu? 'type != "integer" )  IsMenu? := #FALSE;
	if( Style   'type != "integer" )  Style := #WS_OVERLAPPEDWINDOW;
	if( ExtStyle'type != "integer" )  ExtStyle := 0;

	if( ! ^AdjustWindowRectEx( @R, Style, IsMenu?, ExtStyle ) )
		return #FALSE;

	R.Xo = @R(0);
	R.Yo = @R(1);
	R.Xd = @R(2) - @R(0);
	R.Yd = @R(3) - @R(1);
	return #TRUE;
}

function ::GK.Window.SetWindowRgn( rgn, redraw? )
{
	if( ^SetWindowRgn( .hWnd, rgn.hRgn, redraw? ) )
		rgn.hRgn = null;  // ̃[W̓VXeǗɓߍ폜s
}

function ::GK.Window.SetLayerAttr( color, alpha, flags )
{
	return ^SetLayeredWindowAttributes( .hWnd, color, alpha, flags );
}

function ::GK.Window.SetForeground()
{
	^SetForegroundWindow( .hWnd );
}

// EBhEbZ[W̊O֐ݒ^
function ::GK.Window.SetExtWndProc( msg, func, obj )
{
	if( func'type == "usr-func" )
	{
		.ExtWndProc[ msg ].func := func;
		.ExtWndProc[ msg ].obj := obj;
	}
	else
		delete .ExtWndProc[ msg ];
}

//-----------------------------------------------------------------------------

// EBhEʑ

function ::GK.WindowBase.Show()		{  ^ShowWindow( .hWnd, #SW_SHOW );  }
function ::GK.WindowBase.Hide()		{  ^ShowWindow( .hWnd, #SW_HIDE );  }
function ::GK.WindowBase.Update()	{  ^UpdateWindow( .hWnd );  }
function ::GK.WindowBase.Visible?()	{  return ^IsWindowVisible( .hWnd );  }

function ::GK.WindowBase.Enable( s )	{  ^EnableWindow( .hWnd, s == null ? #TRUE : s );   }
function ::GK.WindowBase.Disable( s )	{  ^EnableWindow( .hWnd, s == null ? #FALSE : s );  }
function ::GK.WindowBase.Enabled?()		{  return ^IsWindowEnabled( .hWnd );  }

function ::GK.WindowBase.SetFocus()	{  ^SetFocus( .hWnd );  }

function ::GK.WindowBase.SetTitle( title )	{  ^SetWindowText( .hWnd, title );  }
function ::GK.WindowBase.GetTitle()
{
	title'USHORT( 1024 );
	^GetWindowText( .hWnd, title, 1024 );
	return title'gets;
}

function ::GK.WindowBase.InvalidateRect( R )
{
	if( R != null )
	{
		@R'LONG(4) = {  R.Xo, R.Yo, R.Xo + R.Xd, R.Yo + R.Yd  };
		R := @R;
	}
	^InvalidateRect( .hWnd, R, #FALSE );
}

function ::GK.WindowBase.SetFont( font )
{
	^SendMessage( .hWnd, #WM_SETFONT, font.hFont, #TRUE );
}

function ::GK.WindowBase.SendMessage( iMsg, wParam, lParam )
{
	^SendMessage( .hWnd, iMsg, wParam, lParam );
}

function ::GK.WindowBase.PostMessage( iMsg, wParam, lParam )
{
	^PostMessage( .hWnd, iMsg, wParam, lParam );
}

function ::GK.WindowBase.OnCommand( wParam )		{}
//function ::GK.WindowBase.OnCommandExt( wParam )	{}
function ::GK.WindowBase.OnNotify( id, code, lp )	{}
function ::GK.WindowBase.OnDrawItem( lp )			{}

function ::GK.WindowBase.OnEndDlgWindow( id )		{}


function ::GK.WindowBase.SetClassLong( i, v )	{  return ^SetClassLong( .hWnd, i, v );  }
function ::GK.WindowBase.GetClassLong( i )		{  return ^GetClassLong( .hWnd, i );  }

function ::GK.WindowBase.SetWindowLong( i, v )	{  return ^SetWindowLong( .hWnd, i, v );  }
function ::GK.WindowBase.GetWindowLong( i )		{  return ^GetWindowLong( .hWnd, i );  }

function ::GK.WindowBase.ScreenToClient( x, y )
{
	P'LONG(2) = { x, y };
	^ScreenToClient( .hWnd, P );
	return ( P(0), P(1) );
}

function ::GK.WindowBase.ClientToScreen( x, y )
{
	P'LONG(2) = { x, y };
	^ClientToScreen( .hWnd, P );
	return ( P(0), P(1) );
}

function ::GK.WindowBase.GetClientSize()
{
	R'LONG(4);
	^GetClientRect( .hWnd, R );
	return ( R(2), R(3) );		// RECT.right, .bottom
}

function ::GK.WindowBase.GetWindowRect( R )
{
	Rw'LONG(4);
	^GetWindowRect( .hWnd, Rw );
	R.Xo = Rw(0);
	R.Yo = Rw(1);
	R.Xd = Rw(2) - Rw(0);
	R.Yd = Rw(3) - Rw(1);
}

function ::GK.WindowBase.Move( R )
{
	^MoveWindow( .hWnd, R.Xo, R.Yo, R.Xd, R.Yd, #TRUE );
}

//-----------------------------------------------------------------------------

function ::GK.Window.AttachKeyAccel( acc )	{}
function ::GK.Window.DetachKeyAccel()		{}

function ::GK.Window.StartTimer( id, msec )	{  return ^SetTimer( .hWnd, id, msec, #NULL );  }
function ::GK.Window.StopTimer( id )		{  return ^KillTimer( .hWnd, id );  }

function ::GK.Window.GetMousePos( X, Y )	// J[\ʒuNCAgWnŎ擾
{
	P'LONG(2);
	^GetCursorPos( P );
	^ScreenToClient( .hWnd, P );
	X = P(0);
	Y = P(1);
}

function ::GK.Window.SetMousePos( X, Y )	// J[\ʒuNCAgWnŐݒ
{
	P'LONG(2) = { X, Y };
	^ClientToScreen( .hWnd, P );
	^SetCursorPos( P(0), P(1) );
}

function ::GK.Window.SetMouseCursor( cursor )	{}	// NCAg̈ɕ\J[\̎w
function ::GK.Window.UpdateMouseState()			{}	// }EX̏ԂXV

//-----------------------------------------------------------------------------

// j[֘A

function ::GK.Window.SetMenuBar( top_menu )	// EBhEɃj[o[t
{
	^SetMenu( .hWnd, top_menu.hTopMenu );
}

function ::GK.Window.UnsetMenuBar()		// EBhE烁j[o[폜
{
	^SetMenu( .hWnd, #NULL );
}

function ::GK.Window.DrawMenuBar()		// EBhẼj[o[ĕ`
{
	^DrawMenuBar( .hWnd );
}

/*@@@@@@@@

// EBhẼj[o[Ɏw胁j[w薼̂Ŏwʒuɑ}
function ::GK.Window.InsertMenu( menu, name, ix )
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
	{
		^InsertMenu( hTopMenu, ix != null ? ix : -1,	// -1: ɑ}
						 #MF_BYPOSITION | #MF_POPUP, menu.hMenu, name );
		^DrawMenuBar( .hWnd );
	}
}

// EBhẼj[o[̎wʒũj[폜
function ::GK.Window.DeleteMenu( ix )
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
	{
		^DeleteMenu( hTopMenu, ix, #MF_BYPOSITION );
		^DrawMenuBar( .hWnd );
	}
}

//ijEBhẼj[o[ɂ́Av_Ej[̂ݑ}B
//		ȊÓAAT|[gB

function ::GK.Window.EnableMenuItem( id )	// whc̃j[ڂLɂ
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
		^EnableMenuItem( hTopMenu, id, #MF_BYCOMMAND | #MF_ENABLED );
}
function ::GK.Window.DisableMenuItem( id )	// whc̃j[ڂ𖳌ɂ
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
		^EnableMenuItem( hTopMenu, id, #MF_BYCOMMAND | #MF_GRAYED );
}

function ::GK.Window.CheckMenuItem( id )	// whc̃j[ڂ̃`FbNݒ
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
		^CheckMenuItem( hTopMenu, id, #MF_BYCOMMAND | #MF_CHECKED );
}
function ::GK.Window.UncheckMenuItem( id )	// whc̃j[ڂ̃`FbN
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
		^CheckMenuItem( hTopMenu, id, #MF_BYCOMMAND | #MF_UNCHECKED );
}

function ::GK.Window.DeleteMenuItem( id )	// whc̃j[ڂ폜
{
	if( hTopMenu = ^GetMenu( .hWnd ) )
		^DeleteMenu( hTopMenu, id, #MF_BYCOMMAND );
}

//ijEBhẼj[o[̃v_Ej[̂hcȂTuj[
//		L^A`FbN̐ݒ^A폜́AAs\B

@@@@@@@@*/

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Window.PopupMenu( menu, x, y )
{
	if( x == null  ||  y == null )
	{
		P'LONG(2);
		^GetCursorPos( P );
	}
	else
	{
		P'LONG(2) = { x, y };
		^ClientToScreen( .hWnd, P );
	}
	return ^TrackPopupMenuEx( menu.hMenu, 
		 #TPM_LEFTALIGN | #TPM_TOPALIGN | #TPM_RIGHTBUTTON,
		 //#TPM_LEFTALIGN | #TPM_TOPALIGN | #TPM_RIGHTBUTTON | #TPM_RETURNCMD | #TPM_NONOTIFY,
		P(0), P(1), .hWnd, #NULL );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.SysMenu.Construct( wnd )		// VXej[
{
	.hMenu = ^GetSystemMenu( wnd.hWnd, #FALSE );
}
// ::GK.GetSysMenu NX̃fXgN^͕sv

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.TopMenu.Construct()	{  .hTopMenu = ^CreateMenu();  }
function ::GK.TopMenu.Destruct()	{  ^DestroyMenu( .hTopMenu );  }

// j[o[Ɏw胁j[w薼̂Œǉ
function ::GK.TopMenu.InsertMenu( menu, name, ix )
{
	^InsertMenu( .hTopMenu, ix != null ? ix : -1,	// -1: ɑ}
					 #MF_BYPOSITION | #MF_POPUP, menu.hMenu, name );
}
// ӁF
//	::GK.TopMenu NX̃IuWFNǵA::GK.Window.SetMenuBar() ł̂ݎgp

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

function ::GK.Menu.Construct()	{  .hMenu = ^CreatePopupMenu();  }
function ::GK.Menu.Destruct()	{  ^DestroyMenu( .hMenu );  }

// {j[Ɏw̃Tuj[w薼̂Ŏwʒuɑ}
function ::GK.Menu.InsertMenu( menu, name, ix )
{
	^InsertMenu( .hMenu, ix != null ? ix : -1,	// -1: ɑ}
					 #MF_BYPOSITION | #MF_POPUP, menu.hMenu, name );
}

// {j[ɎwhcƎw薼̂̍ڂwʒuɑ}
function ::GK.Menu.InsertItem( id, name, ix )
{
	^InsertMenu( .hMenu, ix != null ? ix : -1,	// -1: ɑ}
					#MF_BYPOSITION | #MF_STRING, id, name );
}

// {j[ɃZp[^wʒuɑ}
function ::GK.Menu.InsertSeparator( ix )
{
	^InsertMenu( .hMenu, ix != null ? ix : -1,	// -1: ɑ}
					#MF_BYPOSITION | #MF_SEPARATOR, 0, #NULL );
}

function ::GK.Menu.EnableItem( id )		// whc̍ڂLɂ
{
	^EnableMenuItem( .hMenu, id, #MF_BYCOMMAND | #MF_ENABLED );
}

function ::GK.Menu.DisableItem( id )	// whc̍ڂ𖳌ɂ
{
	^EnableMenuItem( .hMenu, id, #MF_BYCOMMAND | #MF_GRAYED );
}

function ::GK.Menu.CheckItem( id )		// whc̍ڂ̃`FbNݒ
{
	^CheckMenuItem( .hMenu, id, #MF_BYCOMMAND | #MF_CHECKED );
}

function ::GK.Menu.UncheckItem( id )	// whc̍ڂ̃`FbN
{
	^CheckMenuItem( .hMenu, id, #MF_BYCOMMAND | #MF_UNCHECKED );
}

function ::GK.Menu.DeleteItem( id )		// {j[̎whc̍ڂ폜
{
	^DeleteMenu( .hMenu, id, #MF_BYCOMMAND );
}

function ::GK.Menu.RemoveMenu( ix )		// {j[̎wʒũTuj[
{										//ijTuj[̃nh͑
	^RemoveMenu( .hMenu, ix, #MF_BYPOSITION );
}

//ijj[́Aj[o[ɓo^ƁAEBhEł̑ΏۂɂȂB
//		::GK.Menu ł̑́A̓o^OA܂́A|bvAbvj[pB
//ijj[̂hcȂTuj[̗L^A`FbN
//		ݒ^́AAs\B́AʒuwŉB

//-----------------------------------------------------------------------------

function ::GK.Cursor.Construct( id )
{
	.hCursor = ^LoadCursor( #NULL, id );	// VXe`ς݃J[\\z
}

//function ::GK.Cursor.Destruct()	{}		//ijJ[\͖IȔjsv

function ::GK.Cursor.Change()			{  ^SetCursor( .hCursor );  }

function ::GK.Cursor.SetPos( x, y )		{  ^SetCursorPos( x, y );  }

function ::GK.Cursor.GetPos()
{
	P'LONG(2);
	^GetCursorPos( P );
	return ( P(0), P(1) );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Icon.Construct( id )
{
	.hIcon = ^LoadIcon( #NULL, id );	// VXeŒ`ς݃ACR\z
}

//function ::GK.Icon.Destruct()	  {}	//ijACR͖Ijsv

//-----------------------------------------------------------------------------

function ::GK.Window.Remove( ... )		// EBWFbg̍폜
{
	N = va_param'count;
	for( i = 0 ; i < N ; i++ )
	{
		p := va_param[i];
		if( p.owner != this )
			continue;
		^DestroyWindow( p.hWnd );
		delete ^WidgetList[ p.id ];
	}
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddButton( style, name, R, ex_style )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer"  &&
	  ( style := ::GK.Button.Style[ style ] ) == null )
		style := #BS_PUSHBUTTON;

	if( ex_style'type != "integer" )
		ex_style := 0;

	//if( R == null )
	//	R := ^NullRect;
	//ij̏sȂȂĂAR  null ̏ꍇA
	//		R.Xo  null ɂȂ̂ŁAƂ肠Aȉł͓ʂɂȂ

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY | ex_style,
				"BUTTON",
				name,
				#WS_CHILD | #WS_VISIBLE | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	if( .DefWidgetFont'exist? )
		^SendMessage( hwnd, #WM_SETFONT, .DefWidgetFont.hFont, #FALSE );

	btn = ::GK.Button();
	btn.hWnd = hwnd;
	btn.style = style;
	btn.name = name;
	btn.owner := this;

	^WidgetList[ btn.id = ^WidgetId ++ ] := btn;

	return btn;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddLabel( text, R, style, ex_style )
{
	if( style'type != "integer"  &&
	  ( style := ::GK.Label.Style[ style ] ) == null )
		style := #SS_LEFT;

	if( ex_style'type != "integer" )
		ex_style := 0;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY | ex_style,
				"STATIC",
				text,
				#WS_CHILD | #WS_VISIBLE | style,
				R.Xo,	// R == null ̎AR.Xo  null ɂȂ
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				0,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	if( .DefWidgetFont'exist? )
		^SendMessage( hwnd, #WM_SETFONT, .DefWidgetFont.hFont, #FALSE );

	label = ::GK.Label();
	label.hWnd = hwnd;
	label.owner := this;
	return label;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddHScrollBar( R )  {  return .AddScrollBar( "H", R );  }
function ::GK.Window.AddVScrollBar( R )  {  return .AddScrollBar( "V", R );  }

function ::GK.Window.AddScrollBar( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	switch( style )
	{
	  default:		if( style'type == "integer" )
						break;
	  case "H":		style := #SBS_HORZ;   break;
	  case "V":		style := #SBS_VERT;   break;
	}

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"SCROLLBAR",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	sb = ::GK.ScrollBar();
	sb.hWnd = hwnd;
	sb.owner := this;

	sb.info'LONG(7);	// SCROLLINFO
	sb.info(0) = 4*7;	// .cbSize = sizeof(SCROLLINFO);

	^WidgetList[ sb.id = ^WidgetId ++ ] := sb;

	return sb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddEditBox( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer"  &&
	  ( style := ::GK.EditBox.Style[ style ] ) == null )
		style := #ES_LEFT | #ES_AUTOHSCROLL;

	hwnd = ^CreateWindowEx(
				#WS_EX_CLIENTEDGE | #WS_EX_NOPARENTNOTIFY,
				"EDIT",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | style, // | #WS_THICKFRAME,   //#WS_DLGFRAME, // | #WS_BORDER,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	if( .DefWidgetFont'exist? )
		^SendMessage( hwnd, #WM_SETFONT, .DefWidgetFont.hFont, #FALSE );

	eb = ::GK.EditBox();
	eb.hWnd = hwnd;
	eb.owner := this;

	^WidgetList[ eb.id = ^WidgetId ++ ] := eb;

	return eb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddComboBox( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer" )
		style := #CBS_DROPDOWNLIST;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"COMBOBOX",		// "ComboBoxEx32"
				#NULL,
				#WS_CHILD | #WS_VISIBLE | #WS_VSCROLL | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	if( .DefWidgetFont'exist? )
		^SendMessage( hwnd, #WM_SETFONT, .DefWidgetFont.hFont, #FALSE );

	cb = ::GK.ComboBox();
	cb.hWnd = hwnd;
	cb.owner := this;

	^WidgetList[ cb.id = ^WidgetId ++ ] := cb;

	return cb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddListBox( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer" )
		style := #LBS_STANDARD;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"LISTBOX",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | #WS_VSCROLL | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	if( .DefWidgetFont'exist? )
		^SendMessage( hwnd, #WM_SETFONT, .DefWidgetFont.hFont, #FALSE );

	lb = ::GK.ListBox();
	lb.hWnd = hwnd;
	lb.owner := this;

	^WidgetList[ lb.id = ^WidgetId ++ ] := lb;

	return lb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddToolBar()
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY | #WS_EX_TOOLWINDOW,
				"ToolbarWindow32",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | #WS_CLIPSIBLINGS |
					#CCS_TOP |
					#TBSTYLE_TOOLTIPS, // | #TBSTYLE_FLAT | #TBSTYLE_CUSTOMERASE,
				0, 0, 0, 0,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	^SendMessage( hwnd, #TB_BUTTONSTRUCTSIZE, 20, 0 );	// sizeof(TBBUTTON) = 20

	tb = ::GK.ToolBar();
	tb.hWnd = hwnd;
	tb.owner := this;

	^WidgetList[ tb.id = ^WidgetId ++ ] := tb;

	return tb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.SetStatusBar()
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"msctls_statusbar32",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | #WS_CLIPSIBLINGS | #SBARS_SIZEGRIP,
				0, 0, 0, 0,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return #NG;

	.StatusBar = ::GK.StatusBar();
	.StatusBar.hWnd = hwnd;
	.StatusBar.owner := this;

	^WidgetList[ .StatusBar.id = ^WidgetId ++ ] := .StatusBar;

	return #OK;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddTreeView( R, style, ex_style )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	//ijc[r[ł́A^CreateWindowEx ֐sɁA
	//		WM_NOTIFY ̂ŁAɁA^WidgetList[] ݒ肵Ă
	tv = ::GK.TreeView();
	tv.hWnd = #NULL;
	tv.owner := this;
	^WidgetList[ tv.id = ^WidgetId ] := tv;

	if( style'type != "integer" )
		style := #TVS_HASLINES | #TVS_LINESATROOT | #TVS_HASBUTTONS ;
					//  | #TVS_EDITLABELS | #TVS_NOTOOLTIPS
	if( ex_style'type != "integer" )
		ex_style := #WS_EX_CLIENTEDGE;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY | ex_style,
				"SysTreeView32",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | #WS_CLIPSIBLINGS | #WS_BORDER | style,
				R.Xo, R.Yo, R.Xd, R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )
	{
		delete ^WidgetList[ ^WidgetId ];
		return null;
	}

	tv.hWnd = hwnd;
	^WidgetId++;
	return tv;
}

//-----------------------------------------------------------------------------

//function ::GK.Window.AddListView( R )		--- 
//{
//}

//-----------------------------------------------------------------------------

function ::GK.Window.AddTrackBar( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer" )
		style := #TBS_HORZ | #TBS_AUTOTICKS | #TBS_TOP | #TBS_TOOLTIPS ;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"msctls_trackbar32",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	tb = ::GK.TrackBar();
	tb.hWnd = hwnd;
	tb.owner := this;

	^WidgetList[ tb.id = ^WidgetId ++ ] := tb;

	return tb;
}

//-----------------------------------------------------------------------------

function ::GK.Window.AddProgressBar( style, R )
{
	while( ^WidgetList[ ^WidgetId ]'exist? )
		^WidgetId = ++^WidgetId & 0xFFFF;

	if( style'type != "integer" )
		style := #PBS_SMOOTH ;

	hwnd = ^CreateWindowEx(
				#WS_EX_NOPARENTNOTIFY,
				"msctls_progress32",
				#NULL,
				#WS_CHILD | #WS_VISIBLE | style,
				R.Xo,
				R.Yo,
				R.Xd,
				R.Yd,
				.hWnd,
				^WidgetId,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )		return null;

	pb = ::GK.ProgressBar();
	pb.hWnd = hwnd;
	pb.owner := this;

	^WidgetList[ pb.id = ^WidgetId ++ ] := pb;

	return pb;
}

//-----------------------------------------------------------------------------

// c[`bvigbLO^̂݁j

function ::GK.Window.ShowToolTip( x, y, text, style )
{
	#pc	"ShowToolTip: ": x, y, text, style;

	if( .ToolTip )	// ɍ쐬ρH
	{
		if( x != null  &&  y != null )
			.ToolTip.Position( x, y );
		if( text != null )
			.ToolTip.SetText( text );
		.ToolTip.Activate( #TRUE );
		return #TRUE;
	}

	if( style'type != "integer" )
		style := 0;

#pv	hwnd = ^CreateWindowEx(
				#WS_EX_TOPMOST,
				"tooltips_class32",
				#NULL,
				#WS_POPUP | style,
				#CW_USEDEFAULT,
				#CW_USEDEFAULT,
				#CW_USEDEFAULT,
				#CW_USEDEFAULT,
				.hWnd,
				#NULL,
				^hInstance,
				#NULL );

	if( hwnd == #NULL )
	{
		#pc "c[`bv쐬sI", ::GK.GetSysErrMsg();
		return #FALSE;
	}

	.ToolTip = ::GK.ToolTip();
	.ToolTip.hWnd = hwnd;
	.ToolTip.owner := this;

	#set	TTF_FLAGS	(#TTF_TRACK | #TTF_IDISHWND | #TTF_ABSOLUTE)
	.ToolTip.TOOLINFO'ULONG(12) =
	{
		12*4,			// [0]  UINT		cbSize;
		#TTF_FLAGS,		// [1]  UINT		uFlags;
		.hWnd,			// [2]  HWND		hwnd;
		.hWnd,			// [3]  UINT_PTR	uId;
		,				// [4]  LONG		RECT::left;
		,				// [5]  LONG		RECT::top;
		.gc.Xd,			// [6]  LONG		RECT::right;
		.gc.Yd,			// [7]  LONG		RECT::bottom;
		^hInstance,		// [8]  HINSTANCE	hinst;
		text'addr,		// [9]  LPSTR		lpszText;
		,				// [10] LPARAM		lParam;
		,				// [11] void*		lpReserved;
	};
#pv	^SendMessage( hwnd, #TTM_ADDTOOL, 0, .ToolTip.TOOLINFO'addr );

	.ToolTip.Position( x, y );
	.ToolTip.Activate( #TRUE );
	return #TRUE;
}


function ::GK.Window.HideToolTip()
{
	#pc	"HideToolTip";
	if( .ToolTip )
		.ToolTip.Activate( #FALSE );
}

//-----------------------------------------------------------------------------

function ::GK.Window.MessageBox( msg, title, type )
{
	return ^MessageBox( .hWnd, msg, title, type );
}

//-----------------------------------------------------------------------------

// _CAO{bNX̍ڂɑ΂鑀
//	ijȉ̊֐́A::GK.Dialog Ɍ肵ȂŁA::GK.Window ɂKp

function ::GK.Window.GetDlgObj( obj, id )
{
	obj.hWnd = ^GetDlgItem( .hWnd, id );
	return obj;
}

function ::GK.Window.GetDlgItem( id )
{
	return ^GetDlgItem( .hWnd, id );
}

function ::GK.Window.GetDlgItemInt( id )
{
	return ^GetDlgItemInt( .hWnd, id, #NULL, #TRUE );
}

function ::GK.Window.GetDlgItemText( id, cn )
{
	if( cn'type != "integer" )
		cn = 256;
	T'USHORT( cn );
	^GetDlgItemText( .hWnd, id, T'addr, cn );
	return T'gets;
}

function ::GK.Window.SendDlgItemMsg( id, Msg, wParam, lParam )
{
	return ^SendDlgItemMessage( .hWnd, id, Msg, wParam, lParam );
}

function ::GK.Window.SetDlgItemInt( id, v )
{
	return ^SetDlgItemInt( .hWnd, id, v, #TRUE );
}

function ::GK.Window.SetDlgItemText( id, text )
{
	return ^SetDlgItemText( .hWnd, id, text );
}

//-----------------------------------------------------------------------------

function ::GK.Window.GetOpenFileName( OFN )
{
	return .DialogToGetFileName( OFN, ^GetOpenFileName );
}

function ::GK.Window.GetSaveFileName( OFN )
{
	return .DialogToGetFileName( OFN, ^GetSaveFileName );
}

function ::GK.Window.DialogToGetFileName( OFN, func )
{
	DefValue = 0;

	OPENFILENAME ::=
	{
		.lStructSize		'ULONG;
		.hwndOwner			'ULONG;
		.hInstance			'ULONG = ^hInstance;
		.lpstrFilter		'ULONG = OFN.Filter'addr;		// ẑ
		.lpstrCustomFilter	'ULONG = 0;
		.nMaxCustFilter		'ULONG = 0;
		.nFilterIndex		'ULONG = OFN.FilterIndex;
		.lpstrFile			'ULONG = OFN.FileSpec'addr;		// ẑ
		.nMaxFile			'ULONG = #MAX_PATH;				// vf͂ȏ̂
		.lpstrFileTitle		'ULONG = 0;
		.nMaxFileTitle		'ULONG = 0;
		.lpstrInitialDir	'ULONG = OFN.InitialDir'addr;	// ̂
		.lpstrTitle			'ULONG = OFN.Title'addr;		// ̂
		.Flags				'ULONG = OFN.Flags;
		.nFileOffset		'USHORT = 0;					//iVXeݒj
		.nFileExtension		'USHORT = 0;					//iVXeݒj
		.lpstrDefExt		'ULONG = OFN.DefExt'addr;		// ̂
		.lCustData			'ULONG = 0;
		.lpfnHook			'ULONG = 0;
		.lpTemplateName		'ULONG = 0;
	}
	OPENFILENAME.lStructSize = OPENFILENAME'size;
	OPENFILENAME.hwndOwner = .hWnd;

	ofn = ::Buffer( OPENFILENAME.lStructSize );
	ofn.Write( OPENFILENAME );
	ofn.Seek(0);

	if( func( ofn ) == 0 )
		return #FALSE;

	ofn.Read( OPENFILENAME );
	OFN.FileOffset = OPENFILENAME.nFileOffset;
	OFN.ExtOffset  = OPENFILENAME.nFileExtension;
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::GK.Window.PrintDialog( PD )
{
	DefValue = 0;

	PRINTDLG ::=
	{
		.lStructSize		 'ULONG;
		.hwndOwner			 'ULONG;
		.hDevMode			 'ULONG  = 0;
		.hDevNames			 'ULONG  = 0;
		.hDC				 'ULONG  = 0;
		.Flags				 'ULONG  = PD.Flags;
		.nFromPage			 'USHORT = PD.nFromPage;
		.nToPage			 'USHORT = PD.nToPage;
		.nMinPage			 'USHORT = PD.nMinPage;
		.nMaxPage			 'USHORT = PD.nMaxPage;
		.nCopies			 'USHORT = PD.nCopies;
		.hInstance			 'ULONG  = 0;
		.lCustData			 'ULONG  = 0;
		.lpfnPrintHook		 'ULONG  = 0;
		.lpfnSetupHook		 'ULONG  = 0;
		.lpPrintTemplateName 'ULONG  = 0;
		.lpSetupTemplateName 'ULONG  = 0;
		.hPrintTemplate		 'ULONG  = 0;
		.hSetupTemplate		 'ULONG  = 0;
	}
	PRINTDLG.lStructSize = PRINTDLG'size;
	PRINTDLG.hwndOwner = .hWnd;

	DEVMODE ::=
	{
		.dmDeviceName		'T(32)  = PD.DevMode.dmDeviceName;
		.dmSpecVersion		'USHORT = PD.DevMode.dmSpecVersion;
		.dmDriverVersion	'USHORT = PD.DevMode.dmDriverVersion;
		.dmSize				'USHORT;
		.dmDriverExtra		'USHORT = PD.DevMode.dmDriverExtra;
		.dmFields			'ULONG  = PD.DevMode.dmFields;
		.dmOrientation		'SHORT  = PD.DevMode.dmOrientation;
		.dmPaperSize		'SHORT  = PD.DevMode.dmPaperSize;
		.dmPaperLength		'SHORT  = PD.DevMode.dmPaperLength;
		.dmPaperWidth		'SHORT  = PD.DevMode.dmPaperWidth;
		.dmScale			'SHORT  = 0;
		.dmCopies			'SHORT  = 0;
		.dmDefaultSource	'SHORT  = 0;
		.dmPrintQuality		'SHORT  = 0;
		.dmColor			'SHORT  = 0;
		.dmDuplex			'SHORT  = 0;
		.dmYResolution		'SHORT  = 0;
		.dmTTOption			'SHORT  = 0;
		.dmCollate			'SHORT  = 0;
		.dmFormName			'T(32)  = "";
		.dmLogPixels		'USHORT = 0;
		.dmBitsPerPel		'ULONG  = 0;
		.dmPelsWidth		'ULONG  = 0;
		.dmPelsHeight		'ULONG  = 0;
		.dmDisplayFlags		'ULONG  = 0;
		.dmDisplayFrequency	'ULONG  = 0;
		.dmICMMethod		'ULONG  = 0;;
		.dmICMIntent		'ULONG  = 0;;
		.dmMediaType		'ULONG  = 0;;
		.dmDitherType		'ULONG  = 0;;
		.dmReserved1		'ULONG  = 0;;
		.dmReserved2		'ULONG  = 0;;
	}
	DEVMODE.dmSize = DEVMODE'size;
	#pc	PD.DevMode.dmSize, DEVMODE.dmSize;

	if( PD.DevMode'exist? )
	{
		bn = DEVMODE.dmSize + DEVMODE.dmDriverExtra;
		dm = ::Buffer( bn );
		dm.Write( DEVMODE );
		if( PD.ExtData'exist? )
			dm.Write( PD.ExtData );
		dm.Seek(0);
		h = ^GlobalAlloc( #GMEM_MOVEABLE, bn );
		^GlobalLock( h )'memcpy( dm'addr, bn );
		^GlobalUnlock( h );
		PRINTDLG.hDevMode = h;
		delete dm;
	}

	if( PD.DevNames'exist? )
	{
		h = ^GlobalAlloc( #GMEM_MOVEABLE, PD.DevNames'size );
		^GlobalLock( h )'memcpy( PD.DevNames'addr, PD.DevNames'size );
		^GlobalUnlock( h );
	}

	pd = ::Buffer( PRINTDLG.lStructSize );
	pd.Write( PRINTDLG );
	pd.Seek(0);

	if( ^PrintDlg( pd ) == 0 )
		return #FALSE;

	pd.Read( PRINTDLG );
	PD.hDC		 = PRINTDLG.hDC;
	PD.Flags	 = PRINTDLG.Flags;
	PD.nFromPage = PRINTDLG.nFromPage;
	PD.nToPage	 = PRINTDLG.nToPage;
	PD.nMinPage	 = PRINTDLG.nMinPage;
	PD.nMaxPage	 = PRINTDLG.nMaxPage;
	PD.nCopies	 = PRINTDLG.nCopies;

	delete PD.DevMode;
	if( PRINTDLG.hDevMode != #NULL )
	{
		if(( bp = ^GlobalLock( PRINTDLG.hDevMode )) != #NULL  &&
		   ( bn = ^GlobalSize( PRINTDLG.hDevMode )) > 0 )
		{
			dm = ::Buffer( bn, bp );
			dm.Read( DEVMODE );
			#pc	DEVMODE.dmDeviceName, DEVMODE.dmDriverExtra, DEVMODE.dmFields'b(8), DEVMODE.dmPaperSize, DEVMODE.dmOrientation;
			PD.DevMode <- DEVMODE;
			
			if( PD.dmDriverExtra > 0 )
			{
				PD.ExtData'UBYTE( PD.dmDriverExtra );
				dm.Read( PD.ExtData );
			}
			delete dm;
		}
		^GlobalFree( PRINTDLG.hDevMode );
	}

	delete PD.DevNames;
	if( PRINTDLG.hDevNames != #NULL )
	{
		#pc	"hDevNames = 0x" : PRINTDLG.hDevNames'x;
		if(( bp = ^GlobalLock( PRINTDLG.hDevNames )) != #NULL  &&
		   ( bn = ^GlobalSize( PRINTDLG.hDevNames )) > 0 )
		{
			PD.DevNames'USHORT( bn / 2 );
			PD.DevNames'addr'memcpy( bp, bn & ~01 );
		}
		^GlobalFree( PRINTDLG.hDevNames );
	}

	return #TRUE;
}

//=============================================================================

function ::GK.GetSysErrMsg( err_id )
{
	if( err_id == null )
		err_id = ^GetLastError();

	ErrMsg'USHORT( 256 );

	if( ^FormatMessage(
			#FORMAT_MESSAGE_FROM_SYSTEM | #FORMAT_MESSAGE_IGNORE_INSERTS,
			#NULL,
			err_id,
			0,
			ErrMsg'addr,
			ErrMsg'count,
			#NULL ) )
		return ErrMsg'gets'trim;
	else
		return "System Error: 0x" + err_id'x(4);
}

//=============================================================================

