/*
===============================================================================
  MkLibrary.s :  }`fBAELbgECu[
===============================================================================

	Copyright (C) 2011-2012  Masahiko Watanabe
	Revision Id.:  Rev.2012.12.12

    Edition History:
      2011.08.15  GK Library ̔g`I[fBIo͊֘A{CuɈړ
      2011.08.15  g`I[fBI͕ǉ
      2011.09.17  rfI֘Aǉ
      2012.12.12  jR[hpɕύX

-----------------------------------------------------------------------------*/

/*****/  // fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  px	#comment
/*****/

/*****  // fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  px	print
/*****/

#set  p		print

#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <MkLib\MkAudio.mh>

//-----------------------------------------------------------------------------

function	^ModuleInit()
{
	if( ^IsMkLibInit'exist? )
		return;

	#pc	"MK Library: Initialization Start!";

	^DefValue = null;	// ӁF ^DefValue ̒l͕ύXsI

	#pv	^WINMM = ::DLL.Link( "WINMM", "sys" );

//	#pv	^waveOutBreakLoop = ^WINMM.GetEntry( "waveOutBreakLoop" );
	#pv	^waveOutClose = ^WINMM.GetEntry( "waveOutClose" );
	#pv	^waveOutGetDevCaps = ^WINMM.GetEntry( "waveOutGetDevCapsW" );
	#pv	^waveOutGetErrorText = ^WINMM.GetEntry( "waveOutGetErrorTextW" );
	#pv	^waveOutGetID = ^WINMM.GetEntry( "waveOutGetID" );
	#pv	^waveOutGetNumDevs = ^WINMM.GetEntry( "waveOutGetNumDevs" );
	#pv	^waveOutGetPitch = ^WINMM.GetEntry( "waveOutGetPitch" );
	#pv	^waveOutGetPlaybackRate = ^WINMM.GetEntry( "waveOutGetPlaybackRate" );
	#pv	^waveOutGetPosition = ^WINMM.GetEntry( "waveOutGetPosition" );
	#pv	^waveOutGetVolume = ^WINMM.GetEntry( "waveOutGetVolume" );
//	#pv	^waveOutMessage = ^WINMM.GetEntry( "waveOutMessage" );
	#pv	^waveOutOpen = ^WINMM.GetEntry( "waveOutOpen" );
	#pv	^waveOutPause = ^WINMM.GetEntry( "waveOutPause" );
	#pv	^waveOutPrepareHeader = ^WINMM.GetEntry( "waveOutPrepareHeader" );
	#pv	^waveOutReset = ^WINMM.GetEntry( "waveOutReset" );
	#pv	^waveOutRestart = ^WINMM.GetEntry( "waveOutRestart" );
	#pv	^waveOutSetPitch = ^WINMM.GetEntry( "waveOutSetPitch" );
	#pv	^waveOutSetPlaybackRate = ^WINMM.GetEntry( "waveOutSetPlaybackRate" );
	#pv	^waveOutSetVolume = ^WINMM.GetEntry( "waveOutSetVolume" );
	#pv	^waveOutUnprepareHeader = ^WINMM.GetEntry( "waveOutUnprepareHeader" );
	#pv	^waveOutWrite = ^WINMM.GetEntry( "waveOutWrite" );

	#pv	^waveInAddBuffer = ^WINMM.GetEntry( "waveInAddBuffer" );
	#pv	^waveInClose = ^WINMM.GetEntry( "waveInClose" );
	#pv	^waveInGetDevCaps = ^WINMM.GetEntry( "waveInGetDevCapsW" );
	#pv	^waveInGetErrorText = ^WINMM.GetEntry( "waveInGetErrorTextW" );
	#pv	^waveInGetID = ^WINMM.GetEntry( "waveInGetID" );
	#pv	^waveInGetNumDevs = ^WINMM.GetEntry( "waveInGetNumDevs" );
	#pv	^waveInGetPosition = ^WINMM.GetEntry( "waveInGetPosition" );
	#pv	^waveInMessage = ^WINMM.GetEntry( "waveInMessage" );
	#pv	^waveInOpen = ^WINMM.GetEntry( "waveInOpen" );
	#pv	^waveInPrepareHeader = ^WINMM.GetEntry( "waveInPrepareHeader" );
	#pv	^waveInReset = ^WINMM.GetEntry( "waveInReset" );
	#pv	^waveInStart = ^WINMM.GetEntry( "waveInStart" );
	#pv	^waveInStop = ^WINMM.GetEntry( "waveInStop" );
	#pv	^waveInUnprepareHeader = ^WINMM.GetEntry( "waveInUnprepareHeader" );

	#pv	^PlaySound = ^WINMM.GetEntry( "PlaySound" );

	class ::MK.WaveOut	{}
	class ::MK.WaveIn	{}


	#pv	^AVICAP32 = ::DLL.Link( "AVICAP32", "sys" );

	#pv	^capCreateCaptureWindow = ^AVICAP32.GetEntry( "capCreateCaptureWindowW" );
	#pv	^capGetDriverDescription = ^AVICAP32.GetEntry( "capGetDriverDescriptionW" );

	class ::MK.Cap : ::GK.WindowBase	{}


	#pv	^AVIFIL32 = ::DLL.Link( "AVIFIL32", "sys" );

	#pv	^AVIBuildFilter = ^AVIFIL32.GetEntry( "AVIBuildFilterW" );
	#pv	^AVIClearClipboard = ^AVIFIL32.GetEntry( "AVIClearClipboard" );
	#pv	^AVIFileAddRef = ^AVIFIL32.GetEntry( "AVIFileAddRef" );
	#pv	^AVIFileCreateStream = ^AVIFIL32.GetEntry( "AVIFileCreateStreamW" );
	#pv	^AVIFileEndRecord = ^AVIFIL32.GetEntry( "AVIFileEndRecord" );
	#pv	^AVIFileExit = ^AVIFIL32.GetEntry( "AVIFileExit" );
	#pv	^AVIFileGetStream = ^AVIFIL32.GetEntry( "AVIFileGetStream" );
	#pv	^AVIFileInfo = ^AVIFIL32.GetEntry( "AVIFileInfoW" );
	#pv	^AVIFileInit = ^AVIFIL32.GetEntry( "AVIFileInit" );
	#pv	^AVIFileOpen = ^AVIFIL32.GetEntry( "AVIFileOpenW" );
	#pv	^AVIFileReadData = ^AVIFIL32.GetEntry( "AVIFileReadData" );
	#pv	^AVIFileRelease = ^AVIFIL32.GetEntry( "AVIFileRelease" );
	#pv	^AVIFileWriteData = ^AVIFIL32.GetEntry( "AVIFileWriteData" );
	#pv	^AVIGetFromClipboard = ^AVIFIL32.GetEntry( "AVIGetFromClipboard" );
	#pv	^AVIMakeCompressedStream = ^AVIFIL32.GetEntry( "AVIMakeCompressedStream" );
	#pv	^AVIMakeFileFromStreams = ^AVIFIL32.GetEntry( "AVIMakeFileFromStreams" );
	#pv	^AVIMakeStreamFromClipboard = ^AVIFIL32.GetEntry( "AVIMakeStreamFromClipboard" );
	#pv	^AVIPutFileOnClipboard = ^AVIFIL32.GetEntry( "AVIPutFileOnClipboard" );
	#pv	^AVISave = ^AVIFIL32.GetEntry( "AVISaveW" );
	#pv	^AVISaveOptions = ^AVIFIL32.GetEntry( "AVISaveOptions" );
	#pv	^AVISaveOptionsFree = ^AVIFIL32.GetEntry( "AVISaveOptionsFree" );
	#pv	^AVISaveV = ^AVIFIL32.GetEntry( "AVISaveVW" );
	#pv	^AVIStreamAddRef = ^AVIFIL32.GetEntry( "AVIStreamAddRef" );
	#pv	^AVIStreamBeginStreaming = ^AVIFIL32.GetEntry( "AVIStreamBeginStreaming" );
	#pv	^AVIStreamCreate = ^AVIFIL32.GetEntry( "AVIStreamCreate" );
	#pv	^AVIStreamEndStreaming = ^AVIFIL32.GetEntry( "AVIStreamEndStreaming" );
	#pv	^AVIStreamFindSample = ^AVIFIL32.GetEntry( "AVIStreamFindSample" );
	#pv	^AVIStreamGetFrame = ^AVIFIL32.GetEntry( "AVIStreamGetFrame" );
	#pv	^AVIStreamGetFrameClose = ^AVIFIL32.GetEntry( "AVIStreamGetFrameClose" );
	#pv	^AVIStreamGetFrameOpen = ^AVIFIL32.GetEntry( "AVIStreamGetFrameOpen" );
	#pv	^AVIStreamInfo = ^AVIFIL32.GetEntry( "AVIStreamInfoW" );
	#pv	^AVIStreamLength = ^AVIFIL32.GetEntry( "AVIStreamLength" );
	#pv	^AVIStreamOpenFromFile = ^AVIFIL32.GetEntry( "AVIStreamOpenFromFileW" );
	#pv	^AVIStreamRead = ^AVIFIL32.GetEntry( "AVIStreamRead" );
	#pv	^AVIStreamReadData = ^AVIFIL32.GetEntry( "AVIStreamReadData" );
	#pv	^AVIStreamReadFormat = ^AVIFIL32.GetEntry( "AVIStreamReadFormat" );
	#pv	^AVIStreamRelease = ^AVIFIL32.GetEntry( "AVIStreamRelease" );
	#pv	^AVIStreamSampleToTime = ^AVIFIL32.GetEntry( "AVIStreamSampleToTime" );
	#pv	^AVIStreamSetFormat = ^AVIFIL32.GetEntry( "AVIStreamSetFormat" );
	#pv	^AVIStreamStart = ^AVIFIL32.GetEntry( "AVIStreamStart" );
	#pv	^AVIStreamTimeToSample = ^AVIFIL32.GetEntry( "AVIStreamTimeToSample" );
	#pv	^AVIStreamWrite = ^AVIFIL32.GetEntry( "AVIStreamWrite" );
	#pv	^AVIStreamWriteData = ^AVIFIL32.GetEntry( "AVIStreamWriteData" );
	#pv	^CreateEditableStream = ^AVIFIL32.GetEntry( "CreateEditableStream" );
	#pv	^EditStreamClone = ^AVIFIL32.GetEntry( "EditStreamClone" );
	#pv	^EditStreamCopy = ^AVIFIL32.GetEntry( "EditStreamCopy" );
	#pv	^EditStreamCut = ^AVIFIL32.GetEntry( "EditStreamCut" );
	#pv	^EditStreamPaste = ^AVIFIL32.GetEntry( "EditStreamPaste" );
	#pv	^EditStreamSetInfo = ^AVIFIL32.GetEntry( "EditStreamSetInfoW" );
	#pv	^EditStreamSetName = ^AVIFIL32.GetEntry( "EditStreamSetNameW" );

	//class ::MK.AVI		{}


	#pv	^MSVFW32 = ::DLL.Link( "MSVFW32", "sys" );

	#pv	^ICClose = ^MSVFW32.GetEntry( "ICClose" );
	#pv	^ICCompress = ^MSVFW32.GetEntry( "ICCompress" );
	#pv	^ICCompressorChoose = ^MSVFW32.GetEntry( "ICCompressorChoose" );
	#pv	^ICCompressorFree = ^MSVFW32.GetEntry( "ICCompressorFree" );
	#pv	^ICDecompress = ^MSVFW32.GetEntry( "ICDecompress" );
	#pv	^ICDraw = ^MSVFW32.GetEntry( "ICDraw" );
	#pv	^ICDrawBegin = ^MSVFW32.GetEntry( "ICDrawBegin" );
	#pv	^ICGetDisplayFormat = ^MSVFW32.GetEntry( "ICGetDisplayFormat" );
	#pv	^ICGetInfo = ^MSVFW32.GetEntry( "ICGetInfo" );
	#pv	^ICImageCompress = ^MSVFW32.GetEntry( "ICImageCompress" );
	#pv	^ICImageDecompress = ^MSVFW32.GetEntry( "ICImageDecompress" );
	#pv	^ICInfo = ^MSVFW32.GetEntry( "ICInfo" );
	#pv	^ICInstall = ^MSVFW32.GetEntry( "ICInstall" );
	#pv	^ICLocate = ^MSVFW32.GetEntry( "ICLocate" );
	#pv	^ICOpen = ^MSVFW32.GetEntry( "ICOpen" );
	#pv	^ICOpenFunction = ^MSVFW32.GetEntry( "ICOpenFunction" );
	#pv	^ICRemove = ^MSVFW32.GetEntry( "ICRemove" );
	#pv	^ICSendMessage = ^MSVFW32.GetEntry( "ICSendMessage" );
	#pv	^ICSeqCompressFrame = ^MSVFW32.GetEntry( "ICSeqCompressFrame" );
	#pv	^ICSeqCompressFrameEnd = ^MSVFW32.GetEntry( "ICSeqCompressFrameEnd" );
	#pv	^ICSeqCompressFrameStart = ^MSVFW32.GetEntry( "ICSeqCompressFrameStart" );

	//class ::MK.IC		{}


	#pv	^MSACM32 = ::DLL.Link( "MSACM32", "sys" );

	#pv	^acmDriverAdd = ^MSACM32.GetEntry( "acmDriverAddW" );
	#pv	^acmDriverClose = ^MSACM32.GetEntry( "acmDriverClose" );
	#pv	^acmDriverDetails = ^MSACM32.GetEntry( "acmDriverDetailsW" );
	#pv	^acmDriverEnum = ^MSACM32.GetEntry( "acmDriverEnum" );
	#pv	^acmDriverID = ^MSACM32.GetEntry( "acmDriverID" );
	#pv	^acmDriverMessage = ^MSACM32.GetEntry( "acmDriverMessage" );
	#pv	^acmDriverOpen = ^MSACM32.GetEntry( "acmDriverOpen" );
	#pv	^acmDriverPriority = ^MSACM32.GetEntry( "acmDriverPriority" );
	#pv	^acmDriverRemove = ^MSACM32.GetEntry( "acmDriverRemove" );
	#pv	^acmFilterChoose = ^MSACM32.GetEntry( "acmFilterChooseW" );
	#pv	^acmFilterDetails = ^MSACM32.GetEntry( "acmFilterDetailsW" );
	#pv	^acmFilterEnum = ^MSACM32.GetEntry( "acmFilterEnumW" );
	#pv	^acmFilterTagDetails = ^MSACM32.GetEntry( "acmFilterTagDetailsW" );
	#pv	^acmFilterTagEnum = ^MSACM32.GetEntry( "acmFilterTagEnumW" );
	#pv	^acmFormatChoose = ^MSACM32.GetEntry( "acmFormatChooseW" );
	#pv	^acmFormatDetails = ^MSACM32.GetEntry( "acmFormatDetailsW" );
	#pv	^acmFormatEnum = ^MSACM32.GetEntry( "acmFormatEnumW" );
	#pv	^acmFormatSuggest = ^MSACM32.GetEntry( "acmFormatSuggest" );
	#pv	^acmFormatTagDetails = ^MSACM32.GetEntry( "acmFormatTagDetailsW" );
	#pv	^acmFormatTagEnum = ^MSACM32.GetEntry( "acmFormatTagEnumW" );
	#pv	^acmGetVersion = ^MSACM32.GetEntry( "acmGetVersion" );
	#pv	^acmMetrics = ^MSACM32.GetEntry( "acmMetrics" );
	#pv	^acmStreamClose = ^MSACM32.GetEntry( "acmStreamClose" );
	#pv	^acmStreamConvert = ^MSACM32.GetEntry( "acmStreamConvert" );
	#pv	^acmStreamMessage = ^MSACM32.GetEntry( "acmStreamMessage" );
	#pv	^acmStreamOpen = ^MSACM32.GetEntry( "acmStreamOpen" );
	#pv	^acmStreamPrepareHeader = ^MSACM32.GetEntry( "acmStreamPrepareHeader" );
	#pv	^acmStreamReset = ^MSACM32.GetEntry( "acmStreamReset" );
	#pv	^acmStreamSize = ^MSACM32.GetEntry( "acmStreamSize" );
	#pv	^acmStreamUnprepareHeader = ^MSACM32.GetEntry( "acmStreamUnprepareHeader" );

	::MK'AddScope( ^ModuleInit'up );

	^IsMkLibInit = #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function	^ModuleTerm()
{
	if( ! ^IsMkLibInit'exist? )
		return;

	delete	^WINMM, ^AVICAP32, ^MSVFW32, ^AVIFIL32, ^MSACM32;
	delete	::MK;
	delete	^IsMkLibInit;

	#pc	"MK Library: Termination End!";
}

//-----------------------------------------------------------------------------

#include <MkLib\MkAudio.mc>		// Waveform Audio ֘A
#include <MkLib\MkVideo.mc>		// Video for Windows ֘A


