/*
===============================================================================
  MkVideo.s :  }`fBAELbgECu[ rfI֘A֐
===============================================================================

	Copyright (C) 2011  Masahiko Watanabe
	Revision Id.:  Rev.2011.10.17

    Edition History:
      2011.09.05  

-----------------------------------------------------------------------------*/


function ::MK.GetCapDriverDesc( index )
{
	Name'USHORT( 256 );
	Ver 'USHORT( 128 );

	if( ^capGetDriverDescription( index, Name'addr, Name'size, Ver'addr, Ver'size ) )
		return ( Name'gets, Ver'gets );
	else
		return null;
}

//-----------------------------------------------------------------------------

// Lv`֘AEBhEbZ[Wi  ́AUNICODE ł j

#set	WM_CAP_START					#WM_USER

#set	WM_CAP_GET_CAPSTREAMPTR			(#WM_CAP_START+ 1)
#set	WM_CAP_SET_CALLBACK_ERROR		(#WM_CAP_START+ 2)		// 
#set	WM_CAP_SET_CALLBACK_STATUS		(#WM_CAP_START+ 3)		// 
#set	WM_CAP_SET_CALLBACK_YIELD		(#WM_CAP_START+ 4)
#set	WM_CAP_SET_CALLBACK_FRAME		(#WM_CAP_START+ 5)
#set	WM_CAP_SET_CALLBACK_VIDEOSTREAM (#WM_CAP_START+ 6)
#set	WM_CAP_SET_CALLBACK_WAVESTREAM	(#WM_CAP_START+ 7)
#set	WM_CAP_GET_USER_DATA			(#WM_CAP_START+ 8)
#set	WM_CAP_SET_USER_DATA			(#WM_CAP_START+ 9)
#set	WM_CAP_DRIVER_CONNECT			(#WM_CAP_START+10)
#set	WM_CAP_DRIVER_DISCONNECT		(#WM_CAP_START+11)
#set	WM_CAP_DRIVER_GET_NAME			(#WM_CAP_START+12)		// 
#set	WM_CAP_DRIVER_GET_VERSION		(#WM_CAP_START+13)		// 
#set	WM_CAP_DRIVER_GET_CAPS			(#WM_CAP_START+14)

#set	WM_CAP_FILE_SET_CAPTURE_FILE	(#WM_CAP_START+20)		// 
#set	WM_CAP_FILE_GET_CAPTURE_FILE	(#WM_CAP_START+21)		// 
#set	WM_CAP_FILE_SAVEAS				(#WM_CAP_START+23)		// 
#set	WM_CAP_FILE_SAVEDIB				(#WM_CAP_START+25)		// 

#set	WM_CAP_FILE_ALLOCATE			(#WM_CAP_START+22)
#set	WM_CAP_FILE_SET_INFOCHUNK		(#WM_CAP_START+24)

#set	WM_CAP_EDIT_COPY				(#WM_CAP_START+30)

#set	WM_CAP_SET_AUDIOFORMAT			(#WM_CAP_START+35)
#set	WM_CAP_GET_AUDIOFORMAT			(#WM_CAP_START+36)

#set	WM_CAP_DLG_VIDEOFORMAT			(#WM_CAP_START+41)
#set	WM_CAP_DLG_VIDEOSOURCE			(#WM_CAP_START+42)
#set	WM_CAP_DLG_VIDEODISPLAY			(#WM_CAP_START+43)
#set	WM_CAP_GET_VIDEOFORMAT			(#WM_CAP_START+44)
#set	WM_CAP_SET_VIDEOFORMAT			(#WM_CAP_START+45)
#set	WM_CAP_DLG_VIDEOCOMPRESSION		(#WM_CAP_START+46)

#set	WM_CAP_SET_PREVIEW				(#WM_CAP_START+50)
#set	WM_CAP_SET_OVERLAY				(#WM_CAP_START+51)
#set	WM_CAP_SET_PREVIEWRATE			(#WM_CAP_START+52)
#set	WM_CAP_SET_SCALE				(#WM_CAP_START+53)
#set	WM_CAP_GET_STATUS				(#WM_CAP_START+54)
#set	WM_CAP_SET_SCROLL				(#WM_CAP_START+55)

#set	WM_CAP_GRAB_FRAME				(#WM_CAP_START+60)
#set	WM_CAP_GRAB_FRAME_NOSTOP		(#WM_CAP_START+61)

#set	WM_CAP_SEQUENCE					(#WM_CAP_START+62)
#set	WM_CAP_SEQUENCE_NOFILE			(#WM_CAP_START+63)
#set	WM_CAP_SET_SEQUENCE_SETUP		(#WM_CAP_START+64)
#set	WM_CAP_GET_SEQUENCE_SETUP		(#WM_CAP_START+65)

#set	WM_CAP_SET_MCI_DEVICE			(#WM_CAP_START+66)		// 
#set	WM_CAP_GET_MCI_DEVICE			(#WM_CAP_START+67)		// 

#set	WM_CAP_STOP						(#WM_CAP_START+68)
#set	WM_CAP_ABORT					(#WM_CAP_START+69)

#set	WM_CAP_SINGLE_FRAME_OPEN		(#WM_CAP_START+70)
#set	WM_CAP_SINGLE_FRAME_CLOSE		(#WM_CAP_START+71)
#set	WM_CAP_SINGLE_FRAME				(#WM_CAP_START+72)

#set	WM_CAP_PAL_OPEN					(#WM_CAP_START+80)		// 
#set	WM_CAP_PAL_SAVE					(#WM_CAP_START+81)		// 

#set	WM_CAP_PAL_PASTE				(#WM_CAP_START+82)
#set	WM_CAP_PAL_AUTOCREATE			(#WM_CAP_START+83)
#set	WM_CAP_PAL_MANUALCREATE			(#WM_CAP_START+84)

#set	WM_CAP_SET_CALLBACK_CAPCONTROL	(#WM_CAP_START+85)

//-----------------------------------------------------------------------------

// fjEBhE̎w`̈ɃLv`EBhEǉ
//	E{Cuł́ALv`EBhE͎qɂȂ݂̂̂
//	Eq̔j́Ae̔jɎIɍsȂ̂ŁA
//		::MK.Cap NXɂ̓fXgN^݂Ȃ

function ::GK.Window.AddCaptureWindow( R, style )
{
	if( style'type == "integer" )
		style |= #WS_CHILD;
	else
		style = #WS_CHILD | #WS_VISIBLE;
	name = "";
	id = 0;

	hwnd = ^capCreateCaptureWindow(
				 name, style, R.Xo, R.Yo, R.Xd, R.Yd, .hWnd, id );

	if( hwnd == #NULL )
		return null;

	cap = ::MK.Cap();
	cap.hWnd = hwnd;
	cap.owner := this;

	return cap;
}

//-----------------------------------------------------------------------------

function ::MK.Cap.Destroy()
{
	//::GK.PostMessage( .hWnd, #WM_CLOSE, 0, 0 );
	//::GK.SendMessage( .hWnd, #WM_CLOSE, 0, 0 );
	::GK.DestroyWindow( .hWnd );
	#pc	"MK.Cap.Destroy: ": .hWnd;
	.hWnd = #NULL;
}

function ::MK.Cap.DriverConnect( i )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_DRIVER_CONNECT, i, 0 );  }
function ::MK.Cap.DriverDisconnect()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_DRIVER_DISCONNECT, 0, 0 );  }

function ::MK.Cap.DriverGetName()
{
	Name'USHORT( #MAX_PATH );	// hCo[́AhCo[̃tpXԂ
	if( ::GK.SendMessage( .hWnd, #WM_CAP_DRIVER_GET_NAME, #MAX_PATH, Name'addr ) )
		return Name'gets;
	else
		return null;
}

function ::MK.Cap.DriverGetVersion()
{
	Vers'USHORT( 64 );
	if( ::GK.SendMessage( .hWnd, #WM_CAP_DRIVER_GET_VERSION, 64, Vers'addr ) )
		return Vers'gets;
	else
		return null;
}

function ::MK.Cap.DriverGetCaps()
{
	CAPDRIVERCAPS ::=
	{
		.wDeviceIndex			'ULONG;		// Driver index in system.ini
		.fHasOverlay			'LONG;		// Can device overlay?
		.fHasDlgVideoSource		'LONG;		// Has Video source dialog box?
		.fHasDlgVideoFormat		'LONG;		// Has Format dialog box?
		.fHasDlgVideoDisplay	'LONG;		// Has External out dialog box?
		.fCaptureInitialized	'LONG;		// Driver ready to capture?
		.fDriverSuppliesPalettes'LONG;		// Can driver make palettes?
		.hVideoIn				'ULONG;		// Driver In channel	 ( = NULL )
		.hVideoOut				'ULONG;		// Driver Out channel	 ( = NULL )
		.hVideoExtIn			'ULONG;		// Driver Ext In channel ( = NULL )
		.hVideoExtOut			'ULONG;		// Driver Ext Out channel( = NULL )
	}
	sz = CAPDRIVERCAPS'size;
	capdrivercaps = ::Buffer( sz );
	capdrivercaps.Keep( sz );
	if( ! ::GK.SendMessage( .hWnd, #WM_CAP_DRIVER_GET_CAPS, sz, capdrivercaps ) )
		return null;
	capdrivercaps.Read( CAPDRIVERCAPS );
	return CAPDRIVERCAPS;
}

//-----------------------------------------------------------------------------

function ::MK.Cap.Preview( b )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_PREVIEW, b, 0 );  }
function ::MK.Cap.PreviewRate( msec )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_PREVIEWRATE, msec, 0 );  }
function ::MK.Cap.PreviewScale( b )		{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_SCALE, b, 0 );  }
function ::MK.Cap.Overlay( b )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_OVERLAY, b, 0 );  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::MK.Cap.SetScrollPos( x, y )
{
	P'LONG(2) = { x, y };
	return ::GK.SendMessage( .hWnd, #WM_CAP_SET_SCROLL, 0, P'addr );
}

//-----------------------------------------------------------------------------

function ::MK.Cap.GetStatus()
{
	CAPSTATUS ::=
	{
		.uiImageWidth				'ULONG;		// Width of the image
		.uiImageHeight				'ULONG;		// Height of the image
		.fLiveWindow				'LONG;		// Now Previewing video?
		.fOverlayWindow				'LONG;		// Now Overlaying video?
		.fScale						'LONG;		// Scale image to client?
		.ptScroll_X					'LONG;		// Scroll position x
		.ptScroll_Y					'LONG;		// Scroll position y
		.fUsingDefaultPalette		'LONG;		// Using default driver palette?
		.fAudioHardware				'LONG;		// Audio hardware present?
		.fCapFileExists				'LONG;		// Does capture file exist?
		.dwCurrentVideoFrame		'ULONG;		// # of video frames cap'td
		.dwCurrentVideoFramesDropped'ULONG;		// # of video frames dropped
		.dwCurrentWaveSamples		'ULONG;		// # of wave samples cap'td
		.dwCurrentTimeElapsedMS		'ULONG;		// Elapsed capture duration
		.hPalCurrent				'ULONG;		// Current palette in use
		.fCapturingNow				'LONG;		// Capture in progress?
		.dwReturn					'ULONG;		// Error value after any operation
		.wNumVideoAllocated			'ULONG;		// Actual number of video buffers
		.wNumAudioAllocated			'ULONG;		// Actual number of audio buffers
	}
	sz = CAPSTATUS'size;
	capstatus = ::Buffer( sz );
	capstatus.Keep( sz );
	if( ! ::GK.SendMessage( .hWnd, #WM_CAP_GET_STATUS, sz, capstatus ) )
		return null;
	capstatus.Read( CAPSTATUS );
	return CAPSTATUS;
}

//-----------------------------------------------------------------------------

//function ::MK.Cap.GetVideoFormatSize()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_GET_VIDEOFORMAT, 0, 0 );  }

function ::MK.Cap.GetVideoFormat()
{
	sz = ::GK.SendMessage( .hWnd, #WM_CAP_GET_VIDEOFORMAT, 0, 0 );
	if( sz <= 0 )		// TCY 0 ȂAhCo[ڑ
		return null;
	bitmapinfo = ::Buffer( sz );
	bitmapinfo.Keep( sz );
	if( ::GK.SendMessage( .hWnd, #WM_CAP_GET_VIDEOFORMAT, sz, bitmapinfo ) != sz )
		return null;
	return bitmapinfo;
}

function ::MK.Cap.SetVideoFormat( s )
{
	return ::GK.SendMessage( .hWnd, #WM_CAP_SET_VIDEOFORMAT, s.Size(), s );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

//function ::MK.Cap.GetAudioFormatSize()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_GET_AUDIOFORMAT, 0, 0 );  }

function ::MK.Cap.GetAudioFormat()
{
	sz = ::GK.SendMessage( .hWnd, #WM_CAP_GET_AUDIOFORMAT, 0, 0 );
	if( sz <= 0 )		// TCY 0 ȂAhCo[ڑ
		return null;
	waveformatex = ::Buffer( sz );
	waveformatex.Keep( sz );
	if( ::GK.SendMessage( .hWnd, #WM_CAP_GET_AUDIOFORMAT, sz, waveformatex ) != sz )
		return null;
	return waveformatex;
}

function ::MK.Cap.SetAudioFormat( s )
{
	return ::GK.SendMessage( .hWnd, #WM_CAP_SET_AUDIOFORMAT, s.Size(), s );
}

//-----------------------------------------------------------------------------

function ::MK.Cap.DlgVideoFormat()		{	return ::GK.SendMessage( .hWnd, #WM_CAP_DLG_VIDEOFORMAT, 0, 0 );  }
function ::MK.Cap.DlgVideoSource()		{	return ::GK.SendMessage( .hWnd, #WM_CAP_DLG_VIDEOSOURCE, 0, 0 );  }
function ::MK.Cap.DlgVideoDisplay()		{	return ::GK.SendMessage( .hWnd, #WM_CAP_DLG_VIDEODISPLAY, 0, 0 );  }
function ::MK.Cap.DlgVideoCompression()	{	return ::GK.SendMessage( .hWnd, #WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0 );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.SetCallbackOnError( cbf )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_ERROR, 0, cbf );  }
function ::MK.Cap.SetCallbackOnStatus( cbf )		{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_STATUS, 0, cbf );  }
function ::MK.Cap.SetCallbackOnYield( cbf )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_YIELD, 0, cbf );  }
function ::MK.Cap.SetCallbackOnFrame( cbf )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_FRAME, 0, cbf );  }
function ::MK.Cap.SetCallbackOnVideoStream( cbf )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0, cbf );  }
function ::MK.Cap.SetCallbackOnWaveStream( cbf )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_WAVESTREAM, 0, cbf );  }
function ::MK.Cap.SetCallbackOnCapControl( cbf )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_CALLBACK_CAPCONTROL, 0, cbf );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.EditCopy()			{	return ::GK.SendMessage( .hWnd, #WM_CAP_EDIT_COPY, 0, 0 );  }
function ::MK.Cap.GrabFrame()			{	return ::GK.SendMessage( .hWnd, #WM_CAP_GRAB_FRAME, 0, 0 );  }
function ::MK.Cap.GrabFrameNoStop()		{	return ::GK.SendMessage( .hWnd, #WM_CAP_GRAB_FRAME_NOSTOP, 0, 0 );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.FileGetCaptureFile()
{
	fname'USHORT( #MAX_PATH );
	if( ::GK.SendMessage( .hWnd, #WM_CAP_FILE_GET_CAPTURE_FILE, #MAX_PATH, fname'addr ) )
		return fname'gets;
	else
		return null;
}

function ::MK.Cap.FileSetCaptureFile( fname )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_FILE_SET_CAPTURE_FILE, 0, fname );  }
function ::MK.Cap.FileAlloc( fsize )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_FILE_ALLOCATE, 0, fsize );  }
function ::MK.Cap.FileSaveAs( fname )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_FILE_SAVEAS, 0, fname );  }
function ::MK.Cap.FileSetInfoChunk( bp )		{  return ::GK.SendMessage( .hWnd, #WM_CAP_FILE_SET_INFOCHUNK, 0, bp );  }
function ::MK.Cap.FileSaveDIB( fname )			{  return ::GK.SendMessage( .hWnd, #WM_CAP_FILE_SAVEDIB, 0, fname );  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::MK.Cap.CaptureGetSetup()
{
	CAPTUREPARMS ::=
	{
		.dwRequestMicroSecPerFrame	'ULONG;		// Requested capture rate in microseconds (default 66667: 15 frames/sec.)
		.fMakeUserHitOKToCapture	'LONG;		// Show dialog box prompting the user to initiate capture
		.wPercentDropForError		'ULONG;		// Give error msg if > (10%)
		.fYield						'LONG;		// Capture via background task?
		.dwIndexSize				'ULONG;		// Max index size in frames (32K)
		.wChunkGranularity			'ULONG;		// Junk chunk granularity (2K)
		.fUsingDOSMemory			'ULONG;		// Use DOS buffers?
		.wNumVideoRequested			'ULONG;		// # video buffers, If 0, autocalc
		.fCaptureAudio				'LONG;		// Capture audio?
		.wNumAudioRequested			'ULONG;		// # audio buffers, If 0, autocalc
		.vKeyAbort					'ULONG;		// Virtual key causing abort
		.fAbortLeftMouse			'LONG;		// Abort on left mouse?
		.fAbortRightMouse			'LONG;		// Abort on right mouse?
		.fLimitEnabled				'LONG;		// Use wTimeLimit?
		.wTimeLimit					'ULONG;		// Seconds to capture
		.fMCIControl				'LONG;		// Use MCI video source?
		.fStepMCIDevice				'LONG;		// Step MCI device?
		.dwMCIStartTime				'ULONG;		// Time to start in MS
		.dwMCIStopTime				'ULONG;		// Time to stop in MS
		.fStepCaptureAt2x			'LONG;		// Perform spatial averaging 2x
		.wStepCaptureAverageFrames	'ULONG;		// Temporal average n Frames
		.dwAudioBufferSize			'ULONG;		// Size of audio bufs (0 = default)
		.fDisableWriteCache			'LONG;		// Attempt to disable write cache
		.AVStreamMaster				'ULONG;		// Which stream controls length?
	}
	sz = CAPTUREPARMS'size;
	captureparms = ::Buffer( sz );
	captureparms.Keep( sz );
	if( ! ::GK.SendMessage( .hWnd, #WM_CAP_GET_SEQUENCE_SETUP, sz, captureparms ))
		return null;
	captureparms.Read( CAPTUREPARMS );
	return CAPTUREPARMS;
}


function ::MK.Cap.CaptureSetSetup( s )
{
	sz = s'size;
	captureparms = ::Buffer( sz );
	captureparms.Write( s );
	captureparms.Seek( 0 );
	return ::GK.SendMessage( .hWnd, #WM_CAP_SET_SEQUENCE_SETUP, sz, captureparms );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::MK.Cap.CaptureSequence()			{  return ::GK.SendMessage( .hWnd, #WM_CAP_SEQUENCE, 0, 0 ); }
function ::MK.Cap.CaptureSequenceNoFile()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SEQUENCE_NOFILE, 0, 0 );  }
function ::MK.Cap.CaptureStop()				{  return ::GK.SendMessage( .hWnd, #WM_CAP_STOP, 0, 0 );  }
function ::MK.Cap.CaptureAbort()			{  return ::GK.SendMessage( .hWnd, #WM_CAP_ABORT, 0, 0 );  }

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ::MK.Cap.CaptureSingleFrameOpen()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SINGLE_FRAME_OPEN, 0, 0 );  }
function ::MK.Cap.CaptureSingleFrameClose()	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SINGLE_FRAME_CLOSE, 0, 0 );  }
function ::MK.Cap.CaptureSingleFrame()		{  return ::GK.SendMessage( .hWnd, #WM_CAP_SINGLE_FRAME, 0, 0 );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.SetUserData( lp )	{  return ::GK.SendMessage( .hWnd, #WM_CAP_SET_USER_DATA, 0, lp );  }
function ::MK.Cap.GetUserData()		{  ::GK.SendMessage( .hWnd, #WM_CAP_GET_USER_DATA, 0, 0 );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.SetMCIDeviceName( szName )		{	return ::GK.SendMessage( .hWnd, #WM_CAP_SET_MCI_DEVICE, 0, szName );  }
function ::MK.Cap.GetMCIDeviceName( szName, wSize )	{	return ::GK.SendMessage( .hWnd, #WM_CAP_GET_MCI_DEVICE, wSize, szName );  }

//-----------------------------------------------------------------------------

function ::MK.Cap.PaletteOpen( szName )				{	return ::GK.SendMessage( .hWnd, #WM_CAP_PAL_OPEN, 0, szName );  }
function ::MK.Cap.PaletteSave( szName )				{	return ::GK.SendMessage( .hWnd, #WM_CAP_PAL_SAVE, 0, szName );  }
function ::MK.Cap.PalettePaste()					{	return ::GK.SendMessage( .hWnd, #WM_CAP_PAL_PASTE,  0, 0 );}
function ::MK.Cap.PaletteAuto( iFrames, iColors )	{	return ::GK.SendMessage( .hWnd, #WM_CAP_PAL_AUTOCREATE, iFrames, iColors );  }
function ::MK.Cap.PaletteManual( fGrab, iColors )	{	return ::GK.SendMessage( .hWnd, #WM_CAP_PAL_MANUALCREATE, (fGrab), iColors );  }

//=============================================================================


