/*
===============================================================================
  CalcB60.mc :  UOid
===============================================================================

	Copyright (C) 2010-2012  Masahiko Watanabe

    Edition History:
      Ver.1.00  2010.10.28i GK Library: Rev.2009.02.03 gp j
      Ver.2.00  2012.12.13  Epsaly pɕύX

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set	p	print

//-----------------------------------------------------------------------------

#set  WndXd		240		// EBhE
#set  WndYd		250		// EBhE

#set  DspXd		200		// ͐l^vZʂ̕\g̕
#set  DspYd		30		// \g̍

#set  BtnXd		32		// {^
#set  BtnYd		32		// {^
#set  BtnXs		8		// {^̍Ě
#set  BtnYs		8		// {^̏㉺̌


#set  MaxIn		12		// ő͎i擪}CiX͏j
#set  MaxFn		10		// _ȉ̍őL

// w߃R[h
#set	CMD_END		0x100
#set	CMD_SIGN	0x101
#set	CMD_CLEAR	0x102
#set	CMD_ALLCLR	0x103
#set	CMD_BACK	0x104

//-----------------------------------------------------------------------------

function  ^Main( argc, argv )
{
	#pc	"Jn";
	^DefValue = null;
	^NumFont = ::GK.Font( 
		"Courier New", 20, #ANSI_CHARSET, #FIXED_PITCH, ::GK.Font.BOLD );
	//	"lr ", 20, #SHIFTJIS_CHARSET, #FIXED_PITCH );
	^BtnFont = ::GK.Font( 
		"lr SVbN", 15, #SHIFTJIS_CHARSET, #FIXED_PITCH, ::GK.Font.BOLD );
	//	"lr ", 14, #SHIFTJIS_CHARSET, #FIXED_PITCH );

	class ^CalcWindow : ::GK.Window  {}

#pv	^MainWnd = ^CalcWindow();
	^MainWnd.Open();

	::GK.WindowMsgLoop();

  FIN:
	delete ^MainWnd;
	delete ^NumFont, ^BtnFont;
	#pc	"I";
	return;

  OnError:
	print ::ErrorMessage( $err_code, $err_info );
	goto FIN;
}

//-----------------------------------------------------------------------------

function ^CalcWindow.Construct()
{
	.[ ::GK.Window.Construct ]( 
		"UOid",
			// ʒɕ\ꍇ́Aȉ̃Rĝ悤ɕύX
		70,	//( ::GK.GetSystemMetrics( #SM_CXSCREEN ) - #WndXd ) / 2,
		20,	//( ::GK.GetSystemMetrics( #SM_CYSCREEN ) - #WndYd ) / 2,
		#WndXd, #WndYd,
		#WS_POPUP | #WS_VISIBLE | #WS_CAPTION | #WS_DLGFRAME | #WS_SYSMENU );
}

function ^CalcWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnCreate()
{
	#pc	"OnCreate";
#pv	( .Xd, .Yd ) = .GetClientSize();

	.DspRect = ::GK.Rect( ( .Xd - #DspXd ) / 2, 12, #DspXd, #DspYd );
	.NumRect = .DspRect;
	.NumRect.Shift( +8, +5, -20, -8 );
	.gc.SetFont( ^NumFont );
	.gc.SetBackMode( #TRANSPARENT );

	.DefWidgetFont := ^BtnFont;
	Name =
	{
		{ "V", "W", "X", "{", "}" },
		{ "S", "T", "U", "|", "C"  },
		{ "P", "Q", "R", "~", "AC" },
		{ "O", "F", "E", "", "" },
	};
	Cmd =
	{
		{ `7`, `8`, `9`, `+`, #CMD_SIGN   },
		{ `4`, `5`, `6`, `-`, #CMD_CLEAR  },
		{ `1`, `2`, `3`, `*`, #CMD_ALLCLR },
		{ `0`, `:`, `.`, `/`, `=`         },
	};
	Color =
	{
		{ #RGB(224,224,255), #RGB(224,224,255), #RGB(224,224,255), #RGB(224,255,128), #RGB(255,224, 96) },
		{ #RGB(224,224,255), #RGB(224,224,255), #RGB(224,224,255), #RGB(224,255,128), #RGB(255,208, 96) },
		{ #RGB(224,224,255), #RGB(224,224,255), #RGB(224,224,255), #RGB(224,255,128), #RGB(255,208, 96) },
		{ #RGB(224,224,255), #RGB(224,208,224), #RGB(208,208,208), #RGB(224,255,128), #RGB(255,224,112) },
	};
	BtnXo = ( .Xd - ( #BtnXd * 5 + #BtnXs * 4 )) / 2;
	R = ::GK.Rect( BtnXo, 10 + #DspYd + 14, #BtnXd, #BtnYd );
	for( v = 0 ; v < 4 ; v++ )
	{
		for( h = 0 ; h < 5 ; h++ )
		{
			name = Name[v][h];
		#pv	.Btn[ name ] = .AddButton( "draw", name, R );
			.Btn[ name ].OnCommand = function()
					{  .owner.SetFocus();  .owner.ExecCmd( .Cmd );  };
			.Btn[ name ].Cmd = Cmd[v][h];
			.Btn[ name ].OnDraw = function( s ) { .owner.OnDraw( this, s ); };
			.Btn[ name ].Rect = R;
			.Btn[ name ].Color = Color[v][h];
			R.Xo += #BtnXd + #BtnXs;
		}
		R.Yo += #BtnYd + #BtnYs;
		R.Xo = BtnXo;
	}

	.state = 0;			// =0: READY, =1: P͒, =2: Q͒
	.Cs'USHORT( #MaxIn + 4 );	// ͕obt@
	.ResetInput();
	.A = 0;				// vZʂ̒l
	.Input? = #FALSE;	// =TRUE: ͕\, =FALSE: vZʕ\
	.Decimal? = #FALSE;	// =TRUE: POi\, =FALSE: UOi\
	.MaxVal = ::Math.pow( 10, #MaxIn ) - 1;		// l̍ől
	.MinVal = ::Math.pow( 10, -#MaxFn ) / 2;	// l̍ŏl
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnClose()
{
	#pc	"OnClose";
	return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnMinMaxInfo( pMinMax )
{
	#pc	"OnMinMaxInfo";

	//MINMAXINFO ::=
	//{
	//	.Reserved		= POINT; 
	//	.MaxSize		= POINT; 
	//	.MaxPosition	= POINT; 
	//	.MinTrackSize	= POINT;
	//	.MaxTrackSize	= POINT;
	//}

  // EBhETCYύXłȂ悤
  //	.MinTrackSize  .MaxTrackSize ݒ肵ĕԂ
	P'LONG(4) = {  #WndXd, #WndYd, #WndXd, #WndYd  };
	( pMinMax + 3*4*2 )'memcpy( P'addr, 4*4 );
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );

	if( .Input? )	// ͕\H
		.ShowInput();
	else			// vZʕ\
		.ShowResult();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnDraw( btn, status )
{
	R := btn.Rect;
	#pc	"OnDraw: " : btn'name, status, R;

	.gc.ClearRect( R, btn.Color );
	.gc.SetFont( ^BtnFont );

	switch( status )
	{
	  default:
	  case 0:	.gc.DrawEdge( R, #EDGE_RAISED, #BF_RECT );	// ʏ
				.gc.DrawText( R, btn'name );
				break;
	  case 1:	.gc.DrawEdge( R, #EDGE_SUNKEN, #BF_RECT );	// 
				Rz = R;
				Rz.Xo += 1;
				Rz.Yo += 1;
				.gc.DrawText( Rz, btn'name );
				break;
	//case 2:	// ֎~
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnChar( c )
{
	#pc	"OnChar", c'c;
	.ExecCmd( c );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.OnKeyDown( key )
{
	#pc	"OnKeyDown", key'x(4);
	switch( key & ~#KCF_REPEAT )
	{
	  case #VK_BACK:	.ExecCmd( #CMD_BACK );	break;
	  case #VK_DELETE:	.ExecCmd( #CMD_CLEAR );	break;
	  case #VK_ESCAPE:	.ExecCmd( #CMD_END );	break;
	  case #VK_RETURN:	.ExecCmd( `=` );		break;
	}
}

//-----------------------------------------------------------------------------

function ^CalcWindow.ExecCmd( c )
{
	switch( c )
	{
	  case `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`:
		if( .state == 0 )
			.state = 1;
		if( .In == 1  &&  .Cs(0) == `0` )	// 0 ̂ṔH
			.In = 0;
	  INPUT_CHAR:
		if( .In >= #MaxIn )
			goto FIN;
		if( .Fn >= 0  &&  c != `.` )	// _ȉ̐́H
		{
			if( .Fn >= #MaxFn )
				goto FIN;
			.Fn++;
		}
		.Cs( .In++ ) = c;
	  SHOW_INPUT:
		.ShowInput();
		goto FIN;

	  case `:`:
		if( .state == 0 )	goto FIN;
		if( .Fn >= 0 )		goto FIN;		// _ȉ͒
		if( .In == 0 )
			.Cs( .In++ ) = `0`;
		goto INPUT_CHAR;

	  case `.`:
		if( .state == 0 )
			.state = 1;
		else if( .Fn >= 0 )	// _ȉ͒H
			goto FIN;
		.Fn = 0;		// = _ȉ̓͌
		if( .In == 0 )
			.Cs( .In++ ) = `0`;
		goto INPUT_CHAR;

	  case #CMD_SIGN:
		if( .Input? )
		{
			.S = ! .S;
			goto SHOW_INPUT;
		}
		.A = -.A;
		.ShowResult();
		goto FIN;

	  case #CMD_BACK:
		if( .state == 0 )	goto ALL_CLEAR;
		if( .In > 0 )
			.In--;
		if( .Fn >= 0 )
			.Fn--;
		goto SHOW_INPUT;

	  case #CMD_CLEAR:
		if( .state == 0 )	goto ALL_CLEAR;
		.ResetInput();
		goto SHOW_INPUT;

	  ALL_CLEAR:
	  case #CMD_ALLCLR:
		.state = 0;
		.ResetInput();
		.A = 0;
		.ShowResult();
		goto FIN;

	  case `+`, `-`, `*`, `/`:
		switch( .state )
		{
		  case 0:	if( .Input? )	goto SET_ACC;
					if( .Decimal? )
						.ShowResult();
					break;
		  SET_ACC:
		  case 1:	.A = .GetInputValue();
					.ShowResult();
					break;
		  case 2:	if( .In <= 0 )	goto SET_OP;
					call Calculate;
		}
		.state = 2;
		.ResetInput();
	  SET_OP:
		.Op = c;
		goto FIN;

	  case `=`:
		switch( .state )
		{
		  case 0:	.ShowResult( #TRUE );	// 60i10i ݂ɐ؊
					break;
		  case 1:	.A = .GetInputValue();
					.ShowResult();
					break;
		  case 2:	call Calculate;
		}
		.state = 0;
		.ResetInput();
		goto FIN;

	  Calculate:
		v = ( .Input? ? .GetInputValue() : .A );
		DefOpValue = null;
		switch( .Op )
		{
		  case `+`:  .A += v;	break;
		  case `-`:  .A -= v;	break;
		  case `*`:  .A *= v;	break;
		  case `/`:  .A = .A / v'float;	  break;
		}
		.ShowResult();
		back;

	  case #CMD_END:
		.Close();
		goto FIN;
	}
  FIN:;
	#pc	##ExecCmd: ${c'x(3)}, state=${.state}, Input?=${.Input?}, .A=${.A}##;
}

//-----------------------------------------------------------------------------

function ^CalcWindow.ResetInput()
{
	.In = 0;	// ݂͕̓ or ̓CfbNXi}CiX͏j
	.Fn = -1;	// ݂̏_ȉ̓͌i =0: _̂, <0: ̂ j
	.S = #FALSE;	// }CiX̗L
}


function ^CalcWindow.GetInputValue()
{
	.Cs( .In ) = 0;
	n = 0.0;
	k = 0.0;
	for( i = 0 ;; )
	{
		switch( c = .Cs( i++ ) )
		{
		  case `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`:
						k = k * 10 + ( c - `0` );
						continue;
		  case `:`:		n = ( n + k ) * 60;
						k = 0.0;
						continue;
		  case `.`:		quit;
		  case 0:		n += k;
						goto FIN;
		}
	}
	n += k;
	f = 0.0;
	d = 0;
	for( ;; )
	{
		switch( c = .Cs( i++ ) )
		{
		  case `0`, `1`, `2`, `3`, `4`, `5`, `6`, `7`, `8`, `9`:
				f = f * 10 + ( c - `0` );
				d++;
				continue;
		  case 0:	quit;
		}
	}
	n += f / ::Math.pow( 10, d );
  FIN:
	#pc	"GetInputValue: " : n, "%-12g"'fmt( n'float ), .S;
	return .S ? -n : n ;
}


function ^CalcWindow.ShowInput()
{
	.Cs( .In ) = 0;
	T = ( .In > 0 ) ? .Cs'gets : "0" ;
	if( .S )
		T = "-" + T;
	.gc.ClearRect( .DspRect );
	.gc.SetFont( ^NumFont );
	.gc.DrawText( .NumRect, T, #DT_RIGHT | #DT_VCENTER | #DT_SINGLELINE );
	.gc.DrawEdge( .DspRect, #EDGE_SUNKEN, #BF_RECT );
	.Input? = #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^CalcWindow.ShowResult( CanDecimal? )
{
	if( CanDecimal? )
		.Decimal? = ! .Decimal?;
	else
		.Decimal? = #FALSE;

	#pc	"ShowResult: " : .A, "%-12g"'fmt( .A'float ), .Decimal? ;

	if( .A == null )
	{
	  ERROR:
		T = "- Error -";
		.A = null;
		goto DISPLAY;
	}

	v = (( s = ( .A < 0 )) ? -.A : .A )'float;
	n = ::Math.floor( v );	// 
	f = v - n;				// 

	if( n > .MaxVal )
		goto ERROR;
	if( v < .MinVal )
	{
		T = "0";
		.A = 0;
		goto DISPLAY;
	}

	// ̕\߂
	i = 0;
	if( .Decimal? )	// POi\H
	{
		i = ::Math.log10( .A )'int;
		if( i <= 0 )
			i = 1;
	}
	else	// UOi\
	{
		for( k = n ; k >= 60 ; k = ::Math.floor( k / 60 ) )
		{
			i += 3;
		}
		i += ( k < 10 ) ? 1 : 2;
	}
	if( i > #MaxIn )
		goto ERROR;

	// _ȉ̕\߂
	d = #MaxIn - 1 - i;
	if( d > #MaxFn )
		d = #MaxFn;

	e = ::Math.pow( 10, d );
	m = ::Math.round( f * e );  // _ȉ̗L\̐l
	if( m >= e )	// ľܓōŏʂ̌オ肪H
	{
		if( ++n > .MaxVal )
			goto ERROR;
		m = 0;
		d = -1;
	}

	// ̕\ݒ
	if( .Decimal? )		// POi\H
	{
		T = n'f(0);
	}
	else	// UOi\
	{
		r = ( n % 60 )'int;
		T = r'd;
		while(( n = ::Math.floor( n / 60 )) > 0 )
		{
			k = r;
			r = ( n % 60 )'int;
			T = r'd + (( k < 10 ) ? ":0" : ":" ) + T;
		}
	}

	// _ȉ̕\ݒ
	if( m > 0 )
	{
		T += ".%0*.0f"'fmt( d, m )'trim( +1, "0." );
	}

	if( s )
		T = "-" + T;

  DISPLAY:
	.gc.ClearRect( .DspRect );
	.gc.SetFont( ^NumFont );
	.gc.DrawText( .NumRect, T, #DT_RIGHT | #DT_VCENTER | #DT_SINGLELINE );
	.gc.DrawEdge( .DspRect, #EDGE_SUNKEN, #BF_RECT );
	.Input? = #FALSE;
}

//-----------------------------------------------------------------------------

