/*
===============================================================================
  DiffText.mc :  Q̃eLXgt@C̍قEBhEɕ\
===============================================================================

	Copyright (C) 2008-2013  Masahiko Watanabe

    Edition History:
      Ver.0.84  2008.01.25i GK Library: Rev.2008.01.21 gp j
      Ver.0.85  2008.03.01i GK Library: Rev.2008.02.29 gp j
      Ver.1.00  2013.01.31  UNICODE 

	gF
	  DiffText.mc <t@C`> <t@Ca>
	ij
		E<t@C`>  <t@Ca> ɂ́Art@Cw
		Ert@CɁA-e w肵ꍇAҏWeLXgΏ
			Í͈i`͈͉j΂̕AȂΑS͈͂Ώ
		Ert@CA-c ̏ꍇANbv{[h̃eLXgΏ
		Ert@C̕Е܂͗̎w肪ȂÃEBhEJ
		Ert@ĆA{EBhEփhbOhbv邩A
			ENbNŃReLXgj[\đI
		Erʂ̊eśÂ悤ɁA[̕\LƔzFς
			A: <t@C`> ݂̂ɂsiԁj
			B: <t@Ca> ݂̂ɂsij
			C: <t@C`>  <t@Ca> ̗ɂsij
		Erʂ\Ă鎞A
			E,, PageDown, PageUp ̊eL[gp
			ECtrl+PageDown ŁȂ̕ςڂֈړ
			ECtrl+PageUp ŁAȎ̕ςڂֈړ
			E_uNbNŁA̍s̃t@C̕ҏWEBhE\
	iӁj
		EeLXg̔ŕAe_sP
		ErśAő 10000 s܂łɐi ύX j
		EPs̔rTCÝAő 256 oCg܂łɐi ύX j
		ErASÝAقrIȂꍇɗL
		Erʂ̊eśAő 256 ܂ŕ\i܂Ԃ\Ȃj

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

/*****/	// fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  pi	#comment
/*****/

/*****	// fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  pi	print
/*****/

#set  p		print

//-----------------------------------------------------------------------------

#set	PROGRAM_NAME	"DiffText"

#set	MAX_LINE_COUNT	10000	// őrs
#set	MAX_LINE_LEN	256		// Ps̍őroCg

#set	C_FGCOLOR	^TextColor			// ̃t@Cɋʂ̍s̕F
#set	C_BGCOLOR	^BackColor			// ̃t@Cɋʂ̍s̔wiF
//#set	C_FGCOLOR	#RGB(0,0,0)			// ̃t@Cɋʂ̍s̕F
//#set	C_BGCOLOR	#RGB(255,255,255)	// ̃t@Cɋʂ̍s̔wiF
#set	A_FGCOLOR	#RGB(196,0,0)		// t@C`ɂȂs̕F
#set	A_BGCOLOR	#RGB(255,208,208)	// t@C`ɂȂs̔wiF
#set	B_FGCOLOR	#RGB(0,0,144)		// t@CaɂȂs̕F
#set	B_BGCOLOR	#RGB(196,255,255)	// t@CaɂȂs̔wiF

#set	COMMON		0
#set	A_ONLY		0x40000000
#set	B_ONLY		0x80000000
#set	SIDE_MASK	0xC0000000
#set	INDEX_MASK	0x3FFFFFFF

#set	DF_FILE_TEXT		0		// ʏt@C
#set	DF_ALL_EDIT_TEXT	1		// ҏW̑SeLXg
#set	DF_SEL_EDIT_TEXT	2		// ҏW̑I͈
#set	DF_CLIPBOARD_TEXT	3		// Nbv{[h̃eLXg

#set	CMD_FILE_OPEN_DIALOG	101
#set	CMD_CLIPBOARD_TEXT		102
#set	CMD_FROM_FILE_A			103
#set	CMD_NEXT_DIFF_LINE		104
#set	CMD_PREV_DIFF_LINE		105
#set	CMD_IMM_OPEN_JUMP		106
#set	CMD_EDIT_FILE_LIST		200

#set	FontYd		16		// gptHg̍

#set	VSB_Xd		16		// XN[o[
#set	HSB_Yd		16		// XN[o[

#set	WM_APP_SET_DIFF_FILE	(#WM_APP+123)
#set	WM_APP_SETUP_DONE		(#WM_APP+124)

#set	SSB_JUMP	100		// wsւ̃Wv

//-----------------------------------------------------------------------------

function	Main( argc, argv )
{
	#pc	"Jn";

	^DefValue = null;
	^SetupDone? = #FALSE;
	^SetupCancel? = #FALSE;

	#pv	::Epsaly.GetWindowCond( 3 );	// sEBhȄꍇAOnError ֍s

	^TextFont =
		::GK.Font( "lr SVbN", #FontYd, #SHIFTJIS_CHARSET, #FIXED_PITCH );
	^DefWidgetFont =
		::GK.Font( "lr oSVbN", 12, #SHIFTJIS_CHARSET, #VARIABLE_PITCH );

	^TextColor = ::GK.GetSysColor( #COLOR_WINDOWTEXT );
	^BackColor = ::GK.GetSysColor( #COLOR_WINDOW );

	class ^DiffWindow    : ::GK.Window  {}
	class ^WaitingWindow : ::GK.Window  {}
	class ^FileCont  {}

	^WaitMsgBox'start'yield;
	^A_File = ^FileCont( argv[0] );
	^B_File = ^FileCont( argv[1] );
	^DiffText();
	^SetupDone? = #TRUE;
	if( ^WaitWnd )
		^WaitWnd.Close();
	'wake;
	'yield;
	if( ^SetupCancel? )
		goto FIN;

#pv	^MainWnd = ^DiffWindow();
	^MainWnd.Open();

	if( ^A_File.Error?  ||  ^B_File.Error? )
		^MainWnd.ShowErrorMsg();

	::GK.WindowMsgLoop();

  FIN:
	delete ^MainWnd;
	delete ^TextFont, ^DefWidgetFont;
	delete ^CmpIndex, ^A_File, ^B_File;
	#pc	"I";
	return;

  OnError:
	#pc	"OnError --- Main()";
	print ::ErrorMessage( $err_code, $err_info );
	goto FIN;
}

//-----------------------------------------------------------------------------

function ^DiffWindow.Construct()
{
	.[ ::GK.Window.Construct ]( ^MainWindowTitle(), ,,,,, #WS_EX_CLIENTEDGE );
}

function ^DiffWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnCreate()
{
	#pc	"OnCreate";

#pv	.HScrBar = .AddScrollBar( "H", ::GK.Rect( 0, 0, 0, 0 ) );
	.HScrBar.OnScroll = HScroll;

#pv	.VScrBar = .AddScrollBar( "V", ::GK.Rect( 0, 0, 0, 0 ) );
	.VScrBar.OnScroll = VScroll;

	.gc.SetFont( ^TextFont );
#pv	.gc.GetFontInfo();
#pc	.gc.FontInfo.Name, .gc.FontInfo.AveCharWidth, .gc.FontInfo.Height;
	.CharXd = .gc.FontInfo.AveCharWidth;
	.LineYd = .gc.FontInfo.Height + 4;

	.SetDiffViewCond();

	::GK.DragAcceptFiles( .hWnd, #TRUE );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd;

	.ViewXo = 6;
	.ViewYo = 4;

	FullXd = .FullCn * .CharXd;
	FullYd = .FullLn * .LineYd;

	.ViewXd = .gc.Xd - #VSB_Xd - .ViewXo;
	if( .ViewXd < 0 )
		.ViewXd = 0;
	if( ^CmpIndex  &&  .TopCi * .CharXd + .ViewXd >= FullXd )
	{
		if(( .TopCi = ( FullXd - .ViewXd ) / .CharXd ) < 0 )
			.TopCi = 0;
	}
#pc	.TopCi, .ViewXd;

	.ViewYd = .gc.Yd - #HSB_Yd - .ViewYo;
	if( .ViewYd < 0 )
		.ViewYd = 0;
	if( ^CmpIndex  &&  .TopLi * .LineYd + .ViewYd >= FullYd )
	{
		if(( .TopLi = ( FullYd - .ViewYd ) / .LineYd ) < 0 )
			.TopLi = 0;
	}
#pc	.TopLi, .ViewYd;

	if( ^CmpIndex )
	{
		.HScrBarRect = ::GK.Rect( 0, .gc.Yd - #HSB_Yd, .ViewXo + .ViewXd, #HSB_Yd );
		.HScrBar.Move( .HScrBarRect );
		.HScrBar.SetRange( 0, .FullCn - 1 );
		.HScrBar.SetPageSize( .ViewXd / .CharXd );
		.HScrBar.SetPos( .TopCi );
		.HScrBar.Show? = #TRUE;
	}
	else
	{
		.HScrBar.Move( ::GK.Rect( 0, 0, 0, 0 ) );
		.HScrBar.Show? = #FALSE;
	}

	if( ^CmpIndex )
	{
		.VScrBar.Move( ::GK.Rect( .gc.Xd - #VSB_Xd, 0, #VSB_Xd, .ViewYo + .ViewYd ) );
		.VScrBar.SetRange( 0, .FullLn - 1 );
		.VScrBar.SetPageSize( .ViewYd / .LineYd );
		.VScrBar.SetPos( .TopLi );
		.VScrBar.Show? = #TRUE;
	}
	else
	{
		.VScrBar.Move( ::GK.Rect( 0, 0, 0, 0 ) );
		.VScrBar.Show? = #FALSE;
	}

	.ViewRect = ::GK.Rect( .ViewXo, .ViewYo, .ViewXd, .ViewYd );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnPaint()
{
	//#pc	"OnPaint";

	.GetHotRect( Rc'STRUCT );
	.gc.DrawEdge( Rc, 0, #BF_MIDDLE );

	if( ! ^CmpIndex )
	{
		.DrawFileSelMsg();
		return;
	}

	Rv = .ViewRect;
	if( ! Rv.And( Rc ) )
		return;

	MinLi = .TopLi + ( Rv.Yo - .ViewYo ) / .LineYd;
	if( MinLi < 0 )
		MinLi = 0;
	MaxLi = .TopLi + ( Rv.Yo + Rv.Yd - .ViewYo - 1 ) / .LineYd;
	if( MaxLi >= .FullLn )
		MaxLi = .FullLn - 1;

	TYi = .ViewYo + ( Rv.Yo - .ViewYo ) / .LineYd * .LineYd;
	TXo = .ViewXo - .TopCi * .CharXd;
	TabXo = TXo + ( 3 + .LineDn + 2 ) * .CharXd;
	TRi = ::GK.Rect( Rv.Xo, TYi, Rv.Xo + Rv.Xd, .LineYd );

	.gc.SetTextAlign( #TA_TOP | #TA_LEFT );
	.gc.SetBackMode( #TRANSPARENT );
	.gc.SetClip( Rv );

	for( Li = MinLi ; Li <= MaxLi ; Li++ )
	{
		.gc.DrawString( TXo, TYi + 2, .GetLineString( Li, TRi ), .TabXp, TabXo );
		TYi += .LineYd;
		TRi.Yo += .LineYd;
	}
	.gc.SetClip( null );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.GetLineString( Li, R )
{
	if( Li < 0  ||  Li >= .FullLn )
	{
		//.gc.SetTextColor( #C_FGCOLOR );
		.gc.ClearRect( R, #C_BGCOLOR );
		return "";
	}

	si = ^CmpIndex( Li );
	li = si & #INDEX_MASK;

	switch( si & #SIDE_MASK )
	{
	  case #COMMON:
		.gc.SetTextColor( #C_FGCOLOR );
		.gc.ClearRect( R, #C_BGCOLOR );
		return "C: " + ( li + ^A_File.LNo )'d's( .LineDn ) + "  " +
					^A_File.GetDispLine( li );

	  case #A_ONLY:
		.gc.SetTextColor( #A_FGCOLOR );
		.gc.ClearRect( R, #A_BGCOLOR );
		return "A: " + ( li + ^A_File.LNo )'d's( .LineDn ) + "  " +
					^A_File.GetDispLine( li );

	  case #B_ONLY:
		.gc.SetTextColor( #B_FGCOLOR );
		.gc.ClearRect( R, #B_BGCOLOR );
		return "B: " + ( li + ^B_File.LNo )'d's( .LineDn ) + "  " +
					^B_File.GetDispLine( li );
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnHScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Ci = 0;								break;
	  case #SB_LINEUP:		Ci = .TopCi - 1;					break;
	  case #SB_PAGEUP:		Ci = .TopCi - .ViewXd / .CharXd;	break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Ci = .HScrBar.GetSlidePos();		break;
		//ij̃Gg[̍ۂɁAprint sȂăR\[EBhE
		//		XN[ƁÃXChʒu擾łȂȂIH

	  case #SB_LINEDOWN:	Ci = .TopCi + 1;					break;
	  case #SB_PAGEDOWN:	Ci = .TopCi + .ViewXd / .CharXd;	break;
	  case #SB_BOTTOM:		Ci = .FullCn;						break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;
	}

	if( Ci > .FullCn - .ViewXd / .CharXd )
		Ci = .FullCn - .ViewXd / .CharXd;
	if( Ci < 0 )
		Ci = 0;

	if( Ci == .TopCi )
		goto END;

	dx = ( .TopCi - Ci ) * .CharXd;
	.TopCi = Ci;
	.HScrBar.SetPos( Ci );

	.Scroll( dx, 0, .ViewRect );
	.Update();

 END:	;
//	#pc	"HScroll", act, Ci;
}

function HScroll( act, pos )
{
	.owner.OnHScroll( act );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnVScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Li = 0;								break;
	  case #SB_LINEUP:		Li = .TopLi - 1;					break;
	  case #SB_PAGEUP:		Li = .TopLi - .ViewYd / .LineYd;	break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Li = .VScrBar.GetSlidePos();		break;
		//ij̃Gg[̍ۂɁAprint sȂăR\[EBhE
		//		XN[ƁÃXChʒu擾łȂȂIH

	  case #SB_LINEDOWN:	Li = .TopLi + 1;					break;
	  case #SB_PAGEDOWN:	Li = .TopLi + .ViewYd / .LineYd;	break;
	  case #SB_BOTTOM:		Li = .FullLn - 1;					break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;

	  case #SSB_JUMP:		Li = .TargetLi;		break;
	}

	if( Li > .FullLn - .ViewYd / .LineYd )
		Li = .FullLn - .ViewYd / .LineYd;
	if( Li < 0 )
		Li = 0;

	if( Li == .TopLi )
		goto END;

	dy = ( .TopLi - Li ) * .LineYd;
	.TopLi = Li;
	.VScrBar.SetPos( Li );

	.Scroll( 0, dy, .ViewRect );
	.Update();

 END:	;
//	#pc	"VScroll", act, Li;
}

function VScroll( act, pos )
{
	.owner.OnVScroll( act );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnMouseWheel( x, y, d )
{
	( X, Y ) = .ScreenToClient( x, y );
	//#pc	"OnMouseWheel: " : X, Y, d ;

	if( .HScrBar.Show?  &&  .HScrBarRect.InPnt?( X, Y ) )
		func := .OnHScroll;
	else if( .VScrBar.Show? )
		func := .OnVScroll;
	else
		return;

	if(( D = d ) > 0 )
		while(( D -= #WHEEL_DELTA / 3 ) >= 0 )
			.[ func ]( #SB_LINEUP );
	else
		while(( D += #WHEEL_DELTA / 3 ) <= 0 )
			.[ func ]( #SB_LINEDOWN );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnKeyDown( vk )
{
	#pc "OnKeyDown: " : vk'x(4), ::GK.GetKeyState( #VK_CONTROL )'SHORT'int;

	if( ! ^CmpIndex )
		return;

	switch( vk & ~#KCF_REPEAT )
	{
	  case #VK_PAGEUP:	.OnVScroll( #SB_PAGEUP );		break;
	  case #VK_PAGEDOWN:.OnVScroll( #SB_PAGEDOWN );		break;
	  case #VK_UP:		.OnVScroll( #SB_LINEUP );		break;
	  case #VK_DOWN:	.OnVScroll( #SB_LINEDOWN );		break;

	  case #KCF_CTRL|#VK_HOME:
	  case #VK_HOME:	.OnVScroll( #SB_TOP );			break;
	  case #KCF_CTRL|#VK_END:
	  case #VK_END:		.OnVScroll( #SB_BOTTOM );		break;

	  case #KCF_CTRL|#VK_PAGEUP:	.PrevDiffLine();	break;
	  case #KCF_CTRL|#VK_PAGEDOWN:	.NextDiffLine();	break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.NextDiffLine()
{
	if( ! ^CmpIndex )
		return;

	i = .TopLi + .ViewYd / .LineYd - 1;   // ʂ̍ŉs̃CfbNX
	if( i >= 0  &&  i < .FullLn )
	{
		CurTopLi = .TopLi;
		s0 = ^CmpIndex( i ) & #SIDE_MASK;

		while( ++i < .FullLn )
		{
			s1 = ^CmpIndex( i ) & #SIDE_MASK;
			if( s0 != s1  &&  s1 != 0 )
			{
				.TargetLi = i;
				.OnVScroll( #SSB_JUMP );
				if( .TopLi != CurTopLi )
					return;
				break;
			}
			s0 = s1;
		}
	}
	.MessageBox( "̉ʂɍق̕ῶ܂I",
			#PROGRAM_NAME, #MB_ICONINFORMATION | #MB_OK );
}

function ^DiffWindow.PrevDiffLine()
{
	if( ! ^CmpIndex )
		return;

	i = .TopLi;   // ʂ̍ŏs̃CfbNX
	if( --i >= 0 )
	{
		CurTopLi = .TopLi;
		s1 = ^CmpIndex( i ) & #SIDE_MASK;

		while( i >= 0 )
		{
			if( --i >= 0 )
				s0 = ^CmpIndex( i ) & #SIDE_MASK;
			else
				s0 = 0;

			if( s1 != s0  &&  s1 != 0 )
			{
				.TargetLi = i + 1;
				.OnVScroll( #SSB_JUMP );
				if( .TopLi != CurTopLi )
					return;
				break;
			}
			s1 = s0;
		}
	}
	.MessageBox( "̉ʂOɍق̕ῶ܂I",
			#PROGRAM_NAME, #MB_ICONINFORMATION | #MB_OK );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnMouseButton( x, y, s, m )
{
	#pc "OnMouseButton: ", x, y, s'x, m'x;

	switch( m )
	{
	  case #WM_LBUTTONDBLCLK:	.OpenJumpAt( x, y );		break;
	  case #WM_RBUTTONDOWN:		.ShowContextMenu( x, y );	break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OpenJumpAt( x, y )
{
	if( ! ^CmpIndex )
		return;
	i = ^CmpIndex( .TopLi + ( y - .ViewYo ) / .LineYd );
	if( i == null )
		return;

	switch( i & #SIDE_MASK )
	{
	  case #COMMON:
	  case #A_ONLY:	  P := ^A_File;   break;
	  case #B_ONLY:   P := ^B_File;   break;
	  default:		  return;
	}
	if( ! P )
		return;
	LineNo = ( i & #INDEX_MASK ) + P::LNo;

	switch( P::Type )
	{
	  case #DF_FILE_TEXT:
		::Epsaly.OpenFile( ##/j%d /b4 /d "%s"##'fmt( LineNo, P::Path ) );
		break;
	  case #DF_ALL_EDIT_TEXT:
		::Epsaly.TargetWindow( P::WndId );
		::Epsaly.MoveTo(( LineNo - 1 )'VLi, 5'SLn );
		::Epsaly.ActiveWindow( P::WndId );
		break;
	  case #DF_SEL_EDIT_TEXT:
		::Epsaly.TargetWindow( P::WndId );
		::Epsaly.MoveTo(( LineNo - 1 )'LLi, 5'SLn );
		::Epsaly.ActiveWindow( P::WndId );
		break;
	  case #DF_CLIPBOARD_TEXT:
		break;
	}
	return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.ShowContextMenu( x, y )
{
	delete .Menu, .SubMenu;
	.Menu = ::GK.Menu();
	.Menu.InsertItem( #CMD_FILE_OPEN_DIALOG, "t@CI_CAO\" );
	.SubMenu = ::GK.Menu();
	for( i = n = 0 ; ( id = ::Epsaly.GetWindowId( i, 3 )) != 0 ; i-- )
	{
		name = ::Epsaly.GetFileName( id, 2 );
		if( name == "-Script-" )
			continue;
		.SubMenu.InsertItem( #CMD_EDIT_FILE_LIST + id,
			name + " ( " + ::Epsaly.GetFileName( id, 1 ) + " )" );
		n++;
	}
	if( n > 0 )
		.Menu.InsertMenu( .SubMenu, "ҏW̃eLXgƔr" );
	.Menu.InsertItem( #CMD_CLIPBOARD_TEXT, "Nbv{[h̓eƔr" );
	.Menu.InsertItem( #CMD_FROM_FILE_A, "t@Ci`j蒼" );
	.Menu.InsertSeparator();
	.Menu.InsertItem( #CMD_NEXT_DIFF_LINE, "̑ӏ ( ^PageDn )" );
	.Menu.InsertItem( #CMD_PREV_DIFF_LINE, "Ȏӏ ( ^PageUp )" );
	.Menu.InsertItem( #CMD_IMM_OPEN_JUMP , "̈ʒũt@C̍s" );
	if( ! ^CmpIndex )
	{
		.Menu.DisableItem( #CMD_NEXT_DIFF_LINE );
		.Menu.DisableItem( #CMD_PREV_DIFF_LINE );
		.Menu.DisableItem( #CMD_IMM_OPEN_JUMP  );
	}
	.MouseX = x;
	.MouseY = y;
	.PopupMenu( .Menu );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnMenu( id )
{
	#pc	"OnMenu: " : id;
	.Update();

	switch( id )
	{
	  case #CMD_FILE_OPEN_DIALOG:
		OFN.FileSpec'USHORT( #MAX_PATH + 4 );
		OFN.Title = "rt@C̑I";
		//OFN.InitialDir = ".";
		::File.GetNamePart( ::Epsaly.GetFileName(), OFN.InitialDir'new! );
		OFN.Filter'USHORT( 16 );
		OFN.Filter'puts( "*.*" );
		OFN.Flags = #OFN_FILEMUSTEXIST | #OFN_HIDEREADONLY;
		if( ! .GetOpenFileName( OFN ) )
			return;
		.DiffFilePath = OFN.FileSpec'gets(-1);
		.PostMessage( #WM_APP_SET_DIFF_FILE, 0, 0 );
		break;

	  case #CMD_CLIPBOARD_TEXT:
		.DiffFilePath = "-c";
		.PostMessage( #WM_APP_SET_DIFF_FILE, 0, 0 );
		break;

	  default:
		.DiffFilePath = id - #CMD_EDIT_FILE_LIST;
		.PostMessage( #WM_APP_SET_DIFF_FILE, 0, 0 );
		#pc	"OnMenu -- default: " : .DiffFilePath;
		break;

	  case #CMD_FROM_FILE_A:
		delete ^CmpIndex;
		delete ^A_File, ^B_File;
		.SetTitle( ^MainWindowTitle() );
		.PostMessage( #WM_APP_SETUP_DONE, 0, 0 );
		break;

	  case #CMD_NEXT_DIFF_LINE:		.NextDiffLine();	break;
	  case #CMD_PREV_DIFF_LINE:		.PrevDiffLine();	break;

	  case #CMD_IMM_OPEN_JUMP:
		.OpenJumpAt( .MouseX, .MouseY );
		break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnDropFiles( hDrop )
{
	#pc	"OnDropFiles";

	file_path'USHORT( #MAX_PATH + 4 );
	::GK.DragQueryFile( hDrop, 0, file_path, #MAX_PATH );
	.DiffFilePath = file_path'gets( -1 );
	.PostMessage( #WM_APP_SET_DIFF_FILE, 0, 0 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage", iMsg - #WM_APP;

	switch( iMsg )
	{
	  case #WM_APP_SET_DIFF_FILE:
		::GK.SetForegroundWindow( .hWnd );
		if( ^DiffSetupThread'start( .DiffFilePath ) )
		{
			.InvalidateRect();
			::GK.SetParaProc( #TRUE );
		}
		break;

	  case #WM_APP_SETUP_DONE:
		.SetDiffViewCond();
		.OnSize();
		.InvalidateRect();
		.Update();
		::GK.SetForegroundWindow( .hWnd );
		::GK.SetParaProc( #FALSE );
		.ShowErrorMsg();
		break;
	}
}

function  ^DiffSetupThread( file_spec )
{
	#pc "DiffSetupThread -- started: " : file_spec;
	^SetupDone? = #FALSE;
	delete ^CmpIndex;

	^WaitMsgThread'start;

	switch(( ^A_File.Fd ? 1 : 0 ) + ( ^B_File.Fd ? 2 : 0 ))
	{
	  case 0:	// `,aȂ
	  case 3:	// `,a
		delete ^A_File, ^B_File;
		^A_File = ^FileCont( file_spec );
		break;

	  case 1:	// `̂
		delete ^B_File;
		^B_File = ^FileCont( file_spec );
		break;

	  case 2:	// â
		delete ^A_File;
		^A_File = ^FileCont( file_spec );
		break;
	}
	^MainWnd.SetTitle( ^MainWindowTitle() );

	^DiffText();
	^SetupDone? = #TRUE;

	if( ^WaitWnd )
		^WaitWnd.Close();
	'wake;
	'yield;

	if( ! ^SetupCancel? )
		^MainWnd.PostMessage( #WM_APP_SETUP_DONE, 0, 0 );
	else
		^MainWnd.Close();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindowTitle()
{
	DefValue = "";
	return
		##r:##
		##   (A) ${ ^A_File.Fd ? ^A_File.Title : "||" }##
	//	##  ##
		##   (B) ${ ^B_File.Fd ? ^B_File.Title : "||" }##
		;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.DrawFileSelMsg()
{
	if( ! ^A_File.Fd )	Msg = "t@Ci`j";
	else
	if( ! ^B_File.Fd )	Msg = "t@Ciaj";
	else
		return;

	.gc.SetBackMode( #TRANSPARENT );
	.gc.SetTextColor( #C_FGCOLOR );
	//.gc.SetBackColor( #C_BGCOLOR );

	#set   R1	::GK.Rect( 0, - #FontYd * 3 / 4, .gc.Xd, .gc.Yd )
	#set   R2	::GK.Rect( 0, + #FontYd * 3 / 4, .gc.Xd, .gc.Yd )

	.gc.DrawText( #R1, Msg + "Ƀhbv邩" );
	.gc.DrawText( #R2, "ENbNŃj[\đIł" );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.ShowErrorMsg()
{
	if( ^A_File.Path  &&  ^A_File.Error? )
		msg = ^A_File.Path + "\n";
	else
		msg = "";

	if( ^B_File.Path  &&  ^B_File.Error? )
		msg += ^B_File.Path + "\n";
	//else
	//	msg += "";

	if( msg )
		.MessageBox( msg + "t@CJ܂I",
			#PROGRAM_NAME, #MB_ICONERROR | #MB_OK );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.SetTabColumnXp( N )
{
	delete .TabXp;
	switch( N'type )
	{
	  case "integer":	// l
		.TabXp'LONG(1) = { .CharXd * N  };
		break;

	  case "array":		// z
		D = N'count;
		.TabXp'LONG( D );
		X = 0;
		for( i = 0 ; i < D ; i++ )
			.TabXp( i ) = ( X += .CharXd * N( i ));
		break;

	  default:			// ̑
		.TabXp'LONG(1) = { .CharXd * 8  };
		break;
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^DiffWindow.SetDiffViewCond()
{
	.FullLn = ( ^CmpIndex ? ^CmpIndex'count : 0 );
	.FullCn = 256;	// b
	.TopCi = 0;
	.TopLi = 0;

	DefValue = 0;
	ln = ::Math.max( ^A_File.N_Lines + ^A_File.LNo, ^B_File.N_Lines + ^B_File.LNo );
	.LineDn = ( ln >= 1 ) ? ( ::Math.log10( ln )'int + 1 ) : 1 ;

	.SetTabColumnXp( ::Epsaly.TabColumn() );
}

//-----------------------------------------------------------------------------

function  ^FileCont.Construct( file_path )
{
	#pc	"FileCont.Construct: " : file_path;

	switch( file_path )
	{
	  case null:	return;

	  SET_CUR_EDIT_TEXT:
	  case "-e":	// ҏWeLXg̏ꍇ
		.Title = ::Epsaly.GetFileName( , 2 );
		.WndId = ::Epsaly.GetWindowId();
		.Fd = ::Buffer();
		if( ::Epsaly.GetSelType() == 0 )	// I͈͂ȂH
		{
			.Fd.Write( ::Epsaly.GetFullText() );
			.Title += " <ҏWe>";
			.Type = #DF_ALL_EDIT_TEXT;
			.LNo = 1;
		}
		else	// I͈͂ꍇ
		{
			.Fd.Write( ::Epsaly.GetSelText() );
			.Title += " <I͈>";
			.Type = #DF_SEL_EDIT_TEXT;
			.LNo = ::Epsaly.GetSelRange( 0 );
			.LNo++;
		}
		if( cur_id )
			::Epsaly.TargetWindow( cur_id );
		break;

	  case "-c":	// Nbv{[h̃eLXg̏ꍇ
		.Fd = ::Buffer();
		.Fd.Write( ::Clipboard.GetText() );
		.Title = "Nbv{[h";
		.Type = #DF_CLIPBOARD_TEXT;
		.LNo = 1;
		break;

	  default:
		if( file_path'type == "integer" )
		{
		  // XgIꂽҏWeLXg̏ꍇ
			cur_id = ::Epsaly.TargetWindow();
			new_id = ::Epsaly.TargetWindow( file_path );
			if( new_id != 0 )
				goto SET_CUR_EDIT_TEXT;
			::Epsaly.TargetWindow( cur_id );
			return;
		}

	  // ʏ́ifBXNjt@C̏ꍇ
		.Path = file_path;
		::File.GetNamePart( .Path, , fn'new!, en'new! );
		.Title = fn + en;
		.Type = #DF_FILE_TEXT;
		.LNo = 1;
		file = ::File.Open( file_path, "in" );
		.Fd = ::Buffer();
		file.Read( .Fd );
		delete file;
		.Fd.Seek(0);
		.Fd.Decode( "auto" );
		break;
	}
	#pc	.Title, .LNo, .Fd.Size();

	.Fd.Seek(0);
	line'LINE;

	offset'ULONG = 0;
	OfsBuf = ::Buffer();
	OfsBuf.Write( offset );

	LimLine'USHORT( #MAX_LINE_LEN );

	s = 0;
	ln = #MAX_LINE_COUNT;
	.Text'cbox!'empty!;
	do
	{
		if( --s < 0 )
		{
			if( 'yield  &&  ^SetupCancel? )
				return;
			s = 20;
		}

		if(( bn = .Fd.Read( line )) <= 0 )
			break;
		offset += bn;
		OfsBuf.Write( offset );

		if( bn > #MAX_LINE_LEN * 2 )
		{
			LimLine'puts( line );
			line = LimLine'gets;
		}
		.Text'post( line'mend( ` `, " +++++++++-++-+++++++++++++++++++" ) );
	}
	while( --ln > 0 );

	.N_Lines = OfsBuf.Size() / 4 - 1;

	.Offset'ULONG( .N_Lines + 1 );
	OfsBuf.Seek(0);
	OfsBuf.Read( .Offset );

	//for( p := .Text'first ; p'ref? ; p := .Text'next )
	//	#pc p;
	return;

  OnError:
	.Error? = #TRUE;
	delete .Fd;
	#pc "OnError --- FileCont.Construct(): " : file_path;
	delete $err_state;
	return;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^FileCont.GetDispLine( Li )
{
	if( .Fd == null  ||  Li < 0  ||  Li >= .N_Lines )
		return "";

	cn = ( .Offset( Li + 1 ) - .Offset( Li )) / 2;
	if( cn <= 0 )
		return "";
	if( cn > #MAX_LINE_LEN )
		cn = #MAX_LINE_LEN;

	line'USHORT( cn );
	.Fd.Seek( .Offset( Li ) );
	.Fd.Read( line );

	//#pc	line'gets;
	return line'gets'mend( ` `, " +--" );
}

//-----------------------------------------------------------------------------

function  DiffText()
{
	//delete ^CmpIndex;

	A := ^A_File.Text;
	B := ^B_File.Text;

	if( ! A || ! B )
		return;

	DefValue = 0;
	s = 0;
	for( p := A'first ; p'ref? ; p := A'next )
	{
		call CHK_SYNC;
		AHash[ p ] = AHash[ p ] + 1;
	}
	for( p := B'first ; p'ref? ; p := B'next )
	{
		call CHK_SYNC;
		BHash[ p ] = BHash[ p ] + 1;
	}

	DefValue = null;
	Ai = 0;
	Bi = 0;
	Index = ::Buffer();

  LOOP:
	call CHK_SYNC;

	if( A'first == null )   goto B_FINISH;
	if( B'first == null )   goto A_FINISH;

	if( A'first == B'first )	// `̐擪sƂa̐擪sH
	{
	  SAVE_COMMON:
		#pi "SAVE_COMMON", A'count, B'count;
		Index.Write( Ai++ | #COMMON );
		Bi++;
		AHash[ A'first ]--;
		BHash[ B'first ]--;
		A'pop;
		B'pop;
		goto LOOP;
	}

  // `̐擪sƂa̐擪sقȂꍇ
  CHK_UNIQUE:
	#pi "CHK_UNIQUE";
	while( ! BHash[ A'first ] )		// `̐擪sa̎csɂȂ
	{
		#pi "A_UNIQUE";
		Index.Write( Ai++ | #A_ONLY );
		AHash[ A'first ]--;
		A'pop;
		if( A'first == null )  goto B_FINISH;
	}

	while( ! AHash[ B'first ] )		// a̐擪s`̎csɂȂ
	{
		#pi "B_UNIQUE";
		Index.Write( Bi++ | #B_ONLY );
		BHash[ B'first ]--;
		B'pop;
		if( B'first == null )  goto A_FINISH;
	}

	if( A'first == B'first )	// `̐擪sƂa̐擪sH
		goto SAVE_COMMON;

	switch( ( AHash[ B'first ] ? 1 : 0 ) +
			( BHash[ A'first ] ? 2 : 0 ) )
	{
	  case 0:
		#pi "A, B unique";
		goto CHK_UNIQUE;
	
	  case 1:
		#pi "A only unique";
		An = 1;
		Bt := B'first;
		Ap := A'first(1);
	  A_SEEK:
		for( ; Ap'ref? ; Ap := A'next )
		{
			if( Ap == Bt )	goto A_SAVE;
			An++;
		}
		break;	// ɂ͗Ȃ

	  case 2:
		#pi "B only unique";
		Bn = 1;
		At := A'first;
		Bp := B'first(1);
	  B_SEEK:
		for( ; Bp'ref? ; Bp := B'next )
		{
			if( Bp == At )	goto B_SAVE;
			Bn++;
		}
		break;	// ɂ͗Ȃ

	  case 3:
		#pi "A, B not unique";
		An = 1;   At := A'first;   Ap := A'first(1);
		Bn = 1;   Bt := B'first;   Bp := B'first(1);
		for( ;; )	// ɌD
		{
			if( ! Ap'ref? )  goto B_SEEK;
			if( Ap == Bt )	 goto A_SAVE;
			An++;
			Ap := A'next;

			if( ! Bp'ref? )  goto A_SEEK;
			if( Bp == At )	 goto B_SAVE;
			Bn++;
			Bp := B'next;
		}
	}
	#pi "ɂ͗Ȃ";
	goto LOOP;

  A_SAVE:
	#pi "SAVE_A", An;
	while( --An >= 0 )
	{
		Index.Write( Ai++ | #A_ONLY );
		AHash[ A'first ]--;
		A'pop;
	}
	goto SAVE_COMMON;

  B_SAVE:
	#pi "SAVE_B", Bn;
	while( --Bn >= 0 )
	{
		Index.Write( Bi++ | #B_ONLY );
		BHash[ B'first ]--;
		B'pop;
	}
	goto SAVE_COMMON;

  A_FINISH:		// `̍ŝݎcꍇi a̍s͋ j
	#pi "A_FINISH";
	while( A'first != null )
	{
		Index.Write( Ai++ | #A_ONLY );
		A'pop;
	}
	goto END;

  B_FINISH:		// a̍ŝݎcꍇi `̍s͋ j
	#pi "B_FINISH";
	while( B'first != null )
	{
		Index.Write( Bi++ | #B_ONLY );
		B'pop;
	}
	goto END;

  END:	;
	n = Index.Size() / 4;
	#pi "END", n, A'count, B'count;

	if( n <= 0 )
		return;

	^CmpIndex'ULONG( n );
	Index.Seek(0);
	Index.Read( ^CmpIndex );
	return;

  CHK_SYNC:
	if( --s < 0 )
	{
		if( 'yield  &&  ^SetupCancel? )
			return;
		s = 20;
	}
	back;
}

//=============================================================================

function ^WaitingWindow.Construct()
{
	#pc	"WaitingWindow - Construct";
	Xd = 240;
	Yd = 110;
	Xo = ( ::GK.GetSystemMetrics( #SM_CXSCREEN ) - Xd ) / 2;
	Yo = ( ::GK.GetSystemMetrics( #SM_CYSCREEN ) - Yd ) / 2;

	.[ ::GK.Window.Construct ]( #PROGRAM_NAME " ...", Xo, Yo, Xd, Yd,
		#WS_POPUP | #WS_VISIBLE | #WS_CAPTION | #WS_DLGFRAME | #WS_SYSMENU, ,
		^MainWnd );
}

function ^WaitingWindow.OnCreate()
{
	#pc	"WaitingWindow - OnCreate";
	.DefWidgetFont := ^DefWidgetFont;
	.AddLabel( "΂炭҂DDD",
					::GK.Rect( 0, 20, 240, 18 ), "center" );
	.CancelBtn = .AddButton( "push", "LZ",
					::GK.Rect( 70, 50, 90, 24 ) );
	.CancelBtn.OnCommand = function() { ^SetupCancel? = #TRUE;  };
}

function ^WaitingWindow.OnPaint()
{
	#pc	"WaitingWindow -- OnPaint";
	.GetHotRect( R'new! );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

function ^WaitingWindow.OnClose()
{
	#pc	"WaitingWindow -- OnClose";
	return ^SetupDone? ? #OK : #NG ;
}

//-----------------------------------------------------------------------------

function  ^WaitMsgBox()
{
	'sleep( 500 );
	if( ! ^SetupDone? )
	{
		^WaitWnd = ^WaitingWindow();
		^WaitWnd.Open();
		::GK.SetParaProc( #TRUE );
		::GK.WindowMsgLoop();
		::GK.SetParaProc( #FALSE );
		delete ^WaitWnd;
	}
}

function  ^WaitMsgThread()
{
	'sleep( 500 );
	if( ! ^SetupDone? )
	{
		^WaitWnd = ^WaitingWindow();
		^WaitWnd.Open();
	}
}

//-----------------------------------------------------------------------------
