/*
===============================================================================
  HexDump.mc :  wt@C̓eEBhE 16ilŕ\
===============================================================================

	Copyright (C) 2008-2013  Masahiko Watanabe

    Edition History:
      2013.01.31  Ahift-JISłAUNICODEłɏC
      2013.06.25  @\ǉi ASCIIUTF16(LE)؊AL[ j

	gF
	  HexDump.mc <t@C>
	ij
		E<t@C> ɂ́A16il\t@Cw
		E<t@C> ȗÃEBhEJ
		EEBhEփt@ChbOhbvƕ\؂芷
	ij
		Et@C̃TCYAȂ蒷łAɕ\i 2GB ȏ͕s j
		Ee\śAItZbg\APUl\A\ɋ敪
		EItZbg\́AAʂU܂ŕ\
		E\́AF2L[ŁAASCII  UTF16(LE) ؊

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  "GkLib\GkLibrary.mc"

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set  p		print

#set	MGN_Xd		4			// [̗]

#set	OFS_Xc		(6+1)		// ItZbǧ
#set	HEX_Xc		(1+3*16)	// 16il\̌
#set	STR_Xc		(1+16)		// \̌

#set	FONT_Yd		16			// \
#set	FONT_Xd		8			// \

#set	HDR_Yd		(2+#FONT_Yd+2)	// wb_[s̍
#set	CNT_Yd		(1+#FONT_Yd+1)	// ʏes̍

#set	VSB_Xd		16			// XN[o[̕
#set	HSB_Yd		0			// XN[o[̍iȂj

#set	WM_SHOW_HEX_FILE	(#WM_APP+123)

//-----------------------------------------------------------------------------

function	Main( argc, argv )
{
	#pc	"Jn";

	^DefValue = null;

#pv	^TextFont = 
		::GK.Font( "lr SVbN", #FONT_Yd, #SHIFTJIS_CHARSET, #FIXED_PITCH );

	class ^HexViewWindow : ::GK.Window  {}

#pv	wnd = ^HexViewWindow( argv[0] );
	wnd.Open();

	if( wnd.FileOpenError? )
		wnd.ShowFileErrorMsg();

	::GK.WindowMsgLoop();

  FIN:
	delete wnd;
	delete ^TextFont;
	#pc	"I";
	return;

  OnError:
	print ::ErrorMessage( $err_code, $err_info );
	goto FIN;
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.Construct( file_path )
{
#pv	.FilePathToOpen = file_path;

	R'LONG(4);
	R(2) = #MGN_Xd + #FONT_Xd * ( #OFS_Xc + #HEX_Xc + #STR_Xc + 1 )+ #VSB_Xd;
	R(3) = #HDR_Yd + 28 * #CNT_Yd + 2 + #HSB_Yd;
	if( ::GK.AdjustWindowRectEx( R,
			#WS_OVERLAPPEDWINDOW, #FALSE, #WS_EX_CLIENTEDGE ))
	{
		Xd = R(2) - R(0);	// = .right - .left
		Yd = R(3) - R(1);	// = .bottom - .top
	}
	.[ ::GK.Window.Construct ]( "", , , Xd, Yd, , #WS_EX_CLIENTEDGE );
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.Destruct()
{
	//delete .CurFile;	//  Ńt@C̃N[YIɍsȂ
	.[ ::GK.Window.Destruct ]();
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnCreate()
{
	#pc	"OnCreate";

	.gc.SetTextColor( ::GK.GetSysColor( #COLOR_WINDOWTEXT ) );
	.gc.SetBackColor( ::GK.GetSysColor( #COLOR_WINDOW ) );
	.gc.SetBackMode( #TRANSPARENT );

	.gc.SetFont( ^TextFont );
#pc	.gc.GetFontInfo();
#pc	.gc.FontInfo.Name, .gc.FontInfo.Height, .gc.FontInfo.AveCharWidth;

#pv	.VScrBar = .AddScrollBar( "V", ::GK.Rect( 0, 0, 0, 0 ) );
	.VScrBar.OnScroll =
		function( act, pos )  {  .owner.OnVScroll( act );  };

	.IsAscii? = #TRUE;

	.OpenHexFile();

	::GK.DragAcceptFiles( .hWnd, #TRUE );
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd;

	.VScrBar.Move( ::GK.Rect( .gc.Xd - #VSB_Xd, 0, #VSB_Xd, .gc.Yd - #HSB_Yd ) );

#pv	v = ( .gc.Yd - ( #HDR_Yd + #HSB_Yd )) / #CNT_Yd;
	if( v <= 0 )
		v = 1;
	.VScrBar.SetPageSize( v );
	.VScrBar.PageLines = v;
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( Rc'STRUCT );
	.gc.DrawEdge( Rc, 0, #BF_MIDDLE );

	if( .CurFile == null )
	{
		.gc.DrawText( ::GK.Rect( 0, 0, .gc.Xd, .gc.Yd ),
			 "t@CɃhbvƊJ܂I" );
		return;
	}

  // wb_[̕`
	R = ::GK.Rect( #MGN_Xd, 0, .gc.Xd - #VSB_Xd, #HDR_Yd );
	if( Rc.Yo < #HDR_Yd )
		.gc.DrawText( R,
			"        +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F",
			//"        +0 +1 +2 +3 +4 +5 +6 +7 +8 +9 +A +B +C +D +E +F  0123456789ABCDEF",
			#DT_LEFT | #DT_VCENTER | #DT_SINGLELINE );

  // ees̕`
	Bytes'UBYTE( 16 );
	Buf = ::Buffer();
	i = ( Rc.Yo - #HDR_Yd ) / #CNT_Yd;
	if( i < 0 )
		i = 0;
	offset = .CurTopOffset + 16 * i;
	CurY = i * #CNT_Yd + #HDR_Yd;
	LimY = Rc.Yo + Rc.Yd;
	R.Yd = #CNT_Yd;
	while( offset < .CurFileSize  &&  CurY < LimY )
	{
		.CurFile.Seek( offset );
		bn = .CurFile.Read( Bytes );
		if( bn <= 0 )
			break;

		line = offset'x(6) + "  ";

		for( i = 0 ; i < bn ; i++ )
			line += Bytes(i)'x(2) + " ";
		if( bn < 16 )
			line += "   "'rep( 16 - bn );

		if( .IsAscii? )
		{
			Buf.Seek(0);
			Buf.Write( Bytes );
			Buf.Seek(0);
			Buf.Size( bn );
			//tn = Buf.Decode( "CP1252" );
			tn = Buf.Decode( "Shift-JIS" );
			if( tn > 0 )
				Buf.Read( text'T( tn / 2 ) );
			else
				text = " "'rep( bn );	// ϊG[̏ꍇ
		}
		else	// UTF16(LE) ̏ꍇ
			text = Bytes'gets( bn );

		R.Yo = CurY;
		.gc.DrawText( R,
			line + " " + text'mend( ` `, "..............................." ),
			#DT_LEFT | #DT_VCENTER | #DT_SINGLELINE );

		offset += 16;
		CurY += #CNT_Yd;
	}
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnVScroll( act )
{
	#pc	"OnVScroll", act;

	switch( act )
	{
	  case #SB_TOP:			pos = .VScrBar.min;			break;
	  case #SB_LINEUP:		pos = .VScrBar.pos - 1;		break;
	  case #SB_PAGEUP:		pos = .VScrBar.pos - .VScrBar.PageLines;
							break;

	  case #SB_BOTTOM:		pos = .VScrBar.max;			break;
	  case #SB_LINEDOWN:	pos = .VScrBar.pos + 1;		break;
	  case #SB_PAGEDOWN:	pos = .VScrBar.pos + .VScrBar.PageLines;
							break;

	  case #SB_THUMBTRACK:
	  case #SB_THUMBPOSITION:
							pos = .VScrBar.GetSlidePos();
							break;
	  case #SB_ENDSCROLL:
	  default:				return;
	}

	max = .VScrBar.max - .VScrBar.PageLines + 2;
	if( pos > max )
		pos = max;
	if( pos < .VScrBar.min )
		pos = .VScrBar.min;

	if( pos == .VScrBar.pos )
		return;

	.VScrBar.SetPos( pos );

	dy = ( .CurTopLine - pos ) * #CNT_Yd;
	.CurTopLine = pos;
	.CurTopOffset = pos * 16;

	R = ::GK.Rect( 0, #HDR_Yd,
			.gc.Xd - #VSB_Xd, .gc.Yd - ( #HDR_Yd + #HSB_Yd ));

	.Scroll( 0, dy, R );
	.Update();
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnMouseWheel( x, y, d )
{
	//#pc	"OnMouseWheel: " : x, y, d ;

	if(( D = d ) > 0 )
		while(( D -= #WHEEL_DELTA / 5 ) >= 0 )
			.OnVScroll( #SB_LINEUP );
	else
		while(( D += #WHEEL_DELTA / 5 ) <= 0 )
			.OnVScroll( #SB_LINEDOWN );
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnKeyDown( vk )
{
	#pc "OnKeyDown: " : vk'x(4), ::GK.GetKeyState( #VK_CONTROL )'SHORT'int;

	switch( vk & ~#KCF_REPEAT )
	{
	  case #VK_F2:		.IsAscii? = ! .IsAscii?;
						.InvalidateRect();
						.Update();
						break;

	  case #VK_PAGEUP:	.OnVScroll( #SB_PAGEUP );		break;
	  case #VK_PAGEDOWN:.OnVScroll( #SB_PAGEDOWN );		break;
	  case #VK_UP:		.OnVScroll( #SB_LINEUP );		break;
	  case #VK_DOWN:	.OnVScroll( #SB_LINEDOWN );		break;

	  case #KCF_CTRL|#VK_HOME:
	  case #VK_HOME:	.OnVScroll( #SB_TOP );			break;
	  case #KCF_CTRL|#VK_END:
	  case #VK_END:		.OnVScroll( #SB_BOTTOM );		break;
	}
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnDropFiles( hDrop )
{
	#pc	"OnDropFiles";

	file_path'USHORT( #MAX_PATH + 4 );

	::GK.DragQueryFile( hDrop, 0, file_path, #MAX_PATH );
	.FilePathToOpen = file_path'gets( -1 );
	.PostMessage( #WM_SHOW_HEX_FILE, 0, 0 );
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage", iMsg;

	if( iMsg == #WM_SHOW_HEX_FILE )
	{
		::GK.SetForegroundWindow( .hWnd );
		.OpenHexFile();
		.InvalidateRect();
		.Update();
		if( .FileOpenError? )
			.ShowFileErrorMsg();
	}
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.OpenHexFile()
{
	$err_state = 1;		// ꎞIɃG[[v֎~
	delete .CurFile;	//  Ńt@C̃N[YIɍsȂ

	.FileOpenError? = #FALSE;

	if(( .CurFileName = .FilePathToOpen ) != null )
	{
		.CurFile = ::File.Open( .CurFileName, "in" );
		if( .CurFile != null )
		{
		#pv	.CurFileSize = .CurFile.Size();
			if( .CurFileSize < 0 )
				.CurFileSize = 0;
		}
		else
		{
			.CurFileSize = 0;
			.FileOpenError? = #TRUE;
		}
	}
	else
	{
		.CurFile = null;
		.CurFileSize = 0;
	}

	.CurTopOffset = 0;
	.CurTopLine = 0;
	.MaxLine = ( .CurFileSize + 15 ) / 16;
	if( .MaxLine <= 0 )
		.MaxLine = 1;

	if( .CurFileName  &&  ! .FileOpenError? )
		.SetTitle( .CurFileName + " -- HexDump" );
	else
		.SetTitle( "HexDump" );

	.VScrBar.SetRange( 0, .MaxLine );
	.VScrBar.SetPos( 0 );
	if( .VScrBar.PageLines )
		.VScrBar.SetPageSize( .VScrBar.PageLines );

	$err_state = 0;		// G[[v
}

//-----------------------------------------------------------------------------

function ^HexViewWindow.ShowFileErrorMsg()
{
	if( .CurFileName != null )
		.MessageBox( .CurFileName + "\nt@CJ܂I",
			"HexDump", #MB_ICONERROR | #MB_OK );
}

//-----------------------------------------------------------------------------

