/*
===============================================================================
  PrintView.mc :  ҏWeLXg̈vr[  s
===============================================================================

	Copyright (C) 2008-2012  Masahiko Watanabe

    Edition History:
      Ver.0.84  2008.01.22i GK Library: Rev.2008.01.22 gp j
      Ver.0.85  2008.03.01i GK Library: Rev.2008.02.29 gp j
      Ver.0.86  2008.06.06i GK Library: Rev.2008.02.29 gp j
	  Ver.0.87  2008.10.18 lbg[Nv^Ήi Windows9x ͑Ołŉ j
      Ver.1.00  2012.12.19 Epsaly ł̓Ή

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

/*****/	// fobOvgi[Xj
#set  pc	#comment
#set  pv	
#set  pi	#comment
#set  pd	#comment
/*****/

/*****	// fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  pi	print
#set  pd	
/*****/

#set  p		print

//-----------------------------------------------------------------------------

#set	PROGRAM_NAME	"vr["

#set	VSB_Xd		16			// XN[o[
#set	HSB_Yd		16			// XN[o[

#set	MIN_MXd		(12+12+#VSB_Xd)		// DFhׂ̍Ev̍ŏl
#set	MIN_MYd		(12+12+#HSB_Yd)		// DFhׂ̏㉺v̍ŏl

#set	MIN_SCALE	0
#set	MAX_SCALE	9
#set	DEF_SCALE	3

#set	CMD_EDIT_PRINT_SPEC			101
#set	CMD_UPDATE_PRINT_SPEC		102
#set	CMD_RESET_PRINT_TEXT		103
#set	CMD_SHOW_HELP_TEXT			104
#set	CMD_SEL_PRINTER_BASE		200

#set	WM_APP_TEXT_SETUP_DONE	(#WM_APP+123)

#set	CUT( min, v, max )	(((#v)<(#min)?(#min):((#v)>(#max)?(#max):(#v))))

#set	K	(1440/25.4)		// mm  cb_Pʂւ̕ϊW [ twips / mm ]

//-----------------------------------------------------------------------------

function  ^Main( argc, argv )
{
	#pc	"Jn";

	^DefValue = null;
	^TextSetupDone? = #FALSE;
	^TextSetupCancel? = #FALSE;
	^Round := ::Math.round;

	^SetupPrintSpecs();
	^CurSpec := ^FindPrintSpec( ::LastPrintSpecName );
	if( ^CurSpec == null )
	{
		::Alert( "dl܂I" );
		return;
	}

	^EnumPrinterInfos();
	if( ^nPrinters <= 0 )
	{
	  NO_PRINTER:
		::Alert( "v^[CXg[Ă܂I" );
		return;
	}

	if( ^SetupCurPrinter( ::LastPrinterName ) == #FALSE )
		^CurPrinter = ^GetDefaultPrinter();
	if( ! ^CurPrinter )
		goto NO_PRINTER;
#pc	^CurPrinter.DevMode.dmDeviceName;

#pv	^DocFullName = ::Epsaly.GetFileName();
	::File.GetNamePart( ^DocFullName, , base_name'new!, ext_name'new! );
#pv	^DocMainName = base_name + ext_name;
	delete base_name, ext_name;

	^CurPage = 1;
	^CurScaleIndex = #DEF_SCALE;
	^ScaleList'DOUBLE(10) =
		{  0.25, 0.5, 0.75, 1.0, 1.5, 2.0, 2.5, 3.0, 3.5, 4.0  };

	^ArrowCursor = ::GK.Cursor( #IDC_ARROW );
	^WaitCursor = ::GK.Cursor( #IDC_WAIT );

	^DefWidgetFont = ::GK.Font( "lr oSVbN", 12, #SHIFTJIS_CHARSET, #VARIABLE_PITCH );

	class ^PrintViewWindow : ::GK.Window  {}
	class ^PrintStopWindow : ::GK.Window  {}
	class ^WaitingWindow   : ::GK.Window  {}
	class ^PagePrint  {}
	class ^PageImage : ::GK.Image, ^PagePrint  {}

	^WaitMsgBox'start()'yield;
	^SetupTextToPrint();
	^TextSetupDone? = #TRUE;
	if( ^WaitWnd )
		^WaitWnd.Close();
	'wake;
	'yield;
	if( ^TextSetupCancel? )
		goto FIN;

	^CurPrinter.[ SetPrinterCoord ]( #TRUE );
	^CurPrinter.[ SetPrinterFont ]( #TRUE );

	//^WhiteBrush = ::GK.Brush( #RGB(255,255,255) );
	^GreyBrush = ::GK.Brush( #RGB(192,192,192) );
	//^BlackPen = ::GK.Pen( #RGB(0,0,0) );
	^DotPen = ::GK.Pen( #RGB(0,0,0), #PS_DOT );

	^SetupOuterFormat();

#pv	^MainWnd = ^PrintViewWindow();
	^MainWnd.Open();
	::GK.WindowMsgLoop();

#pv	::LastPrintSpecName = ^CurSpec.dl;

  FIN:
	delete ^MainWnd;
	delete ^PreviewFont, ^DotPen, ^GreyBrush;
	delete ^DefWidgetFont;
	delete ^CurPrinter;
	delete ^PrintFont;
	#pc	"I";
	return;

  OnError:
	print ::ErrorMessage( $err_code, $err_info ), $err_func;
	goto FIN;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^WaitMsgBox()
{
	'sleep( 500 );
	if( ! ^TextSetupDone? )
	{
		^WaitWnd = ^WaitingWindow();
		^WaitWnd.Open();
		::GK.SetParaProc( #TRUE );
		::GK.WindowMsgLoop();
		::GK.SetParaProc( #FALSE );
		delete ^WaitWnd;
	}
}

function  ^WaitMsgThread()
{
	'sleep( 500 );
	if( ! ^TextSetupDone? )
	{
		^WaitWnd = ^WaitingWindow();
		^WaitWnd.Open();
	}
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.Construct()
{
	.[ ::GK.Window.Construct ]( .WindowTitle() );
}

function ^PrintViewWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.WindowTitle()
{
	return ^DocMainName + " -- " #PROGRAM_NAME " ( " + ::LastPrinterName + " )";
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.OnCreate()
{
	#pc	"OnCreate";

	.DefWidgetFont := ^DefWidgetFont;

	R1 = ::GK.Rect( 10, 4, 72, 24 );					//uJnv
	R2 = ::GK.Rect( R1.Xo + R1.Xd + 12,  5, 140, 200 );	// R{{bNX
	R3 = ::GK.Rect( R2.Xo + R2.Xd + 10,  4,  68,  24 );	//uj[v
	R4 = ::GK.Rect( R3.Xo + R3.Xd +  4, 10,  72,  12 );	// y[W\
	R5 = ::GK.Rect( R4.Xo + R4.Xd +  6,  8, 140,  16 );	// y[WXC_[
	R6 = ::GK.Rect( R5.Xo + R5.Xd +  4, 10,  48,  12 );	// {\
	R7 = ::GK.Rect( R6.Xo + R6.Xd +  6,  8, 120,  16 );	// {XC_[

#pv	.PrintBtn = .AddButton( "push", "...", R1 );
	.PrintBtn.OnCommand =
		function() { .owner.SetFocus(); .owner.OnPrintButton(); };

#pv	.SpecList = .AddComboBox( , R2 );
	.SpecList.OnCommand =
		function() { .owner.SetFocus(); .owner.OnSpecSelect(); };
	.SpecList.SetItemYd( 14 );
	do ^EnumPrintSpecName( this ) with name { .SpecList.Add( name ); };
	.SpecList.Select( ^CurSpec.Index );

#pv	.MenuBtn = .AddButton( "push", "j[", R3, #WS_EX_STATICEDGE );
	.MenuBtn.OnCommand =
		function() { .owner.SetFocus(); .owner.OnMenuButton(); };

#pv	.PageLabel = .AddLabel( "", R4, "right" );

#pv	.PageSlide = .AddScrollBar( "H", R5 );
	.PageSlide.OnScroll = function( act, pos ) { .owner.OnPageSlide( act, pos ); };

#pv	.ScaleLabel = .AddLabel( "", R6, "right" );

#pv	.ScaleSlide = .AddScrollBar( "H", R7 );
	.ScaleSlide.OnScroll = function( act, pos ) { .owner.OnScaleSlide( act, pos ); };
	.ScaleSlide.SetRange( #MIN_SCALE, #MAX_SCALE );
//	.ScaleSlide.SetPageSize( 1 );
	.OnScaleSlide( -1 );

	R := ::GK.NullRect;

#pv	.HScrBar = .AddScrollBar( "H", R );
	.HScrBar.OnScroll = function( act, pos ) { .owner.OnHScroll( act ); };

#pv	.VScrBar = .AddScrollBar( "V", R );
	.VScrBar.OnScroll = function( act, pos ) { .owner.OnVScroll( act ); };

#pv	.Menu = ::GK.Menu();
	if( ^nPrinters >= 1 )
	{
#pv		.SubMenu = ::GK.Menu();
		for( i = 0 ; i < ^nPrinters ; i++ )
		{
			.SubMenu.InsertItem( #CMD_SEL_PRINTER_BASE + i,
					^DevMode[i].dmDeviceName );
		}
		.Menu.InsertMenu( .SubMenu, "v^[I" );
		.Menu.InsertSeparator();
	}
	.Menu.InsertItem( #CMD_EDIT_PRINT_SPEC  , "dlݒ" );
	.Menu.InsertItem( #CMD_UPDATE_PRINT_SPEC, "dlXV" );
	.Menu.InsertSeparator();
	.Menu.InsertItem( #CMD_RESET_PRINT_TEXT , "̓ǂݍݒ" );
	.Menu.InsertSeparator();
	.Menu.InsertItem( #CMD_SHOW_HELP_TEXT   , "wv" );

	^S_Xdpi = .gc.GetCaps( #LOGPIXELSX );
	^S_Ydpi = .gc.GetCaps( #LOGPIXELSY );

	.S_Page = ^PageImage();
	.S_Page.DrawPage( ^CurPage );

	.PageSlide.SetRange( 1, ^MaxPage );
	.OnPageSlide( -1 );

	.Scr_Xo = -9999;
	.Scr_Yo = -9999;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd;

	.ToolBarRect = ::GK.Rect( 0, 0, .gc.Xd, 32 );

	.FrameRect = ::GK.Rect( 0, .ToolBarRect.Yd, .gc.Xd, .gc.Yd - .ToolBarRect.Yd );
	if( .FrameRect.Xd < 0 )  .FrameRect.Xd = 0;
	if( .FrameRect.Yd < 0 )  .FrameRect.Yd = 0;

	.UpdateViewSize();
}

function ^PrintViewWindow.UpdateViewSize()
{
	VXo = .FrameRect.Xo + 2;
	VXd = .FrameRect.Xd - 4;
	if( VXd < 0 )
		VXd = 0;
	VYo = .FrameRect.Yo + 2;
	VYd = .FrameRect.Yd - 4;
	if( VYd < 0 )
		VYd = 0;

	SXd = .S_Page.V_Rect.Xd;
	SYd = .S_Page.V_Rect.Yd;

	MXd = VXd - SXd;		// DFhׂ̍Ev
	if( MXd < #MIN_MXd )
		MXd = #MIN_MXd;
	MYd = VYd - SYd;		// DFhׂ̏㉺v
	if( MYd < #MIN_MYd )
		MYd = #MIN_MYd;

	.HScrBar.Show? = ( VXd < SXd + MXd );
	.VScrBar.Show? = ( VYd < SYd + MYd );

	if( .HScrBar.Show? )
	{
		VYd -= #HSB_Yd;
		if( VYd < 0 )
			VYd = 0;
		MYd -= #HSB_Yd;
	}
	if( .VScrBar.Show? )
	{
		VXd -= #VSB_Xd;
		if( VXd < 0 )
			VXd = 0;
		MXd -= #VSB_Xd;
	}

	.Scr_Xmin = - MXd / 2;
	.Scr_Xmax = .Scr_Xmin + SXd + MXd;

	.Scr_Ymin = - MYd / 2;
	.Scr_Ymax = .Scr_Ymin + SYd + MYd;

	if( .HScrBar.Show? )
	{
		if( .Scr_Xo > .Scr_Xmax - VXd )
			.Scr_Xo = .Scr_Xmax - VXd;
		if( .Scr_Xo < .Scr_Xmin )
			.Scr_Xo = .Scr_Xmin;

		.HScrBarRect = ::GK.Rect( VXo, VYo + VYd, VXd, #HSB_Yd );
		.HScrBar.Move( .HScrBarRect );
		.HScrBar.SetRange( .Scr_Xmin, .Scr_Xmax );
		.HScrBar.SetPageSize( VXd );
		.HScrBar.SetPos( .Scr_Xo );
	}
	else	// XN[o[\Ȃꍇ
	{
		.Scr_Xo = .Scr_Xmin;
		.HScrBar.Move( ::GK.NullRect );
		delete .HScrBarRect;
	}

	if( .VScrBar.Show? )
	{
		if( .Scr_Yo > .Scr_Ymax - VYd )
			.Scr_Yo = .Scr_Ymax - VYd;
		if( .Scr_Yo < .Scr_Ymin )
			.Scr_Yo = .Scr_Ymin;

		.VScrBarRect = ::GK.Rect( VXo + VXd, VYo, #VSB_Xd, VYd );
		.VScrBar.Move( .VScrBarRect );
		.VScrBar.SetRange( .Scr_Ymin, .Scr_Ymax );
		.VScrBar.SetPageSize( VYd );
		.VScrBar.SetPos( .Scr_Yo );
	}
	else	// XN[o[\Ȃꍇ
	{
		.Scr_Yo = .Scr_Ymin;
		.VScrBar.Move( ::GK.NullRect );
		delete .VScrBarRect;
	}

	.ViewRect = ::GK.Rect( VXo, VYo, VXd, VYd );

	if( .HScrBar.Show?  &&  .VScrBar.Show? )
		.SizeGripRect = ::GK.Rect( VXo + VXd, VYo + VYd, #VSB_Xd, #HSB_Yd );
	else
		.SizeGripRect = ::GK.NullRect;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.OnPaint()
{
//	#pc	"OnPaint";

	Rc = ::GK.Rect();
	.GetHotRect( Rc );

	if( ! .ToolBarRect.Out?( Rc ) )
		.gc.DrawEdge( .ToolBarRect, 0, #BF_MIDDLE );

	if( ! .FrameRect.Out?( Rc ) )
		.gc.DrawEdge( .FrameRect, #EDGE_SUNKEN, #BF_RECT );

	if( ! .SizeGripRect.Out?( Rc ) )
		.gc.DrawFrameControl( .SizeGripRect, #DFC_SCROLL, #DFCS_SCROLLSIZEGRIP );

	Rv = .ViewRect;
	if( ! Rv.And( Rc ) )
		return;

	//if( ! ^TextSetupDone? )
	//{
	//	.gc.DrawEdge( Rv, 0, #BF_MIDDLE );
	//	.gc.SetTextColor( #RGB(0,0,0) );
	//	.gc.SetBackMode( #TRANSPARENT );
	//	.gc.DrawText( .ViewRect, "΂炭҂I" );
	//	return;
	//}

	src = Rv;
	src.Xo += .Scr_Xo - .ViewRect.Xo;
	src.Yo += .Scr_Yo - .ViewRect.Yo;
	if( ! src.And( .S_Page.V_Rect ) )
	{
		.gc.SetBrush( ^GreyBrush );
		.gc.ClearRect( Rv );
		return;
	}

	dst = src;
	dst.Xo -= .Scr_Xo - .ViewRect.Xo;
	dst.Yo -= .Scr_Yo - .ViewRect.Yo;

	.S_Page.SaveDC();
	.S_Page.SetMapMode( #MM_TEXT );
	.gc.CopyImage( .S_Page, dst, src );
	.S_Page.RestoreDC();

	R1 = ::GK.Region( Rv );
	R2 = ::GK.Region( dst );
	switch( R1 -= R2 )
	{
	  case #COMPLEXREGION:
	  case #SIMPLEREGION:
		.gc.FillRegion( R1, ^GreyBrush );
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.OnHScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Xo = .Scr_Xmin;						break;
	  case #SB_LINEUP:		Xo = .Scr_Xo - .ViewRect.Xd / 24;	break;
	  case #SB_PAGEUP:		Xo = .Scr_Xo - .ViewRect.Xd;		break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Xo = .HScrBar.GetSlidePos();		break;

	  case #SB_LINEDOWN:	Xo = .Scr_Xo + .ViewRect.Xd / 24;	break;
	  case #SB_PAGEDOWN:	Xo = .Scr_Xo + .ViewRect.Xd;		break;
	  case #SB_BOTTOM:		Xo = .Scr_Xmax;						break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;
	}

	if( Xo > .Scr_Xmax - .ViewRect.Xd + 1 )
		Xo = .Scr_Xmax - .ViewRect.Xd + 1 ;
	if( Xo < .Scr_Xmin )
		Xo = .Scr_Xmin;

	if(( dx = .Scr_Xo - Xo ) != 0 )
	{
		.Scr_Xo = Xo;
		.HScrBar.SetPos( Xo );
		.Scroll( dx, 0, .ViewRect );
		.Update();
	}
//	#pc	"HScroll", act, Xo;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.OnVScroll( act )
{
	switch( act )
	{
	  case #SB_TOP:			Yo = .Scr_Ymin;						break;
	  case #SB_LINEUP:		Yo = .Scr_Yo - .ViewRect.Yd / 24;	break;
	  case #SB_PAGEUP:		Yo = .Scr_Yo - .ViewRect.Yd;		break;

	  case #SB_THUMBPOSITION:
	  case #SB_THUMBTRACK:
							Yo = .VScrBar.GetSlidePos();		break;

	  case #SB_LINEDOWN:	Yo = .Scr_Yo + .ViewRect.Yd / 24;	break;
	  case #SB_PAGEDOWN:	Yo = .Scr_Yo + .ViewRect.Yd;		break;
	  case #SB_BOTTOM:		Yo = .Scr_Ymax;						break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;
	}

	if( Yo > .Scr_Ymax - .ViewRect.Yd + 1 )
		Yo = .Scr_Ymax - .ViewRect.Yd + 1;
	if( Yo < .Scr_Ymin )
		Yo = .Scr_Ymin;

	if(( dy = .Scr_Yo - Yo ) != 0 )
	{
		.Scr_Yo = Yo;
		.VScrBar.SetPos( Yo );
		.Scroll( 0, dy, .ViewRect );
		.Update();
	}
//#pc	"VScroll", act, Yo, Ys;
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnMouseWheel( x, y, d )
{
	( X, Y ) = .ScreenToClient( x, y );
	//#pc	"OnMouseWheel: " : X, Y, d ;

	if( .HScrBar.Show?  &&  .HScrBarRect.InPnt?( X, Y ) )
		func := .OnHScroll;
	else if( .VScrBar.Show? )
		func := .OnVScroll;
	else
		return;

	if(( D = d ) > 0 )
		while(( D -= #WHEEL_DELTA / 3 ) >= 0 )
			.[ func ]( #SB_LINEUP );
	else
		while(( D += #WHEEL_DELTA / 3 ) <= 0 )
			.[ func ]( #SB_LINEDOWN );
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnPrintButton()
{
	#pc	"OnPrintButton";

	PD ::=
	{
		.Flags = #PD_PAGENUMS | #PD_COLLATE | #PD_NOSELECTION | 
					#PD_USEDEVMODECOPIESANDCOLLATE | #PD_RETURNDC;
		.nFromPage = 1;
		.nToPage = ^MaxPage;
		.nMinPage = 1;
		.nMaxPage = ^MaxPage;
		.nCopies = 1;
		.DevMode = ^CurPrinter.DevMode;
		.DevMode ::=
		{
			if( ^CurSpec.p.Ki )
			{
				.dmFields = #DM_ORIENTATION | #DM_PAPERSIZE;
				.dmOrientation = ^CurSpec.p.;
				.dmPaperSize = ^CurSpec.p.id;
			}
			else	// KiȌꍇ
			{
				.dmFields = #DM_PAPERLENGTH | #DM_PAPERWIDTH;
				.dmPaperLength = ^CurSpec.p.'int * 10;   // P: 0.1 mm
				.dmPaperWidth  = ^CurSpec.p.'int * 10;   // P: 0.1 mm
			}
		}
	}

	if( ! .PrintDialog( PD ) )
	{
		#pc	"PrintDialog: ": ::GK.CommDlgExtendedError(), PD.DevMode.dmDeviceName;
		return;
	}

	if( ! PD.DevMode'exist? )
	{
		#pc	"PD.DevMode ȂI";
		goto DO_PRINT;
	}

	if( PD.DevMode.dmDeviceName != ^CurPrinter.DevMode.dmDeviceName )
	{
		if( .MessageBox( 
			"̃v^Avr[Ƃ͈قȂ܂I\n"
			"̂܂܈sȂĂ낵łH",
			"", #MB_ICONQUESTION | #MB_YESNO ) != #IDYES )
			return;
		.UpdateCurPrinter( PD.DevMode.dmDeviceName );
	}

	if( ^CurSpec.p.Ki )
	{
		if(( PD.DevMode.dmFields & ( #DM_ORIENTATION | #DM_PAPERSIZE )) != 0  &&
			 PD.DevMode.dmOrientation == ^CurSpec.p.  &&
			 PD.DevMode.dmPaperSize == ^CurSpec.p.id )
			goto DO_PRINT;
	}
	else	// KiȌꍇ
	{
		if(( PD.DevMode.dmFields & ( #DM_PAPERLENGTH | #DM_PAPERWIDTH )) != 0  &&
			 PD.DevMode.dmPaperLength == ^CurSpec.p.'int * 10  &&  // P: 0.1 mm
			 PD.DevMode.dmPaperWidth  == ^CurSpec.p.'int * 10 )    // P: 0.1 mm
			goto DO_PRINT;
	}

	if( .MessageBox( 
		"v^̗pAdl̃TCYƈقȂ܂I\n"
		"̂܂܈sȂĂ낵łH",
		"", #MB_ICONQUESTION | #MB_YESNO ) != #IDYES )
		return;

  DO_PRINT:
	#pc	PD.hDC'x, PD.Flags'b(8);
	#pc	PD.nFromPage, PD.nToPage, PD.nMinPage, PD.nMaxPage, PD.nCopies;

	Printer = ::GK.Printer( PD.hDC );
	Printer'inherit( ^PagePrint );
	Printer.[ ^SetPrinterCoord ]( #FALSE );

	Font = ::GK.Font( ^CurSpec.tHg.,
		^Round( ^CurSpec.tHg.TCY * 20.0 )'int,
		^CurSpec.tHg.n, ^CurSpec.tHg.sb` );
	Printer.TextFont := Font;
	Printer.SetFont( Font );
	Printer.GetFontInfo();

	Printer.SetupPage();

  // vg~_CA[O\
	.GetWindowRect( R'new! );
	AbortDlg = ^PrintStopWindow( R.Xo + R.Xd / 2, R.Yo + R.Yd / 2 );
	AbortDlg.Printer := Printer;
	AbortDlg.Open();

  // v^֏o
	.Disable();
	Printer.SetAbortMonitor();
	if( Printer.StartDoc( ^DocMainName + "̈" ) <= 0 )
		goto ERR_2;

	if(( PD.Flags & #PD_COLLATE ) != 0 )	// SłRs[H
	{
		for( n = 0 ; n < PD.nCopies ; n++ )
		{
			for( i = PD.nFromPage ; i <= PD.nToPage ; i++ )
			{
				if( Printer.IsToAbort )			goto END_DOC;
				if( Printer.StartPage() <= 0 )	goto ERR_1;
				Printer.DrawPage( i );
				if( Printer.EndPage() <= 0 )	goto ERR_1;
			}
		}
	}
	else	// ełƂɃRs[ꍇ
	{
		for( i = PD.nFromPage ; i <= PD.nToPage ; i++ )
		{
			for( n = 0 ; n < PD.nCopies ; n++ )
			{
				if( Printer.IsToAbort )			goto END_DOC;
				if( Printer.StartPage() <= 0 )	goto ERR_1;
				Printer.DrawPage( i );
				if( Printer.EndPage() <= 0 )	goto ERR_1;
			}
		}
	}
  END_DOC:
	Printer.EndDoc();
	Error? = #FALSE;
	goto FIN;

  ERR_1:
	Printer.EndDoc();
  ERR_2:
	Error? = #TRUE;
	//goto FIN;

  FIN:
  // vg~_CA[O
	if( AbortDlg.hWnd != null )
		AbortDlg.Close();

	delete Printer;
	delete Font;
	.Enable();

	if( Error? )
	{
		.MessageBox( "ŃG[܂I",
			"", #MB_ICONERROR | #MB_OK );
	}
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PrintViewWindow.UpdateCurPrinter( PrinterName )
{
	if( ^SetupCurPrinter( PrinterName ) )
	{
		^CurPrinter.[ SetPrinterCoord ]( #TRUE );
		^CurPrinter.[ SetPrinterFont ]( #FALSE );
		.SetTitle( .WindowTitle() );
		.S_Page.DrawPage( ^CurPage );
		.InvalidateRect( .ViewRect );
		.Update();
	}
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnMenuButton()
{
	#pc	"OnMenuButton";
	.PopupMenu( .Menu );
}

function ^PrintViewWindow.OnMenu( id )
{
	#pc	"OnMenu: " : id;
	.Update();

	switch( id )
	{
	  case #CMD_EDIT_PRINT_SPEC:
		::Epsaly.OpenFile( "/Tx /d /zS " +
				( ::Module.FilePath() + $"\PrintSpec.txt" )'quote );
		break;

	  case #CMD_UPDATE_PRINT_SPEC:
		SpecName = ^CurSpec.dl;
		if( ^ReadPrintSpecFile() != #OK )
			break;
		.SpecList.Empty();
		do ^EnumPrintSpecName( this ) with name { .SpecList.Add( name ); };
		^CurSpec := ^FindPrintSpec( SpecName );
		.SpecList.Select( ^CurSpec.Index );
		.UpdateToNewSpec();
		break;

	  case #CMD_RESET_PRINT_TEXT:
		if( ^TextSetupThread'start() )
		{
			.SetClassLong( #GCL_HCURSOR, ^WaitCursor.hCursor );
			^WaitCursor.Change();
			::GK.SetParaProc( #TRUE );
			.Disable();
		}
		break;

	  case #CMD_SHOW_HELP_TEXT:
		::Epsaly.OpenFile( "/Tx /d /zS /C80 /L24 /k80 /-TFS3DNwtzne " +
				( ::Module.FilePath() + $"\PrintHelp.txt" )'quote );
		break;

	  default:
		.UpdateCurPrinter( 
			^DevMode[ id - #CMD_SEL_PRINTER_BASE ].dmDeviceName );
		break;
	}
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage", iMsg;

	if( iMsg == #WM_APP_TEXT_SETUP_DONE )
	{
		delete ^WaitWnd;
		^CurPage = 1;
		.S_Page.DrawPage( ^CurPage );
		.InvalidateRect( .ViewRect );
		.OnVScroll(  #SB_TOP );
		.OnHScroll(  #SB_TOP );
		.Update();
		.PageSlide.SetRange( 1, ^MaxPage );
		.OnPageSlide( -1 );

		.SetClassLong( #GCL_HCURSOR, ^ArrowCursor.hCursor );
		.Enable();
		::GK.SetForegroundWindow( .hWnd );
		::GK.SetParaProc( #FALSE );
	}
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnSpecSelect()
{
	#pc	"OnSpecSelect", .SpecList.GetText(), .SpecList.GetCurSel();

	new_spec := ^FindPrintSpec( .SpecList.GetCurSel() );
	if( new_spec == null  ||  ^CurSpec == new_spec )
	{
		#pc "dl̕ύXȂ";
		return;
	}

	^CurSpec := new_spec;
	.UpdateToNewSpec();
}

function ^PrintViewWindow.UpdateToNewSpec()
{
	.SetClassLong( #GCL_HCURSOR, ^WaitCursor.hCursor );
	^SeekPageTopLines();
	.SetClassLong( #GCL_HCURSOR, ^ArrowCursor.hCursor );

	^CurPage = 1;
//	^CurScaleIndex = #DEF_SCALE;

	^CurPrinter.[ ^SetPrinterFont ]( #TRUE );

	.Scr_Xo = -9999;
	.Scr_Yo = -9999;

	.UpdatePageView();

	.PageSlide.SetRange( 1, ^MaxPage );
	.OnPageSlide( -1 );
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.UpdatePageView()
{
	delete .S_Page;
	.S_Page = ^PageImage();
	.S_Page.DrawPage( ^CurPage );
	.UpdateViewSize();
	.InvalidateRect( .ViewRect );
	.Update();
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnPageSlide( act, slide_pos )
{
	switch( act )
	{
	  case #SB_TOP:			v = 1;				break;
	  case #SB_LINEUP:		v = ^CurPage - 1;	break;
	  case #SB_PAGEUP:		v = ^CurPage - 2;	break;

	  case #SB_ENDSLIDE:
	  case #SB_SLIDING:		v = .PageSlide.GetSlidePos();	break;

	  case #SB_PAGEDOWN:	v = ^CurPage + 2;	break;
	  case #SB_LINEDOWN:	v = ^CurPage + 1;	break;
	  case #SB_BOTTOM:		v = ^MaxPage;		break;

	  case #SB_ENDSCROLL:
	  default:				return;		//goto END;

	  case -1:				v = ^CurPage;   goto SET_POS;
	}

	v = #CUT( 1, v, ^MaxPage );
	if( v != ^CurPage )
	{
		^CurPage = v;
		.S_Page.DrawPage( ^CurPage );
		.InvalidateRect( .ViewRect );
		.Update();
	  SET_POS:
		.PageSlide.SetPos( v );
		.PageLabel.SetTitle( ": " + v'd + " / " + ^MaxPage'd );
	}
	//#pc	"OnPageSlide", act, v;
}

//-----------------------------------------------------------------------------

function ^PrintViewWindow.OnScaleSlide( act, slide_pos )
{
	switch( act )
	{
	  case #SB_TOP:			v = #MIN_SCALE;				break;
	  case #SB_LINEUP:		v = .ScaleSlide.pos - 1;	break;
	  case #SB_PAGEUP:		v = .ScaleSlide.pos - 2;	break;

	  case #SB_ENDSLIDE:  //v = slide_pos;				break;
	  case #SB_SLIDING:		v = slide_pos;				break;

	  case #SB_PAGEDOWN:	v = .ScaleSlide.pos + 2;	break;
	  case #SB_LINEDOWN:	v = .ScaleSlide.pos + 1;	break;
	  case #SB_BOTTOM:		v = #MAX_SCALE;				break;

	  default:				v = #DEF_SCALE;				break;

	  case #SB_ENDSCROLL:
		if(( v = .ScaleSlide.pos ) != ^CurScaleIndex )
		{
			^CurScaleIndex = v;
			.UpdatePageView();
		}
		goto END;
	}

	v = #CUT( #MIN_SCALE, v, #MAX_SCALE );
	.ScaleSlide.SetPos( v );
	.ScaleLabel.SetTitle( ( ^ScaleList( v ) * 100 )'g + " %" );
  END:  ;
	//#pc	"OnScaleSlide", act, v;
}

//=============================================================================

function  ^TextSetupThread()
{
	#pc "TextSetupThread -- started";
	^TextSetupDone? = #FALSE;
	^WaitMsgThread'start();
	^SetupTextToPrint();
	^TextSetupDone? = #TRUE;
	if( ^WaitWnd )
		^WaitWnd.Close();
	'wake;
	'yield;
	if( ! ^TextSetupCancel? )
	{
		^MainWnd.Enable();
		^MainWnd.PostMessage( #WM_APP_TEXT_SETUP_DONE, 0, 0 );
	}
	else
		^MainWnd.Close();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetupTextToPrint()
{
	delete ^TextBuff;
	^TextBuff = ::Buffer();

	e := ::Epsaly;
	if( e.GetSelType() <= 0 )	// I͈͂ȂH
	{
		^TextBuff.Write( e.GetFullText() );
		e.GetFullCn( ^LineCn'new! );		// es̕R[h
		N = ^MaxLines = ^LineCn'size / 2;	// S\s
		^LineCi'ULONG( N + 1 );				// es̊JnCfbNX
		n = 0;
		for( i = 0 ; i < N ; i++ )
		{
			^LineCi(i) = n;
			n += ^LineCn(i);

			if( 'yield  &&  ^TextSetupCancel? )
				break;
		}
		^LineCi(i) = n;
	}
	else	// I͈͂ꍇ
	{
		^TextBuff.Write( e.GetSelText() );

		( MinLi, MaxLi ) = e.GetSelRange( 0 );
		N = ^MaxLines = MaxLi - MinLi + 1;

		^LineCn'USHORT( N );		// es̕R[h
		^LineCi'ULONG( N + 1 );		// es̊JnCfbNX
		bn = ( e.GetSelType() == 3 ) ? 2 : 0;	// `͈͑IȂesI[ǉ
		n = 0;
		for( i = 0 ; i < N ; i++ )
		{
			^LineCi(i) = n;
			n += ( ^LineCn(i) = e.GetSelCn( MinLi + i ) + bn );

			if( 'yield  &&  ^TextSetupCancel? )
				break;
		}
		^LineCi(i) = n;
	}

	^LineNo'LONG( N );		// \sCfbNX  _sԍ ւ̕ϊ\
	^LineNo(0) = 1;
	n = 1;					// _sԍ
	T := ^TextBuff;
	T.Find( $"\r#1|\n#1|\f#2", 0 );
	for( i = 1 ; i < N ; i++ )
	{
		T.Seek( ^LineCi( i - 1 ) * 2 );
		T.Find( , ^LineCn( i - 1 ) * 2 );

		switch( T.FoundID() )
		{
		  case 1:	// OssR[hŏI[Ăꍇ
			^LineNo(i) = ++n;
			break;

		  case 2:	// Osɉy[WR[h܂܂Ăꍇ
			^LineNo(i) = -( ++n );
			continue;

		  default:	// Os܂ԂsisR[hȂj̏ꍇ
			^LineNo(i) = 0;
			break;
		}
		if( 'yield  &&  ^TextSetupCancel? )
			break;
	}
	^LineNoDigs = ( n >= 1 ) ? ( ::Math.log10( n )'int + 1 ) : 1 ;

	^MaxDigs = e.MaxColumn();
	^TabDigs = e.TabColumn();

	^SeekPageTopLines();
	return;

  OnError:
	#pc	"OnError";
	print ::ErrorMessage( $err_code, $err_info ), $err_func;
	^TextSetupCancel? = #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SeekPageTopLines()
{
	^WaitCursor.Change();

	delete ^PageTopLi;

	N = ^MaxLines;			// ős
	^PageTopLi[1] = 0;		// Ŕԍ  ̕ł̐擪̕\sCfbNX ւ̕ϊ\
	^PageLines = ^CurSpec.i'int * ^CurSpec.s'int;		// Pœ̍s
	k = ^PageLines;
	^MaxPage = 1;
	for( i = 1 ; i < N ; i++ )
	{
		if( ^LineNo(i) < 0 )	// y[WH
		{
			^PageTopLi[ ++^MaxPage ] = i;
			k = ^PageLines;
			continue;
		}
		if( --k <= 0 )
		{
			^PageTopLi[ ++^MaxPage ] = i;
			k = ^PageLines;
		}
	}
	^PageTopLi[ ^MaxPage + 1 ] = N;

	^ShowLineNo? = ^CurSpec.sԍ;
	^ArrowCursor.Change();
}

//=============================================================================

function ^PageImage.Construct()
{
	scale = ^ScaleList( ^CurScaleIndex );
	.VXd = ^Round( ^CurSpec.p. / 25.4 * ^S_Xdpi * scale )'int;
	.VYd = ^Round( ^CurSpec.p. / 25.4 * ^S_Ydpi * scale )'int;

	// ̃[foCXReLXg\z
	.[ ::GK.Image.Construct ]( , .VXd, .VYd, 1 );
	.MemDev? = #TRUE;

	.WXd = ^Round( ^CurSpec.p. * #K )'int;
	.WYd = ^Round( ^CurSpec.p. * #K )'int;

#pc	"PageImage: " : ^CurSpec.dl, scale, "hDC=": .hdc'x, "WXd=": .WXd, "WYd=": .WYd, "VXd=": .VXd, "VYd=": .VYd;

	.SetMapMode( #MM_ANISOTROPIC );
	.SetWindowExt( .WXd, .WYd );
	.SetViewportExt( .VXd, .VYd );

	delete ^PreviewFont;
	^PreviewFont = ::GK.Font( ^CurSpec.tHg.,
		^Round( ^CurSpec.tHg.TCY * 20.0 )'int,
		^CurSpec.tHg.n, ^CurSpec.tHg.sb` );
	.TextFont := ^PreviewFont;
	.SetFont( .TextFont );

	.GetFontInfo();
#pc	.FontInfo.Name, .FontInfo.AveCharWidth, .FontInfo.Height;

	.SetupPage();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^PageImage.Destruct()
{
	.[ ::GK.Image.Destruct ]();
}

//-----------------------------------------------------------------------------

function ^PagePrint.SetupPage()
{
	.V_Rect = ::GK.Rect( 0, 0, .VXd, .VYd );
	.W_Rect = ::GK.Rect( 0, 0, .WXd, .WYd );

	L_MXd = ^Round( ^CurSpec.]. * #K )'int;
	R_MXd = ^Round( ^CurSpec.].E * #K )'int;
	U_MYd = ^Round( ^CurSpec.]. * #K )'int;
	D_MYd = ^Round( ^CurSpec.]. * #K )'int;

	HeaderYd = ^Round( ^CurSpec.wb_[. * #K )'int;
	FooterYd = ^Round( ^CurSpec.tb^[. * #K )'int;

	TextXd = .WXd - L_MXd - R_MXd;
	TextYd = .WYd - U_MYd - D_MYd - HeaderYd - FooterYd;

	.HeaderRect = ::GK.Rect( L_MXd, U_MYd, TextXd, HeaderYd );
	.FooterRect = ::GK.Rect( L_MXd, .WYd - D_MYd - FooterYd, TextXd, FooterYd );

	.TextRect = ::GK.Rect( L_MXd, U_MYd + HeaderYd, TextXd, TextYd );

	N = ^CurSpec.i'int;
	L = ^CurSpec.s'int;

	GapXd = ^Round( ^CurSpec.i * #K )'int;
	DivXd = ( TextXd - GapXd * ( N - 1 )) / N;
	Xo = L_MXd;

	for( k = 0 ; k < N ; k++ )
	{
		.LineXo[ k ] = Xo;

		Yo = U_MYd + HeaderYd +
				(( TextYd'float / L - .FontInfo.Height ) / 2 )'int;

		for( i = 0 ; i < L ; i++ )
			.LineYo[ k ][ i ] = Yo + ( i'float * TextYd / L )'int;

		Xo += DivXd + GapXd;
	}

	.DivLines = L;
	.PageDivs = N;

	^OuterSubst.["&P"] = ^MaxPage'd;

	DefValue = #DT_CENTER;
	.HeaderAlign = ^OuterAlignMode[ ^CurSpec.wb_[.zu'part ]
						 | ( #DT_TOP | #DT_NOPREFIX | #DT_SINGLELINE );
	.FooterAlign = ^OuterAlignMode[ ^CurSpec.tb^[.zu'part ]
						 | ( #DT_BOTTOM | #DT_NOPREFIX | #DT_SINGLELINE );

#pc	"PagePrint.Setup: " : .HeaderAlign'x, .FooterAlign'x;
}

//-----------------------------------------------------------------------------

function ^PagePrint.DrawPage( PageNo )
{
	.SetMapMode( #MM_TEXT );
	.ClearRect( .V_Rect, #RGB(255,255,255) );

	.SetMapMode( #MM_ISOTROPIC );
	.SetWindowExt( .WXd, .WYd );
	.SetViewportExt( .VXd, .VYd );
	.SetFont( .TextFont );

//	.ClearRect( .W_Rect, #RGB(255,255,255) );

	if( ! ^TextBuff )
		return;
	if( PageNo <= 0  ||  PageNo > ^MaxPage )
		return;

	CharXd = ^CurPrinter.FontInfo.AveCharWidth;

	switch( ^TabDigs'type )
	{
	  default:			// ̑
		^TabDigs = 8;
	  case "integer":	// l
		TabXc'LONG( 1 ) = {  ^TabDigs * CharXd  };
		break;

	  case "array":		// z
		N = ^TabDigs'count;
		M = 256;
		TabXc'LONG( M );
		n = 0;
		for( i = 0 ; i < N ; i++ )
			TabXc( i ) = ( n += ^TabDigs( i ) ) * CharXd;
		d = ^TabDigs( N - 1 );
		for( ; i < M ; i++ )
			TabXc( i ) = ( n += d ) * CharXd;
		break;
	}

	//.SetPen( ^BlackPen );
	//.SetBrush( ^WhiteBrush );
	.SetTextColor( #RGB(0,0,0) );
	.SetBackColor( #RGB(255,255,255) );
	.SetBackMode( #TRANSPARENT );
	.SetTextAlign( #TA_LEFT | #TA_TOP );

	Li = ^PageTopLi[ PageNo ];
	LimLi = ^PageTopLi[ PageNo + 1 ];

	for( k = 0 ; k < .PageDivs ; k++ )
	{
		LXo = TXo = .LineXo[ k ];
		if( ^ShowLineNo? )
			TXo += CharXd * ( ^LineNoDigs + 2 );

		for( i = 0 ; i < .DivLines ; i++, Li++ )
		{
			if( Li >= LimLi )   goto PAGE_TEXT_END;;

			LYo = .LineYo[k][i];

			if( ^ShowLineNo?  &&  ^LineNo( Li ) != 0 )
				.DrawChars( LXo, LYo,
					::Math.abs( ^LineNo( Li ) )'d's( ^LineNoDigs ),
					, , ^CurPrinter.Dx );

			if( text'USHORT( ^LineCn( Li ) ) == null )
				continue;
			^TextBuff.Seek( ^LineCi( Li ) * 2 );
			^TextBuff.Read( text );
			line = text'gets'mend( ` `, " +---" );

			.DrawString( TXo, LYo, line, TabXc, TXo );
		}
	}
	PAGE_TEXT_END:

	//.SetPen( ^DotPen );
	//.FrameRect( .HeaderRect );
	//.FrameRect( .FooterRect );

	DefValue = "";
	^OuterSubst.["&p"] = PageNo'd;

#pc	"HeaderText: " :
	HeaderText = ^CurSpec.wb_[.e'subst( "@(&[pPfFYMDhms&])", "@1", , ^OuterSubst );
	if( HeaderText )
		.DrawText( .HeaderRect, HeaderText, .HeaderAlign );

#pc	"FooterText: " :
	FooterText = ^CurSpec.tb^[.e'subst( , "@1", , ^OuterSubst );
	if( FooterText )
		.DrawText( .FooterRect, FooterText, .FooterAlign );
}

//-----------------------------------------------------------------------------

function  ^PagePrint.DrawTestPage()
{
	.SetMapMode( #MM_TEXT );
	.ClearRect( .V_Rect, #RGB(255,255,255) );

	.SetMapMode( #MM_ANISOTROPIC );
	.SetWindowExt( .WXd, .WYd );
	.SetViewportExt( .VXd, .VYd );

//	.ClearRect( .W_Rect, #RGB(255,255,255) );

	R = .W_Rect;
	d = .W_Rect.Xd / 100;
	for( i = 0 ; i < 20 ; i++ )
	{
		R.Xo += d;
		R.Yo += d;
		R.Xd -= 2 * d;
		R.Yd -= 2 * d;
		.FrameRect( R );
	}

	.DrawText( .W_Rect, "̓eXgvgp̕łI" );

	.MoveTo( 0, 0 );
	.LineTo( .V_Rect.Xd / 2, .V_Rect.Yd / 2 );

	.DrawText( .V_Rect, "̓eXgvgp̕łI" );
}

//=============================================================================

function  ^GetDefaultPrinter()
{
	PD.Flags = #PD_RETURNDC | #PD_RETURNDEFAULT;
	if( ! ::GK.Window.PrintDialog( PD )  ||  PD.hDC == null )
		return null;

//	p = ::GK.Printer( PD.hDC );
	p = ::GK.Graphics( PD.hDC );
	p.DevMode <- PD.DevMode;
#pv	::LastPrinterName = p.DevMode.dmDeviceName;
	return p;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetupCurPrinter( PrinterName )
{
	if( PrinterName != null  &&
		^CurPrinter.DevMode.dmDeviceName != PrinterName )
	{
		for( i = 0 ; i < ^nPrinters ; i++ )
		{
			if( ^DevMode[i].dmDeviceName == PrinterName )
				goto FOUND;
		}
	}
	return #FALSE;

  FOUND:
	hdc = ::GK.CreateDC( #NULL, PrinterName, #NULL, #NULL );
	if( ! hdc )
		return #FALSE;
	delete ^CurPrinter;
//	^CurPrinter = ::GK.Printer( hdc );
	^CurPrinter = ::GK.Graphics( hdc );
	^CurPrinter.DevMode := ^DevMode[i];
#pv	::LastPrinterName = PrinterName;
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^EnumPrinterInfos()
{
	delete ^DevMode;
	^nPrinters = 0;

#pv	Winspool = ::DLL.Link( "Winspool.drv", "sys" );
#pv	EnumPrinters = Winspool.GetEntry( "EnumPrintersW" );

#set	PRINTER_ENUM_LOCAL			0x00000002
#set	PRINTER_ENUM_CONNECTIONS	0x00000004

	dwNeeded = 0;
	dwReturned = 0;

	EnumPrinters( 
		#PRINTER_ENUM_LOCAL | #PRINTER_ENUM_CONNECTIONS,
		#NULL, 2, "", 0, dwNeeded'addr, dwReturned'addr );
#pc	dwNeeded, dwReturned;

	if( dwNeeded <= 0 )
		goto FIN;

	PRINTER_INFO_2 ::=		// PRINTER_INFO_2'size == 84
	{
		.pServerName		'ULONG;
		.pPrinterName		'ULONG;
		.pShareName			'ULONG;
		.pPortName			'ULONG;
		.pDriverName		'ULONG;
		.pComment			'ULONG;
		.pLocation			'ULONG;
		.pDevMode			'ULONG;
		.pSepFile			'ULONG;
		.pPrintProcessor	'ULONG;
		.pDatatype			'ULONG;
		.pParameters		'ULONG;
		.pSecurityDescriptor'ULONG;
		.Attributes			'ULONG;
		.Priority			'ULONG;
		.DefaultPriority	'ULONG;
		.StartTime			'ULONG;
		.UntilTime			'ULONG;
		.Status				'ULONG;
		.cJobs				'ULONG;
		.AveragePPM			'ULONG;
	}

#pc	PRINTER_INFO_2'size;
#pv	pri2_buf = ::Buffer( dwNeeded + 1024 );

#pv	EnumPrinters( 
		#PRINTER_ENUM_LOCAL | #PRINTER_ENUM_CONNECTIONS,
		#NULL, 2, pri2_buf, dwNeeded,
		dwNeeded'addr, dwReturned'addr );
#pc	dwNeeded, dwReturned;

	pri2_buf.Size( dwNeeded );
	pri2_buf.Seek(0);

	for( i = 0 ; i < dwReturned ; i++ )
	{
		pri2_buf.Read( PRINTER_INFO_2 );
		#pc	PRINTER_INFO_2.pPrinterName'ps, PRINTER_INFO_2.pDevMode'x(8);

		DEVMODE ::=		// DEVMODE'size == 148
		{
			.dmDeviceName		'T(32);			// TCHAR [ CCHDEVICENAME ]
			.dmSpecVersion		'USHORT;
			.dmDriverVersion	'USHORT;;
			.dmSize				'USHORT;
			.dmDriverExtra		'USHORT;
			.dmFields			'ULONG;
			.dmOrientation		'SHORT;
			.dmPaperSize		'SHORT;
			.dmPaperLength		'SHORT;
			.dmPaperWidth		'SHORT;
			.dmScale			'SHORT;
			.dmCopies			'SHORT;
			.dmDefaultSource	'SHORT;
			.dmPrintQuality		'SHORT;
			.dmColor			'SHORT;
			.dmDuplex			'SHORT;
			.dmYResolution		'SHORT;
			.dmTTOption			'SHORT;
			.dmCollate			'SHORT;
			.dmFormName			'T(32);			// TCHAR [ CCHFORMNAME ]
			.dmLogPixels		'USHORT;
			.dmBitsPerPel		'ULONG;
			.dmPelsWidth		'ULONG;
			.dmPelsHeight		'ULONG;
			.dmDisplayFlags		'ULONG;
			.dmDisplayFrequency	'ULONG;
			.dmICMMethod		'ULONG;
			.dmICMIntent		'ULONG;
			.dmMediaType		'ULONG;
			.dmDitherType		'ULONG;
			.dmReserved1		'ULONG;
			.dmReserved2		'ULONG;
		}
		dm = ::Buffer( DEVMODE'size, PRINTER_INFO_2.pDevMode );
		if( dm )
		{
			dm.Read( DEVMODE );
		}
		else	// PRINTER_INFO_2.pDevMode ꍇAftH[gݒ
		{
			DEVMODE.dmDeviceName = PRINTER_INFO_2.pPrinterName'ps;
			DEVMODE.dmFields = #DM_ORIENTATION | #DM_PAPERSIZE;
			DEVMODE.dmOrientation = #DMORIENT_LANDSCAPE;
			DEVMODE.dmPaperSize = #DMPAPER_A4;
		}
		#pc	DEVMODE.dmDeviceName, DEVMODE.dmSize, DEVMODE.dmPaperSize, DEVMODE.dmOrientation;
		^DevMode[i] <- DEVMODE;
		^nPrinters++;
		delete dm;
	}
  FIN:
	#pc	"v^F " : ^nPrinters;
	delete	Winspool;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetPrinterProperties( PrinterName )
{
#pv	Winspool = ::DLL.Link( "Winspool.drv", "sys" );
#pv	OpenPrinter = Winspool.GetEntry( "OpenPrinterW" );
#pv	PrinterProperties = Winspool.GetEntry( "PrinterProperties" );
#pv	ClosePrinter = Winspool.GetEntry( "ClosePrinter" );

	hPrint = #NULL;
	if( OpenPrinter( PrinterName, hPrint'addr, #NULL ) )
	{
		PrinterProperties( #NULL, hPrint );
 		ClosePrinter( hPrint );
	}
	delete	Winspool;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetPrinterCoord( self? )
{
	.Xdpi = .GetCaps( #LOGPIXELSX );
	.Ydpi = .GetCaps( #LOGPIXELSY );
	#pc	"v^F Xdpi=" : .Xdpi, "Ydpi=" : .Ydpi;

	.VXd = .GetCaps( #HORZRES );
	.VYd = .GetCaps( #VERTRES );
	#pc "v^F VXd=" : .VXd, "VYd=" : .VYd;

	if( self? )  // [hWnv^̉𑜓xŌ߂H
	{
		.WXd = ^Round( 1440 * .VXd / .Xdpi )'int;
		.WYd = ^Round( 1440 * .VYd / .Ydpi )'int;
	}
	else	// [hWnpTCYɂꍇ
	{
		.WXd = ^Round( ^CurSpec.p. * #K )'int;
		.WYd = ^Round( ^CurSpec.p. * #K )'int;
	}
	#pc	"v^F WXd=" : .WXd, "WYd=" : .WYd;

	.SetMapMode( #MM_ANISOTROPIC );
	.SetWindowExt( .WXd, .WYd );
	.SetViewportExt( .VXd, .VYd );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetPrinterFont( Init? )
{
	if( Init? )
	{
		.ResetPaintConds();
		delete ^PrintFont;
		^PrintFont = ::GK.Font( 
			^CurSpec.tHg.,
			^Round( ^CurSpec.tHg.TCY * 20.0 )'int,
			^CurSpec.tHg.n,
			^CurSpec.tHg.sb` );
	}
	.TextFont := ^PrintFont;
	.SetFont( .TextFont );
	.GetFontInfo();

	N = ^MaxDigs + 8;
	.Dx'LONG( N );
	CharXd = .FontInfo.AveCharWidth;
	for( i = 0 ; i < N ; i++ )
		.Dx(i) = CharXd;

	#pc	"v^tHg: ", .FontInfo.Name, .FontInfo.AveCharWidth, .FontInfo.Height;
}

//=============================================================================

function ^PrintStopWindow.Construct( Xc, Yc )
{
	#pc	"PrintStopWindow - Construct";
	Xd = 240;
	Yd = 110;
	Xo = Xc - Xd / 2;
	Yo = Yc - Yd / 2;
	.[ ::GK.Window.Construct ]( "", Xo, Yo, Xd, Yd,
		#WS_POPUP | #WS_VISIBLE | #WS_CAPTION | #WS_DLGFRAME | #WS_SYSMENU , 0 );
}

function ^PrintStopWindow.OnCreate()
{
	#pc	"PrintStopWindow - OnCreate";

	.DefWidgetFont := ^DefWidgetFont;

	( X, Y ) = .GetClientSize();
	.EdgeRect = ::GK.Rect( 0, 0, X, Y );
	.LabelRect = ::GK.Rect( 0, 15, X, 24 );

	R = ::GK.Rect( ( X - 80 ) / 2, 50, 80, 24 );
	.AbortBtn = .AddButton( "push", "~", R );
	.AbortBtn.OnCommand = 
		function() {  .owner.SetFocus();  .owner.AbortPrint();  };
}

function ^PrintStopWindow.OnPaint()
{
	#pc	"PrintStopWindow -- OnPaint";
	.gc.DrawEdge( .EdgeRect, 0, #BF_MIDDLE );
	//.gc.DrawEdge( .EdgeRect, #EDGE_RAISED, #BF_RECT | #BF_MIDDLE );

	.gc.SetFont( .DefWidgetFont );
	.gc.SetBackMode( #TRANSPARENT );
	.gc.SetTextColor( ::GK.GetSysColor( #COLOR_WINDOWTEXT ) );
	.gc.DrawText( .LabelRect, ^DocMainName + " ł..." );
}

function ^PrintStopWindow.AbortPrint()
{
	#pc	"PrintStopWindow -- AbortPrint";
	.Printer.IsToAbort = #TRUE;
	.Close();
}

//=============================================================================

function  ^SetupPrintSpecs()
{
	^PaperSize ::=
	{
		.["A3"]     ::= {  . = 297;  . = 420;  .id = #DMPAPER_A3;  }
		.["A4"]     ::= {  . = 210;  . = 297;  .id = #DMPAPER_A4;  }
		.["A5"]     ::= {  . = 148;  . = 210;  .id = #DMPAPER_A5;  }
		.["B4"]     ::= {  . = 257;  . = 364;  .id = #DMPAPER_B4;  }
		.["B5"]     ::= {  . = 182;  . = 257;  .id = #DMPAPER_B5;  }
		.["͂"] ::= {  . = 100;  . = 148;  .id = #DMPAPER_JAPANESE_POSTCARD;  }
	}

	^FontIndex ::=
	{
		.["SHIFT-JIS"] = #SHIFTJIS_CHARSET;
		.["ANSI"] = #ANSI_CHARSET;
		.["Œ蕝"] = #FIXED_PITCH;
		.["ϕ"] = #VARIABLE_PITCH;
	}
	^FontChset ::=
	{
		.[""] = #DEFAULT_CHARSET;
		.[#SHIFTJIS_CHARSET] = #SHIFTJIS_CHARSET;
		.[#ANSI_CHARSET] = #ANSI_CHARSET;
	}
	^FontPitch ::=
	{
		.[""] = #DEFAULT_PITCH;
		.[#FIXED_PITCH] = #FIXED_PITCH;
		.[#VARIABLE_PITCH] = #VARIABLE_PITCH;
	}

	//if( ! ::PrintSpec )
		^ReadPrintSpecFile();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^EnumPrintSpecName( s, func )
{
	#pc s'name, func;
	n = 0;
	for( p := ::PrintSpec'first ; p'ref? ; p := ::PrintSpec'next )
	{
		if( ! p.dl )   continue;

		n++;
		s.[ func ]( p.dl );
	}
	return n;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^FindPrintSpec( id )
{
	if( id'type == "integer" )
	{
		if(( p := ::PrintSpec'first( id )) != null )
			return p;
	}
	else if( id'type == "string" )
	{
		for( p := ::PrintSpec'first ; p'ref? ; p := ::PrintSpec'next )
		{
			if( p.dl == id )
				return p;
		}
	}
	return ::PrintSpec'first;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function  ^SetupOuterFormat()
{
	^OuterAlignMode ::=
		{  .[""] = #DT_LEFT;  .[""] = #DT_CENTER;  .["E"] = #DT_RIGHT;  };

	::GetTime( Y'new!, M'new!, D'new!, , h'new!, m'new!, s'new! );

	^OuterSubst ::=
	{
		.["&p"] = "";				// ŔԍiŐݒj
		.["&P"] = "";				// SŐ@i   V   j
		.["&f"] := ^DocMainName;	// t@C
		.["&F"] := ^DocFullName;	// t@C̃tpX
		.["&Y"] = Y'd(2);			// N
		.["&M"] = M'd(2);			// 
		.["&D"] = D'd(2);			// 
		.["&h"] = h'd(2);			// 
		.["&m"] = m'd(2);			// 
		.["&s"] = s'd(2);			// b
		.["&&"] = "&";				// & g
	}
}

//-----------------------------------------------------------------------------

function  ^ReadPrintSpecFile()
{
	DefValue = "";

	// dlt@C̓eobt@ɓǂݍ
	file = ::File.Open( ::Module.FilePath() + $"\PrintSpec.txt", "in" );
	if( file == null )
	{
	  OnFileError:
		if( ^MainWnd )
			^MainWnd.MessageBox( 
				"dlt@C PrintSpec.txt ܂I",
				#PROGRAM_NAME, #MB_ICONERROR | #MB_OK );
		else
			::Alert( "dlt@C PrintSpec.txt ܂I" );

		if( ::PrintSpec'exist? )
			return #OK;
		::PrintSpec'cbox!;
		goto NO_PRINT_SPEC;
	}
	buf = ::Buffer();
	buf.Write( file );
	delete file;
	buf.Seek(0);
	buf.Decode( "auto" );

	// dl̃f[^폜
	::PrintSpec'cbox!'empty!;

	// Rg̏
	buf.Seek(0);
	for( bn = buf.Find( "#:/*:|#://:" ) ; bn > 0 ; bn = buf.Find() )
		buf.Replace( bn, "\n" );

	//#pd	call PRINT_BUF_TEXT;

	// dl̉
	N = 0;
	buf.Seek(0);
	'match( $"\s*,\s*" );     // K\̎Oݒ
	for( bn = buf.Find( ##^\s*@([^\sF:]+)[F:]@(.*)\n## ) ;
		 bn > 0 ;
		 bn = buf.FindNext() )
	{
		cmd = buf.FoundText(1);
		//#pc	buf.FoundText(2);

		pn = buf.FoundText(2)'split( , pv'new! );

		for( i = 0 ; i < pn ; i++ )
			pv[i] = pv[i]'trim'dequote;

		switch( cmd )
		{
		  case "dl":
			if( spec.Index'exist? )		// O̎dlH
				call CHECK_AND_POST_SPEC;
			else
				spec'cbox!'empty!;
			spec.Index = N++;
			spec.dl = ( pn > 0  &&  pv[0] ) ?
					pv[0] : "dl(%d)"'fmt( N );
			call SET_DEFAULT_SPEC;
			continue;

		  case "p":
			spec.p ::=
			{
				if( pn <= 0 )
					;
				else if( p := ^PaperSize[ pv[0] ] )   // KipH
				{
					.Ki = p'name;
					. = p.;
					. = p.;
					.id = p.id;
					if( pn >= 2  &&  pv[1] == "" )
					{
						. = #DMORIENT_LANDSCAPE;
						tmp = .,  . = .,  . = tmp;
					}
					else
						. = #DMORIENT_PORTRAIT;
				}
				else if( pn <= 1 )
					;
				else if(( px = pv[0]'float ) > 0  &&    // KiOpH
						( py = pv[1]'float ) > 0 )
				{
					.Ki = "";
					. = #CUT( 50, px, 420 );
					. = #CUT( 50, py, 420 );
					.id = 0;
					. = ( . <= . ) ?
							#DMORIENT_PORTRAIT : #DMORIENT_LANDSCAPE;
				}
			}
			continue;

		  case "]":
			switch( pn )
			{
			  default:	if( pn <= 0 )	break;
			  case 4:	spec.]. = ^Cut( 0, pv[3]'float, 100 );
			  case 3:	spec.]. = ^Cut( 0, pv[2]'float, 100 );
			  case 2:	spec.].E = ^Cut( 0, pv[1]'float, 100 );
			  case 1:	spec.]. = ^Cut( 0, pv[0]'float, 100 );
			}
			continue;

		  case "tHg":
			switch( pn )
			{
			  default:	if( pn <= 0 )	break;
			  case 4:	spec.tHg.sb` = ^FontPitch[ ^FontIndex[ pv[3] ] ];
			  case 3:	spec.tHg.n = 
								^FontChset[ ^FontIndex[ pv[2]'upper ] ];
			  case 2:	spec.tHg.TCY = ^Cut( 4, pv[1]'float, 48 );
			  case 1:	spec.tHg. = pv[0];
			}
			continue;

		  case "s":	if( pn > 0 )  spec.s = ^Cut( 1, pv[0]'int, 200 );   continue;
		  case "i":	if( pn > 0 )  spec.i = ^Cut( 1, pv[0]'int, 4 );     continue;
		  case "i":	if( pn > 0 )  spec.i = ^Cut( 0, pv[0]'float, 100 ); continue;

		  case "sԍ":
			if( pn > 0  &&  pv[0] == "L" )   spec.sԍ = #TRUE;
			continue;

		  case "wb_[":
			switch( pn )
			{
			  default:	if( pn <= 0 )	break;
			  case 3:	spec.wb_[.e = pv[2];
			  case 2:	spec.wb_[.zu = pv[1];
			  case 1:	spec.wb_[.   = ^Cut( 0, pv[0]'float, 200 );
			}
			continue;

		  case "tb^[":
			switch( pn )
			{
			  default:	if( pn <= 0 )	break;
			  case 3:	spec.tb^[.e = pv[2];
			  case 2:	spec.tb^[.zu = pv[1];
			  case 1:	spec.tb^[.   = ^Cut( 0, pv[0]'float, 200 );
			}
			continue;
		}
	}
	if( spec.Index'exist? )		// O̎dlH
		call CHECK_AND_POST_SPEC;

	if( N <= 0 )	// dl̓o^ȂH
	{
	  NO_PRINT_SPEC:
		spec'cbox!'empty!;
		spec.Index = 0;
		spec.dl = "ftH[gdl";
		call SET_DEFAULT_SPEC;
		call POST_PRINT_SPEC;
	}

	#pd	call DUMP_ALL_SPECS;
	return #OK;


  SET_DEFAULT_SPEC:
	spec ::=
	{
		.p ::= {  .Ki = "A4"; . = #DMORIENT_PORTRAIT;
					 . = 210; . = 297; .id = #DMPAPER_A4;  }
		.] ::= {  . = 20;  .E = 15;  . = 15;  . = 15;  }
		.tHg ::= {  . = "lr ";  .TCY = 10.0;
						 .n = #SHIFTJIS_CHARSET;
						 .sb` = #FIXED_PITCH;  }
		.s = 60;
		.i = 1;
		.i = 10;
		.wb_[ ::= {  . = 0;  .zu = "E";  .e = "";  }
		.tb^[ ::= {  . = 0;  .zu = "";  .e = "";  }
	}
	back;

  CHECK_AND_POST_SPEC:
	scope spec
	{
		k = ( .]. + .].E + .i * ( .i - 1 )) * 2.0 / .p.;
		if( k > 1.0 )	// E]ƒiԂ̍vp̔𒴂H
		{
			.]. /= k;
			.].E /= k;
			.i /= k;
		}

		k = ( .]. + .]. + .wb_[. + .tb^[. ) * 2.0 / .p.;
		if( k > 1.0 )	// ㉺]ƃwb_[ƃtb^[̍vp̔𒴂H
		{
			.]. /= k;
			.]. /= k;
			.wb_[. /= k;
			.tb^[. /= k;
		}
	}
  POST_PRINT_SPEC:
	::PrintSpec'post( spec );
	back;

#pd  DUMP_ALL_SPECS:
#pd	for( p := ::PrintSpec'first ; p'ref? ; p := ::PrintSpec'next )
#pd	{
#pd		#p	"dl: "	 : p.dl ;
#pd		#p	"p: "	 : p.p.Ki, p.p., p.p., p.p., p.p.id ;
#pd		#p	"]: "	 : p.]., p.].E, p.]., p.]. ;
#pd		#p	"tHg: " : p.tHg., p.tHg.TCY,
#pd						   p.tHg.n, p.tHg.sb` ;
#pd		#p	"s: "	 : p.s ;
#pd		#p	"i: "	 : p.i ;
#pd		#p	"i: "	 : p.i ;
#pd		#p	"wb_[: " : p.wb_[., p.wb_[.zu, p.wb_[.e ;
#pd		#p	"tb^[: " : p.tb^[., p.tb^[.zu, p.tb^[.e ;
#pd		#p;
#pd	}
#pd	back;

#pd  PRINT_BUF_TEXT:
#pd	buf.Seek(0);
#pd	buf.Find( "#]" );
#pd	#p	buf.SkippedText();
#pd	back;
}

//-----------------------------------------------------------------------------

function  ^Cut( min, v, max )
{
	if( v < min )	return min;
	if( v > max )	return max;
	return v;
}

//=============================================================================

function ^WaitingWindow.Construct()
{
	#pc	"WaitingWindow - Construct";
	Xd = 240;
	Yd = 110;
	Xo = ( ::GK.GetSystemMetrics( #SM_CXSCREEN ) - Xd ) / 2;
	Yo = ( ::GK.GetSystemMetrics( #SM_CYSCREEN ) - Yd ) / 2;

	.[ ::GK.Window.Construct ]( "vr[ ...", Xo, Yo, Xd, Yd,
		#WS_POPUP | #WS_VISIBLE | #WS_CAPTION | #WS_DLGFRAME | #WS_SYSMENU );
}

function ^WaitingWindow.OnCreate()
{
	#pc	"WaitingWindow - OnCreate";
	.DefWidgetFont := ^DefWidgetFont;

#pv	.AddLabel( "΂炭҂DDD",
				::GK.Rect( 0, 20, 240, 18 ), "center" );

#pv	.CancelBtn = .AddButton( "push", "LZ",
					::GK.Rect( 70, 50, 90, 24 ) );
	.CancelBtn.OnCommand = function() { ^TextSetupCancel? = #TRUE;  };
}

function ^WaitingWindow.OnPaint()
{
	#pc	"WaitingWindow -- OnPaint";
	.GetHotRect( R'new! );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

function ^WaitingWindow.OnClose()
{
	#pc	"WaitingWindow -- OnClose";
	return ^TextSetupDone? ? #OK : #NG ;
}

//-----------------------------------------------------------------------------
