//===============================================================================
//  GetFttpFile.mc : URL w̃t@C HTTP Ŏ擾
//===============================================================================

/*****/    // Cu[̃W[[hꍇ
//#include  <GkLib\GkDefs.mh>
//#include  <GkLib\GkSysDefs.mh>
#include  <NkLib\NkDefs.mh>

	if( //::Module.Include( "GkLibrary" ) > 0  &&
		::Module.Include( "NkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // NK Library ̃\[XCN[hꍇ
//#include  <GkLib\GkDefs.mh>
//#include  <GkLib\GkSysDefs.mh>
#include  <NkLib\NkLibrary.mc>

	//if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

/*****/   // fobOvgi[Xj
#set  pc	#comment
#set  pv
#set  ex	#comment
/*****/

/*****   // fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  ex
/*****/

#set  p		print

//=============================================================================

function  Main( argc, argv )
{
	#pc	"Jn";

	url_list =
	{
		"www.venus.dti.ne.jp/mw31/index.html",
		"www.venus.dti.ne.jp/mw31/apsaly/Overview.html",
		"www.yahoo.co.jp",
		"www.google.co.jp",
		"192.168.1.2/index.html",		// Local address on LAN
		"127.0.0.1/index.html",			// Loop-back address
	};

	URL = ::Input( "tqkF", url_list[0] , url_list );
	if( URL == null )
		goto FIN;

	if( URL'match( $"#i^(http://)?@([^/:]+)(:@(\d+))?@(|/.*)$",
				null, ServerName'new!, PortNo'new!, FileName'new! ) < 0  ||
		! ServerName )
	{
		#p	"Error: URL słI --- " : URL ;
		goto FIN;
	}

	PortNo = PortNo ? PortNo'int : 80 ;
	if( ! FileName )
		FileName = "/" ;

	#pc	"ServerName: " : ServerName;
	#pc	"FileName: " : FileName;
	#pc	"PortNo: " : PortNo;

	GetHttpFile( ServerName, FileName, PortNo );

  FIN:
	#pc	"I";
	;
}

//-----------------------------------------------------------------------------

function	GetHttpFile( ServerName, FileName, PortNo )
{
	if(( lpHostEntry = ::NK.gethostbyname( ServerName )) == #NULL )
	{
		#p	"Error #" + ::NK.WSAGetLastError()'d + ": zXg̎擾sI";
		return #NG;
	}
	ip_addr = ( lpHostEntry + 12 )'ULONG'pv'ULONG'pv'ULONG'pv;
		//  = *((LPIN_ADDR)*lpHostEntry->h_addr_list); ̈

	Socket = ::NK.Socket();
	if( ! Socket )
	{
		#p	"Error #" + ::NK.WSAGetLastError()'d + ": \Pbg̍쐬sI";
		return #NG;
	}

	if( Socket.Connect( ip_addr, PortNo ) == #SOCKET_ERROR )
	{
		#p	"Error #" + ::NK.WSAGetLastError()'d + ": ڑsI";
		//delete Socket;
		return #NG;
	}

	'CharEnc( "CP-1252" );

	#pv	request =
		"GET %s HTTP/1.0\r\n"
		"Host: %s:%d\r\n"			//  ꂪ DTI ŁA܂sȂ
	//	"User-Agent: Epsaly\r\n"
		"\r\n"
		'fmt( FileName, ServerName, PortNo );

	if( Socket.send( request, request'size, 0 ) == #SOCKET_ERROR )
	{
		#p	"Error #" + ::NK.WSAGetLastError()'d + ": MsI";
		//delete Socket;
		return #NG;
	}

	#set	RecvSize	(16*1024)
	RecvBuff = ::Buffer( #RecvSize * 4 );
	n = 0;
	rv = #OK;
	while(1)
	{
		RecvBuff.Seek( n );
		if( RecvBuff.Keep( #RecvSize ) <= 0 )
		{
			#p	"[܂I";
			quit;
		}

		switch( k = Socket.recv( RecvBuff, #RecvSize, 0 ))
		{
		  case #SOCKET_ERROR:
				#p	"Error #" + ::NK.WSAGetLastError()'d + ": MsI";
				rv = #NG;
				quit;

		  case 0:	// T[o[ڑꍇ
				#pc	"MI: total %d bytes\n" 'fmt( n );
				quit;

		  default:	// ɎMꍇ
				n += k;
				#pc	"Mnj: %d bytes" 'fmt( k );
				continue;
		}
	}
	delete Socket;


	RecvBuff.Size( n );
	RecvBuff.Seek( 0 );

	// MeLXgɕR[h̎w肪΁Aɏ
	#pv	'CharEnc( "UTF-8" );	// ܂AUTF-8 Ɖ
	'match( $/#i\<charset=@([\w\-]+)/ );
	enc = null;
	for( ln = 1 ; ln <= 20 ; ln++ )   // ŏ 20 ŝݑ
	{
		if( RecvBuff.Read( text'LN ) <= 0  ||
			text'match( , , enc ) >= 0 )
			break;
	}
	#pc	enc;
	if( enc )
		#pv	'CharEnc( enc );

	#pc	" Meij";

	// MeLXgPsvg
	RecvBuff.Seek( 0 );
	while( RecvBuff.Read( text'LN ) > 0 )
	{
		#p	text :- ;
	}

	#pc	" Mei܂Łj";
	return rv;
}

//-----------------------------------------------------------------------------
