//------------------------------------------------------------------
//  EBhE\Ă̒ "Hello, MikoScript!" ƕ`悷
//     iQljCharles Petzold   Programming Windows
//------------------------------------------------------------------

// fobOvgi[Xj
//#set  pc	#comment
//#set  pv
//#set  ex	#comment

// fobOvgLifobOj
#set  pc	print
#set  pv	print
#set  ex

#set  p		print

//-----------------------------------------------------------------------------

#set	NULL				0
#set	CS_VREDRAW			0x0001
#set	CS_HREDRAW			0x0002
#set	IDI_APPLICATION 	0x7F00
#set	IDC_ARROW			0x7F00
#set	WHITE_BRUSH			0
#set	SW_SHOWNORMAL		1

#set	WS_OVERLAPPED		0x00000000
#set	WS_CAPTION			0x00C00000
#set	WS_SYSMENU			0x00080000
#set	WS_THICKFRAME		0x00040000
#set	WS_MINIMIZEBOX		0x00020000
#set	WS_MAXIMIZEBOX		0x00010000

#set	WS_OVERLAPPEDWINDOW		#WS_CAPTION | #WS_SYSMENU | #WS_THICKFRAME | \
								#WS_MINIMIZEBOX | #WS_MAXIMIZEBOX

#set	CW_USEDEFAULT		0x80000000

	#pc	"Jn";

	#pv	^Kernel32 = ::DLL.Link( "KERNEL32", "sys" );
	#pv	^User32 = ::DLL.Link( "USER32", "sys" );
	#pv	^Gdi32 = ::DLL.Link( "GDI32", "sys" );
	
	#pv	^RegisterClassEx = ^User32.GetEntry( "RegisterClassExW" );
	#pv	^UnregisterClass = ^User32.GetEntry( "UnregisterClassW" );
	#pv	^CreateWindowEx = ^User32.GetEntry( "CreateWindowExW" );
	#pv	^ShowWindow = ^User32.GetEntry( "ShowWindow" );
	#pv	^UpdateWindow = ^User32.GetEntry( "UpdateWindow" );
	#pv	^GetMessage = ^User32.GetEntry( "GetMessageW" );
	#pv	^TranslateMessage = ^User32.GetEntry( "TranslateMessage" );
	#pv	^DispatchMessage = ^User32.GetEntry( "DispatchMessageW" );
	#pv	^BeginPaint = ^User32.GetEntry( "BeginPaint" );
	#pv	^GetClientRect = ^User32.GetEntry( "GetClientRect" );
	#pv	^DrawText = ^User32.GetEntry( "DrawTextW" );
	#pv	^EndPaint = ^User32.GetEntry( "EndPaint" );
	#pv	^PostQuitMessage = ^User32.GetEntry( "PostQuitMessage" );
	#pv	^DefWindowProc = ^User32.GetEntry( "DefWindowProcW" );
	#pv	^LoadIcon = ^User32.GetEntry( "LoadIconW" );
	#pv	^LoadCursor = ^User32.GetEntry( "LoadCursorW" );
	#pv	^SetForegroundWindow = ^User32.GetEntry( "SetForegroundWindow" );
	#pv	^GetStockObject = ^Gdi32.GetEntry( "GetStockObject" );
	#pv	^GetModuleHandle = ^Kernel32.GetEntry( "GetModuleHandleW" );
	#pv	^GetLastError = ^Kernel32.GetEntry( "GetLastError" );
	#pv	^FormatMessage = ^Kernel32.GetEntry( "FormatMessageW" );
	
	#pv	::DLL.SetCallback( ^WndProc );

	hInstance = ^GetModuleHandle( 0 );
	lpClassName = "HelloWindow";
	lpWindowTitle = "HelloWin";

	POINT ::=
	{
		.x		'LONG;
		.y		'LONG;
	}

	RECT ::=
	{
		.left	'LONG;
		.top	'LONG;
		.right	'LONG; 
		.bottom	'LONG;
	}

	MSG ::=
	{
		.hwnd		'ULONG;
		.message	'ULONG;
		.wParam		'ULONG;
		.lParam		'ULONG;
		.time		'ULONG;
		.pt			= POINT;
	}

	WNDCLASSEX ::=
	{
		.cbSize			'ULONG;
		.style			'ULONG	= #CS_HREDRAW | #CS_VREDRAW;
		.lpfnWndProc	'ULONG	= ^WndProc'addr;
		.cbClsExtra		'LONG	= 0;
		.cbWndExtra		'LONG	= 0;
		.hInstance		'ULONG	= hInstance;
		.hIcon			'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
		.hCursor		'ULONG	= ^LoadCursor( 0, #IDC_ARROW );
		.hbrBackground	'ULONG	= ^GetStockObject( #WHITE_BRUSH );
		.lpszMenuName	'ULONG	= 0;
		.lpszClassName	'ULONG	= lpClassName'addr;
		.hIconSm		'ULONG	= ^LoadIcon( 0, #IDI_APPLICATION );
	}
	WNDCLASSEX.cbSize = WNDCLASSEX'size;

	PAINTSTRUCT ::=
	{
		.hdc			'ULONG; 
		.fErase			'LONG; 
		.rcPaint		= RECT;
		.fRestore		'LONG; 
		.fIncUpdate		'LONG;
		.rgbReserved	'BYTE(32); 
	}

	msg   = ::Buffer( MSG'size );
	^ps   = ::Buffer( PAINTSTRUCT'size );
	^rect = ::Buffer( RECT'size );

	wndclass = ::Buffer( WNDCLASSEX'size );
	wndclass.Write( WNDCLASSEX );
	wndclass.Seek(0);

	#pv	^UnregisterClass( lpClassName, hInstance );
	if( ^RegisterClassEx( wndclass ) == 0 )
	{
		#p	"EBhENX̓o^sI", ^GetLastError();
		goto FIN;
	}

	hWnd = ^CreateWindowEx(
				0,						// extended window style
				lpClassName,			// registered window class name
				lpWindowTitle,			// window title name
				#WS_OVERLAPPEDWINDOW,	// window style
				#CW_USEDEFAULT,			// horizontal position of window
				#CW_USEDEFAULT,			// vertical position of window
				#CW_USEDEFAULT,			// window width
				#CW_USEDEFAULT,			// window height
				#NULL,					// handle to parent or owner window
				#NULL,					// handle to menu, or child-window identifier
				hInstance,				// handle to application instance
				#NULL					// pointer to window-creation data
			);

	if( hWnd == 0 )
	{
		#p	"EBhE̍쐬sI", ^GetLastError();
		goto FIN;
	}

	^SetForegroundWindow( hWnd );
	^ShowWindow( hWnd, #SW_SHOWNORMAL );
	^UpdateWindow( hWnd );

	while( ^GetMessage( msg, #NULL, 0, 0 ))
	{
		^TranslateMessage( msg );
		^DispatchMessage( msg );
	}

FIN:
	#pc	"I";
	#pv	^UnregisterClass( lpClassName, hInstance );
	::DLL.ResetCallback( WndProc );

	delete	^Kernel32;
	delete	^User32;
	delete	^Gdi32;
	return;

//-----------------------------------------------------------------------------

#set	WM_CREATE		0x0001
#set	WM_DESTROY		0x0002
#set	WM_PAINT		0x000F

#set	DT_CENTER		0x00000001
#set	DT_VCENTER		0x00000004
#set	DT_SINGLELINE	0x00000020


function ^WndProc( hWnd, uMsg, wParam, lParam )
{
	switch( uMsg )
	{
	  case #WM_CREATE :
			#pc	"WM_CREATE";
			return 0;

	  case #WM_PAINT :
			hDC = ^BeginPaint( hWnd, ^ps );
			^GetClientRect( hWnd, ^rect );
			^DrawText( hDC, "Hello, MikoScript!", -1, ^rect,
					#DT_SINGLELINE | #DT_CENTER | #DT_VCENTER );
			^EndPaint( hWnd, ^ps );
			return 0;

	  case #WM_DESTROY :
			#pc	"WM_DESTROY";
			^PostQuitMessage(0);
			return 0;
	}
	return ^DefWindowProc( hWnd, uMsg, wParam, lParam );
}

