/*
===============================================================================
  MVoiceBox.mc :  MikoVoice mFp̃_CAO{bNX\
===============================================================================

	Copyright (C) 2015  Masahiko Watanabe

    Edition History:
	  2015.02.22  

-----------------------------------------------------------------------------*/

// GK Library ̃W[[h
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;

//-----------------------------------------------------------------------------

/*****/
// fobOvgi[Xj
#set  pc	#comment
#set  pv
/*****/

/*****
// fobOvgLifobOj
#set  pc	print
#set  pv	print
/*****/

#set  p		print
#set  pt	#comment

//-----------------------------------------------------------------------------

// _CAO{bNX̕\
#set	DLG_TITLE		"MikoVoice ̔mF"

// _CAO{bNX̕\`
#set	DlgXo		200		// ftH[g̍[ʒu
#set	DlgYo		100		// ftH[g̏[ʒu
#set	ViewXd		400		// NCAg̈̕
#set	ViewYd		320		// NCAg̈̍

// _CAO{bNX̃X^C
//#set	DlgStyle		#WS_POPUP | #WS_CAPTION | #WS_SYSMENU | #WS_DLGFRAME
#set	DlgStyle		#WS_OVERLAPPEDWINDOW
#set	DlgExtStyle		#WS_EX_DLGMODALFRAME


// e
#set  WM_APP_MVS_DONE	#WM_APP+1000	// o͊bZ[W

//=============================================================================

function	Main( argc, argv )
{
	#pc	"Jn";
	^DefValue = null;

	// MikoVoice  DLL N
	::File.GetNamePart( ::File.GetProgramPath(), ProgDir'new! );
	^MikoVoice = ::DLL.Link( ProgDir + $"Tools\MikoVoice.dll" );
	if( ! ^MikoVoice )
	{
		::Alert( "MikoVoice.dll AEpsaly  Tools tH_[ɂ܂I" );
		return;
	}
	^MikoVoiceOutSync  = ^MikoVoice.GetEntry( "MikoVoiceOutSync" );
	^MikoVoiceOutAsync = ^MikoVoice.GetEntry( "MikoVoiceOutAsync" );
	^MikoVoiceOutToBuf = ^MikoVoice.GetEntry( "MikoVoiceOutToBuf" );
	^MikoVoiceOutStop  = ^MikoVoice.GetEntry( "MikoVoiceOutStop" );
	^MikoVoiceOutGetVers = ^MikoVoice.GetEntry( "MikoVoiceOutGetVers" );

	#pc	"MikoVoice Version = " : ( ^MikoVoiceOutGetVers() / 100.0 )'f(2);


	class ^DlgBoxWnd : ::GK.Window	  {}

	^DlgBoxWnd.Construct();
	^DlgBoxWnd.Open();

	::GK.WindowMsgLoop();

	delete ^DlgBoxWnd;
	delete ^MikoVoice;
	#pc	"I";
}

//=============================================================================

function ^DlgBoxWnd.Construct()
{
	R = ::GK.Rect( 0, 0, #ViewXd, #ViewYd );
	.GetAdjRect( R, #TRUE, #DlgStyle, #DlgExtStyle );

	.[ ::GK.Window.Construct ]( 
		  #DLG_TITLE, #DlgXo, #DlgYo, R.Xd, R.Yd, #DlgStyle, #DlgExtStyle );

	.DlgBox? = #TRUE;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnCreate()
{
	#pc	"OnCreate : " : .gc.hdc'x(8);

	.DefWidgetFont =
		::GK.Font( "lr SVbN", 14, #SHIFTJIS_CHARSET, #FIXED_PITCH );

  // j[
	#set	CMD_SAVE			1001
	#set	CMD_END				1002
	#set	CMD_SPK_KONCHI		1201
	#set	CMD_SPK_HAJIME		1202
	#set	CMD_SPK_IKAGA		1203
	#set	CMD_SPK_TOKYO		1204
	#set	CMD_SPK_TONARI		1205
	#set	CMD_SPK_ATUINA		1206
	#set	CMD_SPK_HAIII		1207
	#set	CMD_SNG_OGAWA		1301
	#set	CMD_SNG_FURUSATO	1302
	#set	CMD_SNG_HOSHI		1303

	.menu1 = ::GK.Menu();
	.menu1.InsertItem( #CMD_SAVE, "ۑ..." );
	.menu1.InsertItem( #CMD_END,  "I" );

	.menu2 = ::GK.Menu();
	.menu2.InsertItem( #CMD_SPK_KONCHI, "ɂ" );
	.menu2.InsertItem( #CMD_SPK_HAJIME, "͂߂܂ĥ" );
	.menu2.InsertItem( #CMD_SPK_IKAGA,  "łH" );
	.menu2.InsertSeparator();
	.menu2.InsertItem( #CMD_SPK_TOKYO,  "" );
	.menu2.InsertItem( #CMD_SPK_TONARI, "ׂ̋q͗ǂ`Hq" );
	.menu2.InsertSeparator();
	.menu2.InsertItem( #CMD_SPK_ATUINA, "͏ȁi֐j" );
	.menu2.InsertItem( #CMD_SPK_HAIII,  "͂``H" );

	.menu3 = ::GK.Menu();
	.menu3.InsertItem( #CMD_SNG_OGAWA,	 "t̏" );
	.menu3.InsertItem( #CMD_SNG_FURUSATO,"̋iӂ邳Ɓj" );
	.menu3.InsertItem( #CMD_SNG_HOSHI,   "̐E" );

	.TopMenu = ::GK.TopMenu();
	.TopMenu.InsertMenu( .menu1, "t@C" );
	.TopMenu.InsertMenu( .menu2, " b " );
	.TopMenu.InsertMenu( .menu3, " ̂ " );

	.SetMenuBar( .TopMenu );
	//.DrawMenuBar();

  // GfBbg{bNX
	.AddLabel( "LeLXǵF", ::GK.Rect( 16, 16, 300, 18 ) );

	R = ::GK.Rect( 0, 0, 0, 0 );
	.EditBox = .AddEditBox( #ES_MULTILINE | #ES_AUTOVSCROLL | #ES_AUTOHSCROLL | 
				#ES_WANTRETURN | #WS_VSCROLL  | #WS_HSCROLL | #WS_TABSTOP, R );

  // {^
	.OutBtn = .AddButton( #BS_PUSHBUTTON | #WS_TABSTOP, " ", R );
	.StpBtn = .AddButton( #BS_PUSHBUTTON | #WS_TABSTOP, " ~", R );

	#set	BTN_OUT		800
	#set	BTN_STP		801
	.OutBtn.CtlId = #BTN_OUT;
	.StpBtn.CtlId = #BTN_STP;

  // ̑
	.OutCnt = 0;		// 
	.Ready? = #TRUE;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnSize()
{
	#pc	"OnSize : " : .gc.Xd, .gc.Yd, .Ready?;

	if( ! .Ready? )
		return;

	#set	EdtXo	20
	#set	EdtYo	40
	#set	BtnXd	80
	#set	BtnYd	28

	R = ::GK.Rect( #EdtXo, #EdtYo,
			( .gc.Xd - ( #EdtXo + #EdtXo ) )'cut( 200 ),
			( .gc.Yd - ( #EdtYo + 16 + #BtnYd + 16 ) )'cut( 100 ) );
	.EditBox.Move( R );

	X = (( .gc.Xd - #BtnXd * 2 ) / 8 )'cut( 0 );
	.OutBtn .Move( ::GK.Rect( 3*X, R.Yo + R.Yd +16, #BtnXd, #BtnYd ) );
	.StpBtn .Move( ::GK.Rect( 3*X + #BtnXd + 2*X, R.Yo + R.Yd +16, #BtnXd, #BtnYd ));
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnClose()
{
	#pc	"OnClose";
	#pc	"MikoVoiceOutStop() = ":
	^MikoVoiceOutStop( -1 );
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnMenu( id )
{
	#pc	"OnMenu : " : id;
	.Update();
	switch( id )
	{
	  case #CMD_SAVE:
		.SaveVoiceOutData();
		return;

	  case #CMD_END:
		.Close();
		return;

	  case #CMD_SPK_KONCHI:
		text = "[ɂ]";
		break;

	  case #CMD_SPK_HAJIME:
		text = ##\
P0 S3.4 [ P1 ߂]āAS3.5"
P0 S3.5 [ P1 ], S3.5 "
P0 S3.4 [ P1 ] s4.3 BP0
##;		break;

	  case #CMD_SPK_IKAGA:
		text = ##\
P1.5 S3 v-1 ^ S4 ł S4 P0 S5 H
##;		break;

	  case #CMD_SPK_TOKYO:
		text = ##\
*Sp1 *Te800
^[ P1 ^^[ ^Ƃ傫^^傭 P0
##;		break;

	  case #CMD_SPK_TONARI:
		text = ##\
*Sp1 *Te800
P0 ^ P1 ^̂^A
P0 ^悭 P1 ^^^ P0
##;		break;

	  case #CMD_SPK_ATUINA:
		text = ##\
!!  ͏Ȃi֐ANZgj
P0 [, P-1 P0 ^^ȁ[
##;		break;

	  case #CMD_SPK_HAIII:
		text = ##\
P1 S4.5  S4.5 P0  S1/8 [[[[[[[[[[[ P2 [[[[[ P6##;
		break;

	  case #CMD_SNG_OGAWA:
		text = ##\
!! t̏   쎌 CV   
*Te110 *Ks0
e4  g4 [ a4  g4  e4  g4  +c4  +c4  
a4  a4  g4  e4  c4  d4  e4  r4
e4  g4 [ a4  g4  e4  g4  +c4  +c4  
a4  a4  g4  e4  d4  e4  c4  r4
d4  e4 [ d4  g4  a4  a4  g4  a4 
+c4  +c4  b4  a4  g4  g4  e4  r4
e4  g4 [ a4  g4  e4  g4  +c4  +c4 
a4  a4  g4  e4  d4  e4  c4  r4
##;		break;

	  case #CMD_SNG_FURUSATO:
		text = ##\
!! ̋iӂ邳Ɓj 쎌 CV   
*Te80 *Ks1
g4  g4  g4  a6  b2  a4  b4  b4  +c4  +d8  r4
+c4  +d4  +e4  b6  +c2  b4  a4  a4  f4  g8  r4
a2  g2 [ a4  d4  g2  a2 [ b4  b4  
+c2  b2 [ +c6  +e2 [ +d2  +c2 [ b4  r4
+d4  +d4  +d4  g6  a2  b4  +c4  +c4  a4  g10  r2
##;		break;

	  case #CMD_SNG_HOSHI:
		text = ##\
!! ̐E   쎌 H   `[YER@[X
*Te88 *Ks-1
+c6  +c2  +d2  +c2  a2  f2  f8  d7  r1
c6  f2  a2  f2  +c2  a2  g10  r4 
+c6  +c2  +d2  +c2  a2  f2  f8  d7  r1
c6  f2  a2  g2  f2  e2  f10  r4 
g6  f#2  g2  a2  b2  g2  a8  +c6  r2
+d6  +d2  +c2  a2  b2  a2  g12  r4
+c6  +c2  +d2  +c2  a2  f2  f8  d6  r2
c6  f2  a2  g2  f2  e2  f12  r4
##;		break;

	  default:
		return;
	}
	.EditBox.SetText( text );
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnCommand( wParam, wcp )
{
	#pc	"OnCommand : " : wParam'x(8), wcp, wcp::CtlId;

	switch( wcp::CtlId )
	{
	  case #BTN_OUT:
		#pc	"MikoVoiceOutAsync() = ":
		^MikoVoiceOutAsync( .EditBox.GetText(),
				.hWnd, #WM_APP_MVS_DONE, ++.OutCnt );
		#pc	"Jn #": .OutCnt;
		break;

	  case #BTN_STP:
		#pc	"MikoVoiceOutStop() = ":
		^MikoVoiceOutStop( -1 );
		break;
	}
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnAppMessage( iMsg, wParam, lParam )
{
	#pc	"OnAppMessage : " : iMsg, wParam, lParam;
	switch( iMsg )
	{
	  case #WM_APP_MVS_DONE:
		#pc	"I #": wParam;
		break;
	}
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.SaveVoiceOutData()
{
	#pc	"SaveVoiceOutData";

  // ۑt@C擾
	if( .WavFilePath )
		::File.GetNamePart( .WavFilePath, SavDN'new!, SavFN'new!,  );
	else
		( SavDN, SavFN ) = ( ::File.GetCurPath(), "MVoice_" );

	SavFN += ".wav";

	OFN.Title = "f[^ۑt@C";
	OFN.FileSpec'USHORT( #MAX_PATH + 4 );
	OFN.FileSpec'puts( SavFN );
	OFN.InitialDir = SavDN;
	OFN.Filter'USHORT( 256 );
	i = 0;
	i += OFN.Filter'puts( "t@C(*.wav)", i ) + 1;
	i += OFN.Filter'puts( "*.wav", i ) + 1;
	i += OFN.Filter'puts( "S(*.*)", i ) + 1;
	i += OFN.Filter'puts( "*.*", i ) + 1;
	OFN.Flags =   #OFN_OVERWRITEPROMPT
				| #OFN_HIDEREADONLY
		//		| #OFN_NOCHANGEDIR
				| #OFN_ENABLESIZING
				| #OFN_PATHMUSTEXIST;
	if( ! .GetSaveFileName( OFN ) )
		return #FALSE;

	#pc	"ۑt@C = ": 
	.WavFilePath = OFN.FileSpec'gets;


  // wt@C։g`f[^

	#set	Fs	12000	// TvOg [Hz]
	wfh ::=		// wb_[
	{
		.cRiffId		'C(4)   = "RIFF";		// Riff chunk id ( = 'RIFF' )
		.nRiffSize		'ULONG;					// Riff chunk size ( = <file size> - 8 )
		.cWaveId		'C(4)   = "WAVE";		// = 'WAVE'

		.cFormatId		'C(4)   = "fmt ";		// format chunk id ( = 'fmt ' )
		.nFormatSize	'ULONG  = 16;			// format chunck size ( = 16 )
		.nFormatType	'USHORT = 1;			// format type ( =1: PCM )
		.nChannels		'USHORT = 1;			// number of channels ( =1: mono, =2:stereo )
		.nSamplesPerSec	'ULONG  = #Fs;			// sample rate [Hz] ( = 11025, 22050, or 44100 )
		.nAvgBytesPerSec'ULONG  = 1 * #Fs * 2;	// average data-transfer rate in bytes per second
		.nBlockAlign	'USHORT = 1 * 2;		// = nChannels * nBitsPerSample / 8 
		.nBitsPerSample	'USHORT = 16;			// # of bits of sampling data

		.cDataId		'C(4)   = "data";		// data chunk id ( = 'data' )
		.nDataSize		'ULONG;					// data chunk size
		//										// sampled PCM data area 
	}

	if( ::DLL.SetCallback( WavDatRec ) < 0 )
	{
		rv = #FALSE;
		goto FIN_0;
	}

	^file = ::File.Open( OFN.FileSpec'gets, "out" );
	^file.Seek( wfh'size );	// wb_[͌ŏ

	Bn =^MikoVoiceOutToBuf( .EditBox.GetText(), WavDatRec );
	if( Bn < 0 )
		goto OnFileError;

	wfh.nRiffSize = wfh'size + Bn - 8;
	wfh.nDataSize = Bn;
	#pc	"g`f[^oCg = ": Bn;

	^file.Seek( 0 );
	^file.Write( wfh );
	^file.Close();
	rv = #TRUE;

  FIN_1:
	delete ^file;
	::DLL.ResetCallback( WavDatRec );
  FIN_0:
	return rv;

  OnFileError:
	.MessageBox( ::ErrorMessage( $err_code, $err_info ),
		"f[^ۑt@C", #MB_ICONERROR | #MB_OK );
	rv = #FALSE;
	goto FIN_1;
}

//-----------------------------------------------------------------------------

function WavDatRec( bp, bn )
{
	#pc	"WavDatRec: ": bp'x(8), bn;
	if( bn > 0 )
	{
		if( ^file.Write( 'MEMBLK( bp, bn ) ) != bn )
		{
			return #FALSE;
		}
	}
	return #TRUE;
}

//-----------------------------------------------------------------------------

