/*
===============================================================================
  LRPronQuiz.mc :  p L  R ̔̈Ⴂ̕NCY
===============================================================================

	Copyright (C) 2008  Masahiko Watanabe

    Edition History:
      Ver.0.80  2008.06.07i GK Library: Rev.2008.02.29 gp j
      Ver.0.82  2009.02.12i GK Library: Rev.2009.02.03 gp j
      Ver.1.00  2012.12.14  UNICODE 

-----------------------------------------------------------------------------*/

#include  <Event.mh>

  // Xs[`GW̊mF
	switch( rv = ::Epsaly.Speak(0) )	// ݓǂݏグȂ璆f
	{
	  case -1:  ::Alert( "Xs[`GW@\Ă܂I" );
	  case -2:	return;
	  default:	if( rv >= 0 )	// H
					break;
				::Alert( "ǂݏグł܂I" );
				return;
	}

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set	p	print

//-----------------------------------------------------------------------------

#set  MAX_QUESTIONS		10		// P؂̏o萔
#set  SPEAK_TIMES		3		// e₲Ƃ̒Pꔭ

#set  Wnd_Xd	240		// EBhE
#set  Wnd_Yd	280		// EBhE

#set  BtnBarYd	38		// {^\̈̍
#set  BtnYd		24		// {^
#set  BtnYo		( .Yd - ( #BtnBarYd + #BtnYd ) / 2 )	// {^[ʒu

#set  BtnXd		80		// {^
#set  BtnXs		(( .Xd - 2 * #BtnXd ) / 3 )		// {^Ԃ̕
#set  BtnX1		#BtnXs							// P{^[ʒu
#set  BtnX2		( #BtnX1 + #BtnXd + #BtnXs )	// Q{^[ʒu

#set  SPEAK_TIMER_ID	123

//-----------------------------------------------------------------------------

function  ^Main( argc, argv )
{
	#pc	"Jn";
	^DefValue = null;
	^WidgetFont = ::GK.Font( 
		"lr oSVbN", 12, #SHIFTJIS_CHARSET, #VARIABLE_PITCH );

	class ^QuizWindow : ::GK.Window  {}

#pv	^MainWnd = ^QuizWindow();
	^MainWnd.Open();
	^MainWnd.ShowTopMsg();
	::GK.WindowMsgLoop();

  FIN:
	'sleep( 500 );
	delete ^MainWnd;
	delete ^WidgetFont;
	#pc	"I";
	return;

  OnError:
	print ::ErrorMessage( $err_code, $err_info );
	goto FIN;
}

//-----------------------------------------------------------------------------

function ^QuizWindow.Construct()
{
	Xd = #Wnd_Xd;
	Yd = #Wnd_Yd;
	Xo = ( ::GK.GetSystemMetrics( #SM_CXSCREEN ) - Xd ) / 2;
	Yo = ( ::GK.GetSystemMetrics( #SM_CYSCREEN ) - Yd ) / 2;

	.[ ::GK.Window.Construct ]( "L  R ̔NCY",
		Xo, Yo, Xd, Yd,
		#WS_POPUP | #WS_VISIBLE | #WS_CAPTION | #WS_DLGFRAME | #WS_SYSMENU );
}

function ^QuizWindow.Destruct()
{
	.[ ::GK.Window.Destruct ]();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^QuizWindow.OnCreate()
{
	#pc	"OnCreate";

	.DefWidgetFont := ^WidgetFont;

#pv	( .Xd, .Yd ) = .GetClientSize();

#pv	.EditBox = .AddEditBox( #WS_VSCROLL | //#ES_READONLY |
		#ES_MULTILINE | #ES_AUTOVSCROLL | #ES_AUTOHSCROLL | #ES_WANTRETURN,
		::GK.Rect( 0, 0, .Xd, .Yd - #BtnBarYd ) );

#pv	.L_Button = .AddButton( "push", "X^[g",
		::GK.Rect( #BtnX1, #BtnYo, #BtnXd, #BtnYd ) );
	.L_Button.OnCommand = function() { .owner.OnLButton(); };

#pv	.R_Button = .AddButton( "push", "LZ",
		::GK.Rect( #BtnX2, #BtnYo, #BtnXd, #BtnYd ) );
	.R_Button.OnCommand = function() { .owner.OnRButton(); };

	.IsStarted = #FALSE;
	.nRounds = 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^QuizWindow.OnClose()
{
	#pc	"OnClose";

	.StopSpeak();
	return 0;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^QuizWindow.OnMinMaxInfo( pMinMax )
{
	#pc	"OnMinMaxInfo";

	//MINMAXINFO ::=
	//{
	//	.Reserved		= POINT; 
	//	.MaxSize		= POINT; 
	//	.MaxPosition	= POINT; 
	//	.MinTrackSize	= POINT;
	//	.MaxTrackSize	= POINT;
	//}

  // EBhETCYύXłȂ悤
  //	.MinTrackSize  .MaxTrackSize ݒ肵ĕԂ
	P'LONG(4) = {  #Wnd_Xd, #Wnd_Yd, #Wnd_Xd, #Wnd_Yd  };
	( pMinMax + 3*4*2 )'memcpy( P'addr, 4*4 );
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^QuizWindow.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

//-----------------------------------------------------------------------------

function ^QuizWindow.OnLButton()
{
	#pc	"OnLButton";

	if( ! .IsStarted )
	{
		.L_Button.SetTitle( "L" );
		.R_Button.SetTitle( "R" );
		.IsStarted = #TRUE;
		.InitQuiz();
		.GiveQuiz();
	}
	else
		.CheckAnswer( 0 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^QuizWindow.OnRButton()
{
	#pc	"OnRButton";

	if( ! .IsStarted )
		.Close();
	else
		.CheckAnswer( 1 );
}

//-----------------------------------------------------------------------------

function ^QuizWindow.Print( cp )	// eLXg{bNX֍ŏIs֕ǉ
{
	cn = .EditBox.GetTextCn();
	.EditBox.Select( cn, cn );
	.EditBox.Replace( cp );
}

//-----------------------------------------------------------------------------

function ^QuizWindow.ShowTopMsg()
{
	.Print( ##
 ́Ap L  R ̔
 Ⴂ𕷂NCYłB

 ͑S #MAX_QUESTIONS ₠܂B
 eł́AP #SPEAK_TIMES 񔭉܂B
 ̒P̒ɁA
  L ̔ u L v ̃{^A
  R ̔ u R v ̃{^A
 ĂB

 uX^[gv {^Ǝn܂܂B
## );
}

//-----------------------------------------------------------------------------

function ^QuizWindow.InitQuiz()
{
	if( .nRounds++ == 0 )	// H
	{
		.WordList =
		{
		//	L P	R P
			"light",	"right",
			"lay",		"ray",
			"play",		"pray",
			"lead",		"read",
			"lice",		"rice",
			"flesh",	"fresh",
			"fly",		"fry",
			"collect",	"correct",
			"long",		"wrong",
		};
		.nWords = .WordList'count;
		::Math.srand( 'ticks * 0xABCD ^ 0x12345678 );
	}
	.QN = 0;			// ԍ
	.nCorrectAns = 0;	// 
}

//-----------------------------------------------------------------------------

function ^QuizWindow.GiveQuiz()
{
	// ō̔P߂i P̍ďo} j
	DefValue = 0;
	M = ( #MAX_QUESTIONS - 1 ) / .nWords + 1;
	for( N = 0 ; N < .nWords ; N++ )
	{
		i = ( ::Math.rand() & 0xFFFF ) * .nWords / 0x10000;
		if( .Use[i] < M )
			break;
	}
	.Use[i] = .Use[i] + 1;		// ̒P̎gp񐔁{P

	.CurWord = .WordList[ i ];	// ̔P
	.CurAns = i & 01;			// ̐i =0:L, =1:R j

	.Print( ##
  ${ ++.QN } F@@${ .WordList[ i & ~01 ] } or ${ .WordList[ i | 01 ] }
## );

	.StopSpeak();
	.StartSpeak();		// P̔Jn
}

//-----------------------------------------------------------------------------

function ^QuizWindow.CheckAnswer( ans )
{
	.StopSpeak();

	.Print( ##  ${ ans == .CurAns ? "" : "~" }  i F ${ .CurWord } j
## );
	if( ans == .CurAns )
		.nCorrectAns++;

	if( .QN < #MAX_QUESTIONS )
	{
		.GiveQuiz();	// ̏o
	}
	else	// S̏o肪I
	{
		.Print( ##
 ${ .QN } ⒆A${ .nCorrectAns }  łI

## );
		.IsStarted = #FALSE;
		.L_Button.SetTitle( "X^[g" );
		.R_Button.SetTitle( "LZ" );
		delete .Use;
	}
}

//-----------------------------------------------------------------------------

function ^QuizWindow.StartSpeak()
{
	::Epsaly.Speak( .CurWord );
	.SpeakCount = 1;
	.StartTimer( #SPEAK_TIMER_ID, 50 );
}

function ^QuizWindow.OnTimer( id )
{
	if( id != #SPEAK_TIMER_ID )
		return;

	if( ::Epsaly.TraceSpeaking() != -2 )	// H
		return;

	if( .SpeakCount < #SPEAK_TIMES )
	{
		::Epsaly.Speak( .CurWord );
		.SpeakCount++;
	}
	else
		.StopTimer( #SPEAK_TIMER_ID );
}

function ^QuizWindow.StopSpeak()
{
	::Epsaly.Speak( 0 );
	.StopTimer( #SPEAK_TIMER_ID );
}

//-----------------------------------------------------------------------------

