//----------------------------------------------------------
//  EBhE\Ă̒ɒ`_ɕ`悷
//    iQljCharles Petzold   Programming Windows
//----------------------------------------------------------

//#set	prt		print
#set	prt		#comment

#set	NULL				0
#set	CS_VREDRAW			0x0001
#set	CS_HREDRAW			0x0002
#set	IDI_APPLICATION 	0x7F00
#set	IDC_ARROW			0x7F00
#set	WHITE_BRUSH			0
#set	SW_SHOWNORMAL		1

#set	WS_OVERLAPPED		0x00000000
#set	WS_CAPTION			0x00C00000
#set	WS_SYSMENU			0x00080000
#set	WS_THICKFRAME		0x00040000
#set	WS_MINIMIZEBOX		0x00020000
#set	WS_MAXIMIZEBOX		0x00010000

#set	WS_OVERLAPPEDWINDOW	  #WS_CAPTION | #WS_SYSMENU | #WS_THICKFRAME | \
							  #WS_MINIMIZEBOX | #WS_MAXIMIZEBOX

#set	CW_USEDEFAULT		0x80000000
#set	PM_REMOVE           0x0001

#set	DT_TOP			0x00000000
#set	DT_LEFT			0x00000000
#set	DT_CENTER		0x00000001
#set	DT_RIGHT		0x00000002
#set	DT_VCENTER		0x00000004
#set	DT_BOTTOM		0x00000008
#set	DT_SINGLELINE	0x00000020

#set	RGB(r,g,b)		((#r&0xFF)|((#g<<8)&0xFF00)|((#b<<16)&0xFF0000))

#set	WM_CREATE		0x0001
#set	WM_DESTROY		0x0002
#set	WM_MOVE			0x0003
#set	WM_SIZE			0x0005
#set	WM_PAINT		0x000F
#set	WM_CLOSE		0x0010
#set	WM_QUIT			0x0012


	Kernel32 = ::DLL.Link( "KERNEL32", "sys" );
	User32 = ::DLL.Link( "USER32", "sys" );
	Gdi32 = ::DLL.Link( "GDI32", "sys" );

	^RegisterClassEx = User32.GetEntry( "RegisterClassExW" );
	^CreateWindowEx = User32.GetEntry( "CreateWindowExW" );
	^ShowWindow = User32.GetEntry( "ShowWindow" );
	^UpdateWindow = User32.GetEntry( "UpdateWindow" );
	^GetMessage = User32.GetEntry( "GetMessageW" );
	^TranslateMessage = User32.GetEntry( "TranslateMessage" );
	^DispatchMessage = User32.GetEntry( "DispatchMessageW" );
	^BeginPaint = User32.GetEntry( "BeginPaint" );
	^GetClientRect = User32.GetEntry( "GetClientRect" );
	^DrawText = User32.GetEntry( "DrawTextW" );
	^EndPaint = User32.GetEntry( "EndPaint" );
	^PostQuitMessage = User32.GetEntry( "PostQuitMessage" );
	^DefWindowProc = User32.GetEntry( "DefWindowProcW" );
	^LoadIcon = User32.GetEntry( "LoadIconW" );
	^LoadCursor = User32.GetEntry( "LoadCursorW" );
	^PeekMessage = User32.GetEntry( "PeekMessageW" );
	^SetRect = User32.GetEntry( "SetRect" );
	^GetDC = User32.GetEntry( "GetDC" );
	^ReleaseDC = User32.GetEntry( "ReleaseDC" );
	^FillRect = User32.GetEntry( "FillRect" );

	^CreateSolidBrush = Gdi32.GetEntry( "CreateSolidBrush" );
	^DeleteObject = Gdi32.GetEntry( "DeleteObject" );
	^GetStockObject = Gdi32.GetEntry( "GetStockObject" );

	^GetModuleHandle = Kernel32.GetEntry( "GetModuleHandleW" );

	::DLL.SetCallback( WndProc );

	POINT ::=
	{
		.x		'LONG;
		.y		'LONG;
	};
	#set SizeOfPOINT  4*2

	RECT ::=
	{
		.left	'LONG;
		.top	'LONG;
		.right	'LONG;
		.bottom	'LONG;
	};
	#set SizeOfRECT  4*4

	MSG ::=
	{
		.hwnd		'ULONG;
		.message	'ULONG;
		.wParam		'ULONG;
		.lParam		'ULONG;
		.time		'ULONG;
		.pt			= POINT;
	};
	#set SizeOfMSG  4*5+#SizeOfPOINT

	WNDCLASSEX ::=
	{
		.cbSize			'ULONG;
		.style			'ULONG;
		.lpfnWndProc	'ULONG;
		.cbClsExtra		'LONG;
		.cbWndExtra		'LONG;
		.hInstance		'ULONG;
		.hIcon			'ULONG;
		.hCursor		'ULONG;
		.hbrBackground	'ULONG;
		.lpszMenuName	'ULONG;
		.lpszClassName	'ULONG;
		.hIconSm		'ULONG;
	};
	#set SizeOfWNDCLASSEX  4*12

	PAINTSTRUCT ::=
	{
		.hdc			'ULONG;
		.fErase			'LONG;
		.rcPaint		= RECT;
		.fRestore		'LONG;
		.fIncUpdate		'LONG;
		.rgbReserved	'UBYTE(32);
	};
	#set SizeOfPAINTSTRUCT  4+4+#SizeOfRECT+4+4+32

	msg = Buffer( #SizeOfMSG );
	msg.Keep( #SizeOfMSG );

	^ps = Buffer( #SizeOfPAINTSTRUCT );

	^rect = Buffer( #SizeOfRECT );
	^rect.Keep( #SizeOfRECT );

	hInstance = ^GetModuleHandle( 0 );
	lpClassName = "RandomRect";
	lpWindowName = "MikoScript Window Program -- RandRect";

	WNDCLASSEX.cbSize		 = #SizeOfWNDCLASSEX;
	WNDCLASSEX.style 		 = #CS_HREDRAW | #CS_VREDRAW;
	WNDCLASSEX.lpfnWndProc	 = WndProc'addr;
	WNDCLASSEX.cbClsExtra	 = 0;
	WNDCLASSEX.cbWndExtra	 = 0;
	WNDCLASSEX.hInstance 	 = hInstance;
	WNDCLASSEX.hIcon 		 = ^LoadIcon( 0, #IDI_APPLICATION );
	WNDCLASSEX.hCursor		 = ^LoadCursor( 0, #IDC_ARROW );
	WNDCLASSEX.hbrBackground = ^GetStockObject( #WHITE_BRUSH );
	WNDCLASSEX.lpszMenuName	 = 0;
	WNDCLASSEX.lpszClassName = lpClassName'addr;
	WNDCLASSEX.hIconSm		 = ^LoadIcon( 0, #IDI_APPLICATION );

	wndclass = Buffer( #SizeOfWNDCLASSEX );
	wndclass.Write( WNDCLASSEX );
	wndclass.Seek(0);

	^RegisterClassEx( wndclass );

	hWnd = ^CreateWindowEx(
				0,						// extended window style
				lpClassName,			// registered window class name
				lpWindowName,			// window title name
				#WS_OVERLAPPEDWINDOW,	// window style
				#CW_USEDEFAULT,			// horizontal position of window
				#CW_USEDEFAULT,			// vertical position of window
				#CW_USEDEFAULT,			// window width
				#CW_USEDEFAULT,			// window height
				#NULL,					// handle to parent or owner window
				#NULL,					// handle to menu, or child-window identifier
				hInstance,				// handle to application instance
				#NULL					// pointer to window-creation data
				);

	if( hWnd == 0 )
	{
		print	"EBhE̍쐬sI";
		goto FIN;
	}

	^ShowWindow( hWnd, #SW_SHOWNORMAL );
	^UpdateWindow( hWnd );

	while(1)
	{
		if( ^PeekMessage( msg, 0, 0, 0, #PM_REMOVE ))
		{
			msg.Read( MSG );
			msg.Seek(0);
			if( MSG.message == #WM_QUIT )
				break;

			^TranslateMessage( msg );
			^DispatchMessage( msg );
		}
		else
			DrawRectangle( hWnd );
	}

FIN:
	DLL.ResetCallback( WndProc );

	delete	Kernel32;
	delete	User32;
	delete	Gdi32;
	return;

//-----------------------------------------------------------------------------

function  WndProc( hWnd, iMsg, wParam, lParam )
{
	switch( iMsg )
	{
	  case #WM_CREATE :
			#prt  "WM_CREATE";
			return 0;

	  case #WM_SIZE:
			^cxClient = lParam & 0xFFFF;
			^cyClient = ( lParam >> 16 ) & 0xFFFF;
			return 0;

	  case #WM_DESTROY :
			#prt  "WM_DESTROY";
			^PostQuitMessage(0);
			return 0;
	}
	return ^DefWindowProc( hWnd, iMsg, wParam, lParam );
}

//-----------------------------------------------------------------------------

function  DrawRectangle( hWnd )
{
	if( ^cxClient == 0 || ^cyClient == 0 )
		return;

	^SetRect( ^rect, ::Math.rand() % ^cxClient,
					 ::Math.rand() % ^cyClient,
					 ::Math.rand() % ^cxClient,
					 ::Math.rand() % ^cyClient );

	hBrush = ^CreateSolidBrush(
					#RGB( ::Math.rand(), ::Math.rand (), ::Math.rand() ));

	hDC = ^GetDC( hWnd );

	^FillRect( hDC, rect, hBrush );

	^ReleaseDC( hWnd, hDC );
	^DeleteObject( hBrush );
}

//-----------------------------------------------------------------------------
