/*
===============================================================================
  SpellSuggest.mc :  pP̃XyԈႢmFĒ\
===============================================================================

	Copyright (C) 2013  Masahiko Watanabe

	Edition History:
	  2013.09.28  

	F
		{XNvǵAJ[\ʒủpP̃XymF
		ԈႢƔ肷΁A̒\B

	ӁF
	  {XNvg̎sɂ́Aȉ̂Rt@CKv
		E ...\Tools\libhunspell.dll
		E ...\Dict\en_US.aff
		E ...\Dict\en_US.dic
	  i ... ́AEpsaly CXg[ĂtH_[ j

-----------------------------------------------------------------------------*/

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set  p		print

	e := ::Epsaly;

	e.SelectOff();
	e.MoveTo( 'WordTop );		// J[\ʒu̒P̐擪ֈړ
	e.SelectChars( e.GetTerm()'cn'DCn );	// ʒu̒PI

	word = e.GetSelText();
	if( word'match( $"\w+" ) < 0 )
	{
		::Inform( "J[\ʒuɉpPꂪ܂I" );
		goto FIN;
	}

	::File.GetNamePart( ::File.GetProgramPath(), ProgDir'new! );

	call SETUP_HUNSPELL;

	Ls'ULONG;

	#pc	"hunspell_suggest() = ":
	Ns = ^hunspell_suggest( hunspell, word, Ls'addr );

	for( i = 0 ; i < Ns ; i++ )
	{
		#pv	[ "" ][i] = ( Ls + i * 4 )'pv'ps( , "CP-1252" );
	}

	#pc	"hunspell_free_list() = ":
	^hunspell_free_list( hunspell, Ls'addr, Ns );

	call TERMINATE_HUNSPELL;

	if( Ns <= 0 )
	{
		::Inform( word + " ̒͂܂I" );
		goto FIN;
	}

	id = ::Epsaly.PopupMenu( 1,   // J[\ʒut߂Ƀj[\
		[ "" ],
		null,
		word + " OPWɓo^",
		word + " ̒F" );
	#pc	"MenuId = ": id;

	if( id <= 0 )
		goto FIN;

	e.TintSelText( 0 );			// F

	if( id <= Ns )
	{
		e.SetSelText( [ "" ][ id - 1 ] );
	}
	else if( id == Ns + 1 )		// ɒǉ
	{
		call ADD_TO_DICT;
	}
	//else if( id == Ns + 2 )		// XyԈႢF
	//{
	//	e.TintSelText( 0 );
	//}
  FIN:
	e.SelectOff();
	return;


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// Xy`FbJ[ Hunspell ̃ZbgAbv

SETUP_HUNSPELL:

#pv	^HunSpell = ::DLL.Link( ProgDir + $"Tools\libhunspell.dll", , "CP-1252" );
	if( ! ^HunSpell )
	{
		::Alert( "Xy`FbJ[ Hunspell ܂I" );
		return;
	}

#pv	^hunspell_initialize       = ^HunSpell.GetEntry( "hunspell_initialize", "__cdecl" );
#pv	^hunspell_suggest          = ^HunSpell.GetEntry( "hunspell_suggest", "__cdecl" );
#pv	^hunspell_free_list        = ^HunSpell.GetEntry( "hunspell_free_list", "__cdecl" );
#pv	^hunspell_add              = ^HunSpell.GetEntry( "hunspell_add", "__cdecl" );
#pv	^hunspell_uninitialize     = ^HunSpell.GetEntry( "hunspell_uninitialize", "__cdecl" );


#pv	aff_path = ProgDir + $"Dict\en_US.aff";
#pv	dic_path = ProgDir + $"Dict\en_US.dic";

	if( ! ::File.IsExisting( aff_path ) || ! ::File.IsExisting( dic_path ) )
	{
		::Alert( "Hunspell ̎܂I" );
		return;
	}

#pc	"hunspell_initialize() = ": 
	hunspell = ^hunspell_initialize( aff_path, dic_path );
	back;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// Xy`FbJ[ Hunspell ̏Iݒ

TERMINATE_HUNSPELL:

#pc	"hunspell_uninitialize() = ":
	^hunspell_uninitialize( hunspell );

	delete ^HunSpell;
	back;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// pPOPWɓo^

ADD_TO_DICT:

	buf = ::Buffer();
	file = ::File.Open( ProgDir + $"Dict\ExcWords.txt", "in" );
	if( file != null )
	{
		file.Read( buf );
		delete file;

		buf.Seek( 0 );
		for( v = buf.Find( $"@(.+)(\n|#])" ) ; v > 0 ; v = buf.FindNext() )
		{
			if( word'icmp( buf.FoundText( 1 ) ) == 0 )	// o^ρH
				back;
		}
	}
	file = ::File.Open( ProgDir + $"Dict\ExcWords.txt", "out" );
	if( file != null )
	{
		buf.Seek( 0, "end" );
		buf.Write( word'LINE );
		buf.Seek( 0 );
		file.Write( buf );
		delete file;
	}
	else
		::Alert( word + " \nOPW֓o^ł܂łI" );
	back;

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

