/*
===============================================================================
  AdjEnvColors.mc :  ݒ̔zF𒲐
===============================================================================

	Copyright (C) 2013  Masahiko Watanabe

    Edition History:
	  2013.11.16  

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/*****   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set  p		print
#set  pt	#comment

//-----------------------------------------------------------------------------

// _CAO{bNX̕\
#set	DLG_TITLE		"zF̒"

// _CAO{bNX̕\`
#set	DlgXo		200		// ftH[g̍[ʒu
#set	DlgYo		100		// ftH[g̏[ʒu
#set	ViewXd		330		// NCAg̈̕
#set	ViewYd		354		// NCAg̈̍

// _CAO{bNX̃X^C
#set	DlgStyle		#WS_POPUP | #WS_CAPTION | #WS_SYSMENU | #WS_DLGFRAME
#set	DlgExtStyle		#WS_EX_DLGMODALFRAME

//=============================================================================

function	Main( argc, argv )
{
	#pc	"Jn";
	^DefValue = null;

	class ^DlgBoxWnd : ::GK.Window	  {}

	^DlgBoxWnd.Construct();
	^DlgBoxWnd.Open();

	::GK.WindowMsgLoop();

	delete ^DlgBoxWnd;
	#pc	"I";
}

//=============================================================================

function ^DlgBoxWnd.Construct()
{
	R = ::GK.Rect( 0, 0, #ViewXd, #ViewYd );
	.GetAdjRect( R, #TRUE, #DlgStyle, #DlgExtStyle );

	( Xo, Yo, Xd, Yd ) = ::Epsaly.GetWindowCond( 2 );
	( DlgXo, DlgYo ) = ( Xo != null ) ?
		( Xo + ( Xd - R.Xd ) / 2, Yo + ( Yd - R.Yd ) / 2 ) :
		( #DlgXo, #DlgYo );

	.[ ::GK.Window.Construct ]( 
		  #DLG_TITLE, DlgXo, DlgYo, R.Xd, R.Yd, #DlgStyle, #DlgExtStyle );

	.DlgBox? = #TRUE;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnCreate()
{
	#pc	"OnCreate: ": .gc.hdc;

  /// j[ ///
	#set	CMD_RESTORE			101
	#set	CMD_SAVE			102
	#set	CMD_RESET			103
	#set	CMD_END				104

	.menu1 = ::GK.Menu();
	.menu1.InsertItem( #CMD_RESTORE, "ݒ̔zFɖ߂(&R)" );
	.menu1.InsertItem( #CMD_SAVE,	 "zFݒɕۑ(&S)..." );
	.menu1.InsertItem( #CMD_RESET,	 "X[_[Zbg(&Z)" );
	.menu1.InsertSeparator();
	.menu1.InsertItem( #CMD_END,	 "I(&E)" );

	.TopMenu = ::GK.TopMenu();
	.TopMenu.InsertMenu( .menu1, "(&C)" );

	.SetMenuBar( .TopMenu );
	//.DrawMenuBar();


  /// EBWFbge ///

	.DefWidgetFont =
		::GK.Font( "lr SVbN", 13, #SHIFTJIS_CHARSET, #FIXED_PITCH );

	#set	TLX		 70		// XC_[̕\̕
	#set	BDX		200		// XC_[̃o[̕
	#set	BDY		 40		// XC_[̃o[̍
	#set	VLX		 50		// XC_[̒l̕
	#set	BYo		 10		// XC_[̊xW

	#set	X1		 10
	#set	X2		 #X1+#TLX+4
	#set	X3		 #X2+#BDX

	#set	RateBarStyle	#TBS_HORZ | #TBS_TOP | #TBS_AUTOTICKS | #WS_TABSTOP

	#set	RateTitleRect1	::GK.Rect( #X1, #BYo+15+#BDY*0, #TLX, 20 )
	#set	RateTitleRect2	::GK.Rect( #X1, #BYo+15+#BDY*1, #TLX, 20 )
	#set	RateTitleRect3	::GK.Rect( #X1, #BYo+15+#BDY*2, #TLX, 20 )
	#set	RateTitleRect4	::GK.Rect( #X1, #BYo+15+#BDY*3, #TLX, 20 )
	#set	RateTitleRect5	::GK.Rect( #X1, #BYo+15+#BDY*4, #TLX, 20 )
	#set	RateTitleRect6	::GK.Rect( #X1, #BYo+15+#BDY*5, #TLX, 20 )

	#set	RateBarRect1	::GK.Rect( #X2, #BYo+#BDY*0, #BDX, #BDY )
	#set	RateBarRect2	::GK.Rect( #X2, #BYo+#BDY*1, #BDX, #BDY )
	#set	RateBarRect3	::GK.Rect( #X2, #BYo+#BDY*2, #BDX, #BDY )
	#set	RateBarRect4	::GK.Rect( #X2, #BYo+#BDY*3, #BDX, #BDY )
	#set	RateBarRect5	::GK.Rect( #X2, #BYo+#BDY*4, #BDX, #BDY )
	#set	RateBarRect6	::GK.Rect( #X2, #BYo+#BDY*5, #BDX, #BDY )

	#set	RateValueRect1	::GK.Rect( #X3, #BYo+16+#BDY*0, #VLX, 20 )
	#set	RateValueRect2	::GK.Rect( #X3, #BYo+16+#BDY*1, #VLX, 20 )
	#set	RateValueRect3	::GK.Rect( #X3, #BYo+16+#BDY*2, #VLX, 20 )
	#set	RateValueRect4	::GK.Rect( #X3, #BYo+16+#BDY*3, #VLX, 20 )
	#set	RateValueRect5	::GK.Rect( #X3, #BYo+16+#BDY*4, #VLX, 20 )
	#set	RateValueRect6	::GK.Rect( #X3, #BYo+16+#BDY*5, #VLX, 20 )

  // 邳
	.RateTitle[1] = .AddLabel( "邳(&L)", #RateTitleRect1, #SS_RIGHT );
	.RateBar[1] = .AddTrackBar( #RateBarStyle, #RateBarRect1 );
	.RateBar[1].SetRange( -100, +100 );
	.RateBar[1].SetTicFreq( 10 );
	.RateBar[1].SetPos( 0 );
	.RateBar[1].PageSize( 10 );
	.RateBar[1].LineSize( 1 );
	.RateValue[1] = .AddLabel( "0", #RateValueRect1, #SS_CENTER );

  // NxiRgXgj
	.RateTitle[2] = .AddLabel( "Nx(&C)", #RateTitleRect2, #SS_RIGHT );
	.RateBar[2] = .AddTrackBar( #RateBarStyle, #RateBarRect2 );
	.RateBar[2].SetRange( -100, +100 );
	.RateBar[2].SetTicFreq( 10 );
	.RateBar[2].SetPos( 0 );
	.RateBar[2].PageSize( 10 );
	.RateBar[2].LineSize( 1 );
	.RateValue[2] = .AddLabel( "0", #RateValueRect2, #SS_CENTER );

  // ␳
	.RateTitle[3] = .AddLabel( "␳(&M)", #RateTitleRect3, #SS_RIGHT );
	.RateBar[3] = .AddTrackBar( #RateBarStyle, #RateBarRect3 );
	.RateBar[3].SetRange( -100, +100 );
	.RateBar[3].SetTicFreq( 10 );
	.RateBar[3].SetPos( 0 );
	.RateBar[3].PageSize( 10 );
	.RateBar[3].LineSize( 1 );
	.RateValue[3] = .AddLabel( "1.00", #RateValueRect3, #SS_CENTER );

  // ԋx
	.RateTitle[4] = .AddLabel( "ԋ(&R)", #RateTitleRect4, #SS_RIGHT );
	.RateBar[4] = .AddTrackBar( #RateBarStyle, #RateBarRect4 );
	.RateBar[4].SetRange( -100, +100 );
	.RateBar[4].SetTicFreq( 10 );
	.RateBar[4].SetPos( 0 );
	.RateBar[4].PageSize( 10 );
	.RateBar[4].LineSize( 1 );
	.RateValue[4] = .AddLabel( "0", #RateValueRect4, #SS_CENTER );

  // ΋x
	.RateTitle[5] = .AddLabel( "΋(&G)", #RateTitleRect5, #SS_RIGHT );
	.RateBar[5] = .AddTrackBar( #RateBarStyle, #RateBarRect5 );
	.RateBar[5].SetRange( -100, +100 );
	.RateBar[5].SetTicFreq( 10 );
	.RateBar[5].SetPos( 0 );
	.RateBar[5].PageSize( 10 );
	.RateBar[5].LineSize( 1 );
	.RateValue[5] = .AddLabel( "0", #RateValueRect5, #SS_CENTER );

  // x
	.RateTitle[6] = .AddLabel( "(&B)", #RateTitleRect6, #SS_RIGHT );
	.RateBar[6] = .AddTrackBar( #RateBarStyle, #RateBarRect6 );
	.RateBar[6].SetRange( -100, +100 );
	.RateBar[6].SetTicFreq( 10 );
	.RateBar[6].SetPos( 0 );
	.RateBar[6].PageSize( 10 );
	.RateBar[6].LineSize( 1 );
	.RateValue[6] = .AddLabel( "0", #RateValueRect6, #SS_CENTER );

  // e`FbN{^
	#set	ChkXo		24
	#set	ChkYo		264
	#set	ChkDY		25
	#set	CheckRect1	::GK.Rect( #ChkXo, #ChkYo+#ChkDY*0, 140, 20 )
	#set	CheckRect2	::GK.Rect( #ChkXo, #ChkYo+#ChkDY*1, 140, 20 )
	#set	CheckRect3	::GK.Rect( #ChkXo, #ChkYo+#ChkDY*2, 140, 20 )

	#set	CheckStyle		#BS_AUTOCHECKBOX | #WS_TABSTOP

	.Check[1] = .AddButton( #CheckStyle, "]F(&I)",         #CheckRect1 );
	.Check[2] = .AddButton( #CheckStyle, "O[XP[(&Y)", #CheckRect2 );
	.Check[3] = .AddButton( #CheckStyle, "ڂɗDzF(&E)", #CheckRect3 );

  // {^
	#set	BtnRect1	::GK.Rect( 210, 288, 90, 26 )
	#set	BtnStyle	#BS_PUSHBUTTON | #WS_TABSTOP

	#set	CTL_APPLY	301

	.MenuBtn = .AddButton( #BtnStyle, "Kp(&A)", #BtnRect1 );
	.MenuBtn.CtlId = #CTL_APPLY;

  // ̑
	.IsToSave? = #FALSE;
	.Rx'UBYTE( 256 );
	.Gx'UBYTE( 256 );
	.Bx'UBYTE( 256 );
	.ResetColorFactor();
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );
	.gc.DrawEdge( R, 0, #BF_MIDDLE );
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnClose()
{
	#pc	"OnClose";
	if( .IsToSave? )
	{
		if( .MessageBox( 
				"zFύXĂ܂B\n"
				"ۑɏIĂA낵łH",
				"I", #MB_YESNO | #MB_ICONQUESTION ) != #IDYES )
			return -1;
	}
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnScroll( act, pos, wcp )
{
	//#pc	"OnScroll : " :  act, pos, wcp, wcp'name'ixn;

	.ShowRateValue( wcp'name'ixn );
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnCommand( wParam, wcp )
{
	#pc	"OnCommand : " :  wParam'x(8), wcp, wcp::CtlId;

	switch( wcp::CtlId )
	{
	  case #CTL_APPLY:		.ApplyToAdjust();	break;
	}
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.OnMenu( id )
{
	#pc	"OnMenu: " : id;
	.Update();
	switch( id )
	{
	  case #CMD_RESTORE:
		::Epsaly.EnvApply( "reg" );
		::Epsaly.SetTintSpec( -1 );
		.ResetSlider();
		.IsToSave? = #FALSE;
		break;

	  case #CMD_SAVE:
		if( .MessageBox( 
				"݂̔zFݒ̃f[^t@Cɕۑ܂B\n"
				"낵łH",
				"zF̕ۑ", #MB_YESNO | #MB_ICONQUESTION ) == #IDYES )
		{
			if( ::Epsaly.EnvApply( "save" ) )
			{
				.IsToSave? = #FALSE;
				//.ResetSlider();
				.MessageBox( "݂̔zFۑ܂I",
					"zF̒", #MB_ICONINFORMATION | #MB_OK );
			}
			else
				.MessageBox( "݂̔zFۑł܂łI",
					"zF̒", #MB_ICONERROR | #MB_OK );
		}
		break;

	  case #CMD_RESET:
		.ResetSlider();
		break;

	  case #CMD_END:
		.Close();
		break;
	}
}

//=============================================================================

function ^DlgBoxWnd.ResetSlider()
{
	for( i = 1 ; i <= 6 ; i++ )
	{
		.RateBar[i].SetPos( 0 );
		.ShowRateValue( i );
	}
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.ShowRateValue( i )
{
	switch( i )
	{
	  case 1,2,4,5,6:
		s = .RateBar[i].GetPos()'d(0);
		break;
	  case 3:
		 = ::Math.pow( 3.0, .RateBar[3].GetPos() / 100.0 );
		s = 'f(2);
		break;
	  default:
		return;
	}
	.RateValue[i].SetTitle( s );
}

//-----------------------------------------------------------------------------

#set	CVT_BY_TABLE	0		// qfåele[uŕϊ
#set	CVT_GRAYSCALE	1		// O[XP[ɕϊ

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.ApplyToAdjust()	// XC_[̐ݒl𔽉f
{
  // ̔zFɖ߂
	::Epsaly.EnvApply( "reg" );
	::Epsaly.SetTintSpec( -1 );

  // ڂɗDzF
	if( .Check[3].GetCheck() )
		.GentleScheme();

  // O[XP[
	if( .Check[2].GetCheck() )
		.AdjustColors( #CVT_GRAYSCALE );

  // ]F
	if( .Check[1].GetCheck() )
	{
		for( i = 0 ; i < 256 ; i++ )
			.Rx(i) = .Gx(i) = .Bx(i) = 255 - i;

		.AdjustColors( #CVT_BY_TABLE );
	}

  // 邳
	if(( v = .RateBar[1].GetPos() ) != 0 )
	{
		//v = 128 * v / 100;
		for( i = 0 ; i < 256 ; i++ )
			.Rx(i) = .Gx(i) = .Bx(i) = ( i + v )'cut( 0, 255 );

		.AdjustColors( #CVT_BY_TABLE );
	}

  // NxiRgXgj
	if(( v = .RateBar[2].GetPos() ) != 0 )
	{
		k = ::Math.pow( 2.0, v / 100.0 );
		for( i = 0 ; i < 256 ; i++ )
			.Rx(i) = .Gx(i) = .Bx(i) = 
				( k * ( i - 128 ) + 128 )'int'cut( 0, 255 );

		.AdjustColors( #CVT_BY_TABLE );
	}

  // ␳
	if(( v = .RateBar[3].GetPos() ) != 0 )
	{
		Pow := ::Math.pow;
		 = Pow( 3.0, v / 100.0 );
		for( i = 0 ; i < 256 ; i++ )
			.Rx(i) = .Gx(i) = .Bx(i) =
				( Pow( i / 255.0, 1.0 /  ) * 255 )'cut( 0, 255 );

		.AdjustColors( #CVT_BY_TABLE );
	}

  // ԗΐx
	Rv = .RateBar[4].GetPos();
	Gv = .RateBar[5].GetPos();
	Bv = .RateBar[6].GetPos();
	if( Rv != 0  ||  Gv != 0  ||  Bv != 0 )
	{
		//Rv = 128 * Rv / 100;
		//Gv = 128 * Gv / 100;
		//Bv = 128 * Bv / 100;
		for( i = 0 ; i < 256 ; i++ )
		{
			.Rx(i) = ( i + Rv )'cut( 0, 255 );
			.Gx(i) = ( i + Gv )'cut( 0, 255 );
			.Bx(i) = ( i + Bv )'cut( 0, 255 );
		}
		.AdjustColors( #CVT_BY_TABLE );
	}

	::Epsaly.EnvApply( "new" );
	.IsToSave? = #TRUE;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.AdjustColors( cvt )		// ݂̔zF𒲐
{
	'AddScope( ::Epsaly );
	.CvtCmd = cvt;

  // ʊ
	#pt	"\nʊ";
	n = 0;
	for( i = 11 ; i <= 14 ; i++ )
	{
		( v1, v2, v3 ) = EnvValue( n, i );
		.ChgColor( v1 );
		.ChgColor( v2 );
		.ChgColor( v3 );
		EnvValue( n, i, v1, v2, v3 );
		#pt	"  ": i : v1'X8d : v2'X8d : v3'X8d;
	}

  // ʊ
	#pt	"\nʊ";
	( min, max ) = EnvNameId();
	for( N = min ; N <= max ; N++ )
	{
		if( N == 0 )	continue;

		n = ( N < 0 ) ? ( min - N - 1 ) : N ;

		#pt	EnvNameId( n );

		// eJ[ݒ
		for( i = 101 ; i <= 112 ; i++ )
		{
			( v1, v2, v3, v4 ) = EnvValue( n, i );
			.ChgColor( v1 );
			.ChgColor( v2 );
			.ChgColor( v3 );
			.ChgColor( v4 );
			EnvValue( n, i, v1, v2, v3, v4 );
			#pt	"  ": i : v1'X8d : v2'X8d : v3'X8d : v4'X8d;
		}

		// \J[\
		for( i = 1001 ; i <= 1031 ; i++ )
		{
			( v1, v2 ) = EnvValue( n, i );
			if( v1 == null )
				continue;
			.ChgColor( v1 );
			.ChgColor( v2 );
			EnvValue( n, i, v1, v2 );
			#pt	"  ": i : v1'X8d : v2'X8d;
		}
	}

  // ėpF`
	#pt	"\nėpF`";
	for( i = 1 ; i <= 24 ; i++ )
	{
		( fc, bc ) = GetTintSpec( i );
		.ChgColor( fc );
		.ChgColor( bc );
		SetTintSpec( i, fc, bc );
	}
	#pt	;
}

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.ChgColor( c )
{
	if( c == null )
		return;

	if( c < 0 )
		c = ::GK.GetSysColor( ( c >> 24 ) & 0x7F );

	r = c & 0xFF;
	g = ( c >> 8 ) & 0xFF;
	b = ( c >> 16 ) & 0xFF;

	switch( .CvtCmd )
	{
	  case #CVT_BY_TABLE:
		r = .Rx( r );
		g = .Gx( g );
		b = .Bx( b );
		break;

	  case #CVT_GRAYSCALE:
		r = g = b = ( 77 * r + 151 * g + 28 * b ) / 256;
		break;
	}
	c = r + ( g << 8 ) + ( b << 16 );
}

//-----------------------------------------------------------------------------

function 'X8d( v )  {  return v != null ? ( ", 0x" + v'x(8)'ds(`\``,2) ) : "";  }
function 'X2d( v )  {  return v != null ? ( ", 0x" + v'x(2)'ds(`\``,2) ) : "";  }

//-----------------------------------------------------------------------------

function ^DlgBoxWnd.ResetColorFactor()
{
	for( i = 0 ; i < 256 ; i++ )
		.Rx(i) = .Gx(i) = .Bx(i) = i;
}

//=============================================================================

function ^DlgBoxWnd.GentleScheme()
{
	'AddScope( ::Epsaly );

	// ʊ
	#pt	"\nʊ";
	EnvValue( 0, 11, #RGB(255,255,255), #RGB(255, 0 , 0 ) );					// J[\F
	EnvValue( 0, 12, #RGB(255, 0 , 32), #RGB( 0 ,255,255), #RGB(128,128,128) );	// Xe[^Xo[F
	EnvValue( 0, 13, #RGB(208,192,160), #RGB(224,224,224), #RGB(255, 64, 32) );	// ^u{^F
	EnvValue( 0, 14, #RGB( 0 , 0 , 0 ), #RGB( 96, 80, 0 ) );					// ^u{^wiF

	// ʊ
	#pt	"\nʊ";
	( min, max ) = EnvNameId();
	for( N = min ; N <= max ; N++ )
	{
		if( N == 0 )
			continue;
		n = ( N < 0 ) ? ( min - N - 1 ) : N ;

		( RefName, EnvName, EnvId ) = EnvNameId( n );
		#pt	" " : RefName, EnvName, EnvId;

	  // eJ[ݒ
		EnvValue( n, 101, #RGB(240,128, 0 ), #RGB( 0 , 0 , 0 ) );						// ʏeLXgF
		EnvValue( n, 102, #RGB( 0 , 64, 0 ), #RGB(196,196, 0 ) );						// I͈͐F
		EnvValue( n, 103, #RGB(255,192, 96), #RGB( 0 , 64, 0 ), #RGB(128,255,128) );	// J[\s̐F
		EnvValue( n, 104, #RGB( 64, 64, 64), #RGB(128,128,128) );						// crF
		EnvValue( n, 105, #RGB( 32, 32, 32) );											// ʏÖF
		EnvValue( n, 106, #RGB(255,255,255), #RGB( 64, 64, 64), #RGB(224,224,224) );	// ܂ݐF
		EnvValue( n, 107, #RGB( 96, 96, 96), #RGB(128,128,128), #RGB(128,128,224), #RGB( 0 ,160,255) );	// LF
		EnvValue( n, 108, #RGB(192,176,144), #RGB(255, 64, 32), #RGB(128,128,128), #RGB(192,112, 96) );	// sԍF
		EnvValue( n, 109, #RGB( 32, 32, 32), #RGB( 64, 96, 0 ) );						// sԍwiF
		EnvValue( n, 110, #RGB(192,176,144), #RGB(128,128,128), #RGB( 0 , 0 , 0 ) );	// ڐF
		EnvValue( n, 111, #RGB( 32, 32, 32), #RGB( 96,160, 0 ) );						// ڐF
		EnvValue( n, 112, #RGB(255,255, 0 ), #RGB( 0 ,255,255) );						// s}[NF

	  // \J[\
		switch( RefName )
		{
		  case "C++":
			EnvValue( n, 1001, #RGB(240,128, 0 ), #RGB( 0 , 0 , 0 ) );	// \
			EnvValue( n, 1002, #RGB(224,240, 80), #RGB( 0 , 0 , 0 ) );	// 
			EnvValue( n, 1003, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔
			EnvValue( n, 1004, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔l
			EnvValue( n, 1005, #RGB(240, 0 ,240), #RGB( 0 , 0 , 0 ) );	// }N
			EnvValue( n, 1006, #RGB(255, 32, 0 ), #RGB( 0 , 0 , 0 ) );	// x
			EnvValue( n, 1007, #RGB(192,128,255), #RGB( 0 , 0 , 0 ) );	// jR[h
			EnvValue( n, 1008, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiPjyJnz
			EnvValue( n, 1009, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1010, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			EnvValue( n, 1016, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiQjyJnz
			EnvValue( n, 1017, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1018, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			break;

		  case "CSS":
			EnvValue( n, 1001, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// Rg
			EnvValue( n, 1002, #RGB(255,128, 0 ), #RGB( 0 , 0 , 0 ) );	// ZN^ vf
			EnvValue( n, 1003, #RGB(255,224, 0 ), #RGB( 0 , 0 , 0 ) );	// ZN^ NX/ID
			EnvValue( n, 1004, #RGB(255, 32, 32), #RGB( 0 , 0 , 0 ) );	// ZN^ ^NX
			EnvValue( n, 1005, #RGB(192,192,192), #RGB( 0 , 0 , 0 ) );	// ZN^ w
			EnvValue( n, 1006, #RGB(224, 0 ,224), #RGB( 0 , 0 , 0 ) );	// Ŏn܂s
			EnvValue( n, 1007, #RGB( 0 ,255,255), #RGB( 0 , 0 , 0 ) );	// ̑
			EnvValue( n, 1008, #RGB(255,128,255), #RGB( 0 , 0 , 0 ) );	// X^CwyJnz
			EnvValue( n, 1009, #RGB(255,128,255), #RGB( 0 , 0 , 0 ) );	//      V     yIz
			EnvValue( n, 1010, #RGB(255,128, 0 ), #RGB( 0 , 0 , 0 ) );	//      V     ys蕔z
			EnvValue( n, 1011, #RGB(255,128, 0 ), #RGB( 0 , 0 , 0 ) );	//      V      vpeB
			EnvValue( n, 1012, #RGB(128,255, 0 ), #RGB( 0 , 0 , 0 ) );	//      V      l
			EnvValue( n, 1013, #RGB( 0 ,240,240), #RGB( 0 , 0 , 0 ) );	//      V      
			EnvValue( n, 1014, #RGB( 0 ,192, 0 ), #RGB( 0 , 0 , 0 ) );	//      V      Rg
			EnvValue( n, 1015, #RGB(192,192,192), #RGB( 0 , 0 , 0 ) );	//      V      ؂
			break;

		  case "HTML":
			EnvValue( n, 1001, #RGB(255,128,255), #RGB( 32, 0 , 48) );	// DOCTYPE
			EnvValue( n, 1002, #RGB(108,224,112), #RGB( 0 , 24, 0 ) );	// Q
			EnvValue( n, 1003, #RGB(128,192,192), #RGB( 0 , 0 , 80) );	// hoAhX
			EnvValue( n, 1004, #RGB(128,192,192), #RGB( 0 , 0 , 80) );	// URL
			EnvValue( n, 1005, #RGB(128,192,192), #RGB( 0 , 0 , 80) );	// E-Mail
			EnvValue( n, 1008, #RGB(128,255, 96), #RGB( 0 , 24, 0 ) );	// ^OyJnz
			EnvValue( n, 1009, #RGB(128,255, 96), #RGB( 0 , 24, 0 ) );	//  V yIz
			EnvValue( n, 1010, #RGB(128,255, 96), #RGB( 0 , 24, 0 ) );	//  V ys蕔z
			EnvValue( n, 1011, #RGB(255,192, 96), #RGB( 0 , 24, 0 ) );	//  V  
			EnvValue( n, 1012, #RGB( 96,192,255), #RGB( 0 , 24, 0 ) );	//  V  liPj
			EnvValue( n, 1013, #RGB( 96,192,255), #RGB( 0 , 24, 0 ) );	//  V  liQj
			EnvValue( n, 1014, #RGB( 96,192,255), #RGB( 0 , 24, 0 ) );	//  V  liRj
			EnvValue( n, 1016, #RGB(192,192,192), #RGB( 16, 16, 16) );	// RgyJnz
			EnvValue( n, 1017, #RGB(192,192,192), #RGB( 16, 16, 16) );	//    V   yIz
			EnvValue( n, 1018, #RGB(192,192,192), #RGB( 16, 16, 16) );	//    V   ys蕔z
			EnvValue( n, 1024, #RGB(224,224, 0 ), #RGB( 16, 16, 16) );	// XNvgyJnz
			EnvValue( n, 1025, #RGB(224,224, 0 ), #RGB( 16, 16, 16) );	//     V    yIz
			EnvValue( n, 1026, #RGB(240,240,240), #RGB( 0 , 0 , 0 ) );	//     V    ys蕔z
			EnvValue( n, 1027, #RGB( 96,240,240), #RGB( 0 , 24, 24) );	//     V     Rg
			EnvValue( n, 1028, #RGB(255,128, 0 ), #RGB( 16,  8, 0 ) );	//     V     
			EnvValue( n, 1029, #RGB( 0 ,255,255), #RGB( 0 , 16, 16) );	//     V     萔
			EnvValue( n, 1030, #RGB(224,224,192), #RGB( 0 , 0 , 0 ) );	//     V     \
			break;

		  case "JScript":
			EnvValue( n, 1001, #RGB(240,128, 0 ), #RGB( 0 , 0 , 0 ) );	// \
			EnvValue( n, 1002, #RGB(224,240, 80), #RGB( 0 , 0 , 0 ) );	// idpj
			EnvValue( n, 1003, #RGB(176, 96,255), #RGB( 0 , 0 , 0 ) );	// iPpj
			EnvValue( n, 1004, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔l
			EnvValue( n, 1005, #RGB(255, 32, 0 ), #RGB( 0 , 0 , 0 ) );	// x
			EnvValue( n, 1006, #RGB(255, 0 ,255), #RGB( 0 , 0 , 0 ) );	// RpC
			EnvValue( n, 1008, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiPjyJnz
			EnvValue( n, 1009, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1010, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			EnvValue( n, 1016, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiQjyJnz
			EnvValue( n, 1017, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1018, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			break;

		  case "Java":
			EnvValue( n, 1001, #RGB(240,128, 0 ), #RGB( 0 , 0 , 0 ) );	// \
			EnvValue( n, 1002, #RGB(224,240, 80), #RGB( 0 , 0 , 0 ) );	// 
			EnvValue( n, 1003, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔
			EnvValue( n, 1004, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔l
			EnvValue( n, 1005, #RGB(255, 32, 0 ), #RGB( 0 , 0 , 0 ) );	// x
			EnvValue( n, 1008, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiPjyJnz
			EnvValue( n, 1009, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1010, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			EnvValue( n, 1011, #RGB( 0 , 0 , 0 ), #RGB( 0 , 0 , 0 ) );	//       V       hLg ^O
			EnvValue( n, 1016, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiQjyJnz
			EnvValue( n, 1017, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1018, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			break;

		  case "Miko":
			EnvValue( n, 1001, #RGB(240,128, 0 ), #RGB( 0 , 0 , 0 ) );	// \
			EnvValue( n, 1002, #RGB(224,160, 96), #RGB( 0 , 0 , 0 ) );	// \
			EnvValue( n, 1003, #RGB(224,240, 80), #RGB( 0 , 0 , 0 ) );	// 
			EnvValue( n, 1004, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// l^萔
			EnvValue( n, 1005, #RGB(240,112,240), #RGB( 0 , 0 , 0 ) );	// }N
			EnvValue( n, 1006, #RGB(255, 32, 0 ), #RGB( 0 , 0 , 0 ) );	// x
			EnvValue( n, 1007, #RGB(176, 96,255), #RGB( 0 , 0 , 0 ) );	// [^֐
			EnvValue( n, 1008, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiPjyJnz
			EnvValue( n, 1009, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1010, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			EnvValue( n, 1016, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	// RgiQjyJnz
			EnvValue( n, 1017, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      yIz
			EnvValue( n, 1018, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//       V      ys蕔z
			EnvValue( n, 1024, #RGB(128,208, 0 ), #RGB( 24, 24, 0 ) );	// LyJnz
			EnvValue( n, 1025, #RGB(128,208, 0 ), #RGB( 24, 24, 0 ) );	//     V    yIz
			EnvValue( n, 1026, #RGB(255,208, 96), #RGB( 24, 24, 0 ) );	//     V    ys蕔z
			EnvValue( n, 1027, #RGB(112,240, 0 ), #RGB( 24, 24, 0 ) );	// XNvg
			EnvValue( n, 1028, #RGB(240, 0 ,240), #RGB( 24, 24, 0 ) );	// }N
			break;

		  case "VBScript":
			EnvValue( n, 1001, #RGB(255,128, 0 ), #RGB( 0 , 0 , 0 ) );	// Xe[gg
			EnvValue( n, 1002, #RGB(224,144, 64), #RGB( 0 , 0 , 0 ) );	// L[[h
			EnvValue( n, 1003, #RGB(224,240, 80), #RGB( 0 , 0 , 0 ) );	// 
			EnvValue( n, 1004, #RGB(160,224,255), #RGB( 0 , 0 , 0 ) );	// 萔
			EnvValue( n, 1005, #RGB(176, 96,255), #RGB( 0 , 0 , 0 ) );	// t
			EnvValue( n, 1006, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ) );	// Rg
			EnvValue( n, 1008, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	// Rg(Rem)yJnz
			EnvValue( n, 1009, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//      V      yIz
			EnvValue( n, 1010, #RGB( 0 ,224, 0 ), #RGB( 0 , 0 , 0 ) );	//      V      ys蕔z
			break;

		  case "XML":
			EnvValue( n, 1001, #RGB( 0 ,240,240), #RGB( 0 , 32, 0 ) );	// 
			EnvValue( n, 1002, #RGB(255,128,112), #RGB( 32, 0 , 48) );	// DOCTYPE
			EnvValue( n, 1003, #RGB(160,160,160), #RGB( 16, 16, 16) );	// Rg
			EnvValue( n, 1004, #RGB(112,224,112), #RGB( 0 , 32, 0 ) );	// ̎Q
			EnvValue( n, 1005, #RGB(128,192,255), #RGB( 0 , 0 , 80) );	// URL
			EnvValue( n, 1006, #RGB(192,255, 96), #RGB( 0 , 0 , 80) );	// E-Mail
			EnvValue( n, 1007, #RGB(240, 80,144), #RGB( 0 , 0 , 80) );	// hoAhX
			EnvValue( n, 1008, #RGB(128,255, 32), #RGB( 0 , 24, 0 ) );	// ^OyJnz
			EnvValue( n, 1009, #RGB(128,255, 32), #RGB( 0 , 24, 0 ) );	//  V yIz
			EnvValue( n, 1010, #RGB( 0 ,255,255), #RGB( 0 , 24, 0 ) );	//  V ys蕔z
			EnvValue( n, 1011, #RGB(240,240, 32), #RGB( 0 , 24, 0 ) );	//  V  
			EnvValue( n, 1012, #RGB( 0 ,192,255), #RGB( 0 , 24, 0 ) );	//  V  liPj
			EnvValue( n, 1013, #RGB( 0 ,192,255), #RGB( 0 , 24, 0 ) );	//  V  liQj
			EnvValue( n, 1014, #RGB( 0 ,255,255), #RGB( 0 , 24, 0 ) );	//  V  lisj
			EnvValue( n, 1016, #RGB(255,128,255), #RGB( 32, 0 , 32) );	// DOCTYPEyJnz
			EnvValue( n, 1017, #RGB(255,128,255), #RGB( 32, 0 , 32) );	//   V   yIz
			EnvValue( n, 1018, #RGB( 0 ,255,255), #RGB( 32, 0 , 32) );	//   V   ys蕔z
			EnvValue( n, 1019, #RGB(255,255, 0 ), #RGB( 32, 0 , 32) );	//   V    vf^錾
			EnvValue( n, 1020, #RGB(255,255, 0 ), #RGB( 32, 0 , 32) );	//   V    Xg錾
			EnvValue( n, 1021, #RGB(255,128,255), #RGB( 32, 0 , 32) );	//   V    ̐錾
			EnvValue( n, 1022, #RGB(112,225,117), #RGB( 32, 0 , 32) );	//   V    L@錾
			EnvValue( n, 1023, #RGB( 0 ,128,192), #RGB( 32, 0 , 32) );	//   V    ̑
			EnvValue( n, 1024, #RGB(255,255, 0 ), #RGB( 32, 32, 32) );	// CDATA yJnz
			EnvValue( n, 1025, #RGB(255,255, 0 ), #RGB( 32, 32, 32) );	//   V  yIz
			EnvValue( n, 1026, #RGB(255,255,255), #RGB( 32, 32, 32) );	//   V  ys蕔z
			EnvValue( n, 1027, #RGB(128,192,255), #RGB( 0 , 0 , 80) );	//   V   URL
			EnvValue( n, 1028, #RGB(192,255, 96), #RGB( 0 , 0 , 80) );	//   V   E-Mail
			EnvValue( n, 1029, #RGB(240, 80,144), #RGB( 0 , 0 , 80) );	//   V   hoAhX
			break;
		}
	}

  // ėpF`
	SetTintSpec(  1, #RGB(255,128,128), #RGB(128, 0 , 0 ), 0b0011 );	// Ԋ
	SetTintSpec(  2, #RGB(224,160,128), #RGB( 96, 32, 0 ), 0b0011 );	//  V 
	SetTintSpec(  3, #RGB(192,192,128), #RGB( 64, 64, 0 ), 0b0011 );	//  V 
	SetTintSpec(  4, #RGB(160,224,128), #RGB( 32, 96, 0 ), 0b0011 );	//  V 
	SetTintSpec(  5, #RGB(128,255,128), #RGB( 0 ,128, 0 ), 0b0011 );	//  V 
	SetTintSpec(  6, #RGB(128,224,160), #RGB( 0 , 96, 32), 0b0011 );	// ΐ V 
	SetTintSpec(  7, #RGB(128,192,192), #RGB( 0 , 64, 64), 0b0011 );	// ΐ V 
	SetTintSpec(  8, #RGB(128,160,224), #RGB( 0 , 32, 96), 0b0011 );	// ΐ V 
	SetTintSpec(  9, #RGB(128,128,255), #RGB( 0 , 0 ,128), 0b0011 );	//  V 
	SetTintSpec( 10, #RGB(160,128,224), #RGB( 32, 0 , 96), 0b0011 );	//  V 
	SetTintSpec( 11, #RGB(192,128,192), #RGB( 64, 0 , 64), 0b0011 );	//  V 
	SetTintSpec( 12, #RGB(224,128,160), #RGB( 96, 0 , 32), 0b0011 );	// Ԏ V 
	SetTintSpec( 13, #RGB(255, 0 , 0 ), #RGB( 0 , 0 , 0 ), 0b0101 );	// Ԋ
	SetTintSpec( 14, #RGB(255,128, 0 ), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 15, #RGB(255,255, 0 ), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 16, #RGB(128,255, 0 ), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 17, #RGB( 0 ,255, 0 ), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 18, #RGB( 0 ,255,128), #RGB( 0 , 0 , 0 ), 0b0101 );	// ΐ V 
	SetTintSpec( 19, #RGB( 0 ,255,255), #RGB( 0 , 0 , 0 ), 0b0101 );	// ΐ V 
	SetTintSpec( 20, #RGB( 0 ,128,255), #RGB( 0 , 0 , 0 ), 0b0101 );	// ΐ V 
	SetTintSpec( 21, #RGB( 0 , 0 ,255), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 22, #RGB(128, 0 ,255), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 23, #RGB(255, 0 ,255), #RGB( 0 , 0 , 0 ), 0b0101 );	//  V 
	SetTintSpec( 24, #RGB(255, 0 ,128), #RGB( 0 , 0 , 0 ), 0b0101 );	// Ԏ V 
}

//-----------------------------------------------------------------------------
