/*
===============================================================================
  DecBase64.mc :  Base64 fR[h
===============================================================================

	Copyright (C) 2009-2012  Masahiko Watanabe

    Edition History:
      Ver.1.00  2009.02.11  
      Ver.2.00  2013.01.01  Epsaly pɕύX

  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

   F
	  {vÓABase64 ŃGR[hꂽeLXgfR[hāA
	R\[i -Script- EBhE jɃvg܂B̃fR[h
	ΏۂɂȂ̂́AI͈͂̃eLXgłi`I͈͂jBA
	I͈͂Ȃ΁AҏWeLXgŜΏۂɂȂ܂B

   F
	  fR[hOF  QUJDREVGRw==
	  fR[hF  ABCDEFG

   ӁF
	  Ώۂ̃eLXǵABase64 ŃfR[hāAUTF-8 ̃eLXgɂȂA
	ɁAUTF-16 ̃eLXgɕϊ܂B

   F
	  fR[hʂ̃f[^t@CɊi[ꍇ́A{vO
	̂悤ɕύX܂B
	  iPjR\[Ƀvg镔Rg
	  iQjt@CɊi[镔̃Rg
	  iRjKvɉāAi[̃t@CύX

	  t@CɊi[Ă Base64 ̃eLXgΏۂɂꍇAǂ
	oǉKv܂B

-----------------------------------------------------------------------------*/

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set  p		print

//-----------------------------------------------------------------------------

  // Base64 ̃R[hϊ\쐬
	CharB64'USHORT( 64 );
	CharB64'puts(
		"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/" );

	#set  ILLEGAL_CODE  (-2)
	#set  SKIP_CODE		(-1)

	code'USHORT( 256 );

	DefValue = #ILLEGAL_CODE;

	for( i = 0 ; i < 256 ; i++ )
		code[i] = #ILLEGAL_CODE;

	for( i = 0 ; i < 64 ; i++ )
		code[ CharB64( i ) ] = i;

	code[ `=`  ] = #SKIP_CODE;
	code[ `\r` ] = #SKIP_CODE;
	code[ `\n` ] = #SKIP_CODE;

  // Base64 ̃eLXg͈͂zɓǂݍ
	if(( cn = ::Epsaly.GetSelCn() ) > 0 )
	{
		T'USHORT( cn );
		T'puts( ::Epsaly.GetSelText() );
	}
	else if(( cn = ::Epsaly.GetFullCn()) > 0 )
	{
		T'USHORT( cn );
		T'puts( ::Epsaly.GetFullText() );
	}
	else
		return;

  // Base64 fR[hāAobt@Ɋi[
	bf = ::Buffer( cn );
	v'UBYTE( 3 );
	k = 0;
	for( i = 0 ; i < cn ; i++ )
	{
		switch( c = code[ T( i ) ] )
		{
		  case #ILLEGAL_CODE:	// sR[h
			print "Error: sȕi %c j܂܂Ă܂I"'fmt( T(i) );
			return;
		  case #SKIP_CODE:		// ǂݔ΂R[h
			continue;
		}

		switch( k++ & 03 )
		{
		  case 0:  c1 = c;   continue;
		  case 1:  c2 = c;   continue;
		  case 2:  c3 = c;   continue;
		  case 3:  c4 = c;   break;
		}

		v(0) = ( c1 << 2 ) | ( c2 >> 4 );
		v(1) = ( c2 << 4 ) | ( c3 >> 2 );
		v(2) = ( c3 << 6 ) | ( c4 >> 0 );
		bf.Write( v );
	}

	// S̔{̗]̃rbg 0 lݒ
	switch( k & 03 )
	{
	  case 0:  break;
	  case 1:  c2 = 0;
	  case 2:  c3 = 0;
	  case 3:  c4 = 0;
		v(0) = ( c1 << 2 ) | ( c2 >> 4 );
		v(1) = ( c2 << 4 ) | ( c3 >> 2 );
		v(2) = ( c3 << 6 ) | ( c4 >> 0 );
	   bf.Write( v );
	}

	bf.Size( k * 6 / 8 );	// ̖oCg

  // fR[hꂽei UTF-8 ̕ƑzjAUTF-16 ɕϊ
	bf.Seek( 0 );
	bf.Decode( "UTF-8" );

  // fR[hꂽAR\[Ƀvg
	bf.Seek( 0 );
	while( bf.Read( text'LN ) > 0 )
		print text : -;

/*@@@@@
  // obt@̃f[^t@CɊi[
	bf.Seek( 0 );
	::File.GetNamePart( ::Epsaly.GetFileName(),
	      DirName'new!, MainName'new!, ExtName'new! );
	FullName = DirName + MainName + ".xxx";
	file = ::File.Open( FullName, "out" );
	if( file == null  ||
		file.Write( bf ) < 0 )
	{
		print "Error: t@CɊi[ł܂I ": FullName;
		return;
	}
	file.Close();
@@@@@*/

	return;

//-----------------------------------------------------------------------------

