/*
===============================================================================
  HypoCycloid.mc :  ~̓ɉď~]̋OՂ`
===============================================================================

	Copyright (C) 2010  Masahiko Watanabe

    Edition History:
      Ver.1.00  2010.11.15i GK Library: Rev.2009.02.03 gp j

-----------------------------------------------------------------------------*/

/*****/    // GK Library ̃W[[hꍇ
#include  <GkLib\GkDefs.mh>
#include  <GkLib\GkSysDefs.mh>
#include  <GkLib\GkKey.mh>

	if( ::Module.Include( "GkLibrary" ) > 0 )
		Main( argc, argv );
	return;
/*****/

/******   // GK Library ̃\[XCN[hꍇ
#include  <GkLib\GkLibrary.mc>

	Main( argc, argv );
	return;
/*****/

//-----------------------------------------------------------------------------

// fobOvgi[Xj
#set  pc	#comment
#set  pv

// fobOvgLifobOj
//#set  pc	print
//#set  pv	print

#set	p	print

//-----------------------------------------------------------------------------

///  }N`  ///

#set	MAIN_TITLE		"~̓]O"	// EBhẼLvV

#set	Wnd_Xo				// EBhE̍[ʒui󔒂̓ftH[gj
#set	Wnd_Yo				// EBhȄ[ʒui󔒂̓ftH[gj

#set	DlgYd		40		// _CAÖ̍

#set	FigXd		500		// }``̈̕
#set	FigYd		500		// }``̈̍

#set	TimerId		101		// ^C}[̓l

#set	VFR			30		// ʍXV񐔁^b

#set	MIN_SPEED	15		// ~`̎px̍ŏl [x^b]
#set	MAX_SPEED  (360*7)	// @@@@V@@@@ől@@V@

#set	MIN_SI		1		// ~`̎px̍ŏwW
#set	MAX_SI		100		// @@@@V@@@@őwW
#set	INI_SI		50		// @@@@V@@@@wW
#set	DIV_SI		( #MAX_SI - #MIN_SI + 1 )	// ̎wW̕

#set	INI_KR		3.125	// Q~̔ȁl
#set	MAX_KR		20.0	// @@@V@@@ől
#set	MIN_KR		0.5		// @@@V@@@ŏl

#set	INI_KD		0.5		// OՓ_̉S̏l
#set	MAX_KD		5.0		// @@@V@@@@ől
#set	MIN_KD		0.0		// @@@V@@@@ŏl

#set	PI		3.14159265358979
#set	RAD		( #PI / 180 )

//=============================================================================

function	Main( argc, argv )
{
	#pc	"Jn";
	^DefValue = null;

	SetupDrawingConds();
	class ^MainWindow  : ::GK.Window	{}

	R = ::GK.Rect( 0, 0, #FigXd, #DlgYd + #FigYd );
	::GK.Window.GetAdjRect( R );
	^MainWindow.Construct( #MAIN_TITLE, #Wnd_Xo, #Wnd_Yo, R.Xd, R.Yd );
	^MainWindow.Open();

	^MainWindow.StartTimer( #TimerId, 1000 / #VFR );

	::GK.WindowMsgLoop();

	delete ^MainWindow;
	DeleteDrawingConds();
	#pc	"I";
}

//=============================================================================

function  SetupDrawingConds()
{
	^WhitePen = ::GK.Pen( #RGB(255,255,255), #PS_SOLID, 1 );
	^GreyPen = ::GK.Pen( #RGB(160,160,160), #PS_SOLID, 1 );
	^GreenPen = ::GK.Pen( #RGB(0,128,0), #PS_SOLID, 1 );
	^BluePen = ::GK.Pen( #RGB(0,64,255), #PS_SOLID, 1 );
	^BlackBrush = ::GK.Brush( #RGB(0,0,0) );
	^RedBrush = ::GK.Brush( #RGB(255,0,0) );
	^DlgFont = 
		::GK.Font( "lr SVbN", 14, #SHIFTJIS_CHARSET, #FIXED_PITCH );
}

function  DeleteDrawingConds()
{
	delete ^WhitePen,^GreyPen,^GreenPen,^BluePen;
	delete ^BlackBrush, ^RedBrush;
	delete ^DlgFont;
}

//=============================================================================

function ^MainWindow.OnCreate()
{
	#pc	"OnCreate";
	.MakeDlgItems();
	.InizFigData();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnClose()
{
	#pc	"OnClose";
	.StopTimer( #TimerId );
	.TermFigData();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnSize()
{
	#pc	"OnSize", .gc.Xd, .gc.Yd, .Min?();
	if( .gc.Xd <= 0 || .gc.Yd <= 0 )
		return;
	.SetDlgAreaLayout();
	.SetFigAreaLayout();
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnMinMaxInfo( pMinMax )
{
  // EBhETCYύXłȂ悤ɂ
	.GetWindowRect( R'STRUCT );
	//#pc	"OnMinMaxInfo", R.Xd, R.Yd;
	P'LONG(4) = {  R.Xd, R.Yd, R.Xd, R.Yd  };
	( pMinMax + 3*4*2 )'memcpy( P'addr, 4*4 );
	return #TRUE;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnPaint()
{
	#pc	"OnPaint";
	.GetHotRect( R'STRUCT );

	if( ! .DlgRect.Out?( R ) )
		.DrawDlgArea();

	if( ! .FigRect.Out?( R ) )
		.DrawFigArea( 0 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnTimer( id )
{
	//#pc	"OnTimer: ", id;
	.DrawFigArea( .Ts );
}

//-----------------------------------------------------------------------------

function ^MainWindow.MakeDlgItems()
{
	.DefWidgetFont := ^DlgFont;

	R = ::GK.Rect( 0,0,0,0 );

	.KrTitle = .AddLabel( "a", R, #SS_RIGHT );
#pv	.KrInput = .AddEditBox( #ES_CENTER, R );
	.KrInput.SetText( #INI_KR'g );

	.KdTitle = .AddLabel( "S", R, #SS_RIGHT );
#pv	.KdInput = .AddEditBox( #ES_CENTER, R );
	.KdInput.SetText( #INI_KD'g );

	.SiTitle = .AddLabel( "x", R, #SS_RIGHT );
#pv	.SiSlide = .AddScrollBar( "H", R );
	.SiSlide.OnScroll = function( act, pos ) { .owner.OnSiSlide( act, pos ); };
	.SiSlide.SetRange( #MIN_SI, #MAX_SI );
	.SiSlide.SetPos( #INI_SI );

#pv	.StartBtn = .AddButton( "push", "Jn", R );
	.StartBtn.OnCommand =
		function() { .owner.SetFocus(); .owner.OnStartButton(); };
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.SetDlgAreaLayout()
{
	.DlgRect = ::GK.Rect( 0, 0, .gc.Xd, #DlgYd );

	R1 = ::GK.Rect( 4, 12, 50, 20 );
	R2 = ::GK.Rect( R1.Xo + R1.Xd + 6, 10, 54, 20 );
	.KrTitle.Move( R1 );
	.KrInput.Move( R2 );

	R1.Xo += 114;
	R2.Xo += 114;
	.KdTitle.Move( R1 );
	.KdInput.Move( R2 );

	R1.Xo += 118;
	R1.Xd = 36;
	R2 = ::GK.Rect( R1.Xo + R1.Xd + 6, 10, 128, 16 );
	.SiTitle.Move( R1 );
	.SiSlide.Move( R2 );

	.StartBtn.Move( ::GK.Rect( R2.Xo + R2.Xd + 20, 8, 64, 22 ) );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.DrawDlgArea()
{
	.gc.DrawEdge( .DlgRect, #EDGE_BUMP, #BF_BOTTOM|#BF_MIDDLE );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnSiSlide( act, pos )
{
	switch( act )
	{
	  case #SB_TOP:			v = #MIN_SI;				break;
	  case #SB_LINEUP:		v = .Ts - 1;				break;
	  case #SB_PAGEUP:		v = .Ts - #DIV_SI / 10;		break;

	  case #SB_BOTTOM:		v = #MAX_SI;				break;
	  case #SB_LINEDOWN:	v = .Ts + 1;				break;
	  case #SB_PAGEDOWN:	v = .Ts + #DIV_SI / 10;		break;

	  case #SB_ENDSLIDE://	v = pos;	break;
	  case #SB_SLIDING:		v = pos;	break;

	  default:
	  case #SB_ENDSCROLL:	goto END;
	}

	v = v'cut( #MIN_SI, #MAX_SI );
	.SiSlide.SetPos( v );
	.Ts = v;
	//#pc	"OnSiSlide", act, v;
  END:  ;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.OnStartButton()
{
	#pc	"OnStartButton";

	.Tc = 0.0;					// ~`̌px [rad/b]

	// ~ai~jƉ~`̔a
	.Kr = .KrInput.GetText()'float'cut( #MIN_KR, #MAX_KR );
	.KrInput.SetText( .Kr'g );

	// OՓ_̉Si~`̒SOՓ_܂ł̋^~`̔aj
	.Kd = .KdInput.GetText()'float'cut( #MIN_KD, #MAX_KD );
	.KdInput.SetText( .Kd'g );

	.Ra = .Rb / .Kr;	// ~`̔a
	.Rc = .Rb - .Ra;	// ~a̒S~`̒S܂ł̋
	.Rd = .Ra * .Kd;	// ~`̒SOՓ_܂ł̋

	.CircleA = ::GK.Rect( 0, 0, .Ra'int * 2, .Ra'int * 2 );

	.SGC.ClearRect( .MgcFullRect );
	.SGC.MoveTo( ( .Rc + .Rd )'int, 0 );
}

//-----------------------------------------------------------------------------

function ^MainWindow.InizFigData()
{
	.MgcFullRect = ::GK.Rect( - #FigXd / 2, - #FigYd / 2, #FigXd, #FigYd );

	.Ts = #INI_SI;	// ~`̎px [x/b]
	.Tc = 0.0;		// ~`̌px [rad/b]

	.Kr = #INI_KR;	// ~ai~jƉ~`̔a
	.Kd = #INI_KD;	// OՓ_̉Si~`̒SOՓ_܂ł̋^~`̔aj

	.Rb = 200;			// ~a̔a
	.Ra = .Rb / .Kr;	// ~`̔a
	.Rc = .Rb - .Ra;	// ~a̒S~`̒S܂ł̋
	.Rd = .Ra * .Kd;	// ~`̒SOՓ_܂ł̋

	.CircleB = ::GK.Rect( -.Rb, -.Rb, .Rb * 2, .Rb * 2 );
	.CircleA = ::GK.Rect( 0, 0, .Ra'int * 2, .Ra'int * 2 );

	// OՕ`p̉ʃobt@imNFwiAj
#pv	.SGC = ::GK.Image( , #FigXd, #FigYd, 1 );
	.SGC.SetMapMode( #MM_ISOTROPIC );
	.SGC.SetWindowExt( #FigXd, #FigYd );
	.SGC.SetViewportExt( #FigXd, -#FigYd );
	.SGC.SetViewportOrg( #FigXd / 2, #FigYd / 2 );
	.SGC.SetPen( ^WhitePen );
	.SGC.SetBrush( ^BlackBrush );
	//.SGC.ClearRect( .MgcFullRect );
	.SGC.MoveTo( ( .Rc + .Rd )'int, 0 );

	// ʃobt@ỉʍXVɕ\}``j
#pv	.MGC = ::GK.Image( , #FigXd, #FigYd );
	.MGC.SetMapMode( #MM_ISOTROPIC );
	.MGC.SetWindowExt( #FigXd, #FigYd );
	.MGC.SetViewportExt( #FigXd, -#FigYd );
	.MGC.SetViewportOrg( #FigXd / 2, #FigYd / 2 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.TermFigData()
{
	delete .SGC;
	delete .MGC;
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.SetFigAreaLayout()
{
	.FigRect = ::GK.Rect( 0, #DlgYd, .gc.Xd, .gc.Yd - #DlgYd );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

function ^MainWindow.DrawFigArea( ts )
{
	if( ts <= 0 )
		goto SET_VFRAME;

	cos := ::Math.cos;
	sin := ::Math.sin;

	td = #MIN_SPEED * ::Math.pow( ( #MAX_SPEED'float / #MIN_SPEED ),
			( ts - #MIN_SI )'float / ( #MAX_SI - #MIN_SI ) );	// 䐔̏ꍇ
	//td = #MIN_SPEED + ( #MAX_SPEED - #MIN_SPEED ) *
	//		( ts - #MIN_SI )'float / ( #MAX_SI - #MIN_SI );		// ̏ꍇ
	Td = td * #RAD / #VFR;		// eʍXV̉~`̎px [rad]
	To = .Tc;
	M = ( td / #VFR )'int'cut( 1, );	// Td ̕

	for( N = 1 ; N <= M ; N++ )
	{
		Tb = To + Td * N / M;
		Ta = Tb - .Kr * Tb;

		Cx = .Rc * cos( Tb );
		Cy = .Rc * sin( Tb );

		Px = ( Cx + .Rd * cos( Ta ))'int;
		Py = ( Cy + .Rd * sin( Ta ))'int;

		.SGC.LineTo( Px, Py );		// ꍇ
		//.SGC.SetPixel( Px, Py, #RGB(255,255,255) );	// _łꍇ
	}
	.Tc = Tb;

	.MGC.ClearRect( .MgcFullRect, #RGB(255,255,255) );
	.MGC.SetPen( ^GreyPen );
	.MGC.FrameOval( .CircleB );

	.CircleA.Xo = ( Cx - .Ra )'int;
	.CircleA.Yo = ( Cy - .Ra )'int;
	.MGC.SetPen( ^GreenPen );
	.MGC.FrameOval( .CircleA );

	.MGC.SetPen( ^BluePen );
	.MGC.MoveTo( Cx'int, Cy'int );
	.MGC.LineTo( Px, Py );

	.MGC.SetBrush( ^RedBrush );
	.MGC.CopyImage( .SGC, .MgcFullRect, .MgcFullRect, 0x00E20746 );

  SET_VFRAME:
	.MGC.SaveDC();
	.MGC.SetMapMode( #MM_TEXT );
	.gc.CopyImage( .MGC, .FigRect, .MgcFullRect, #SRCCOPY );
	//iӁjMM_TEXT ɂȂƁAY ̕tijɂȂĂ܂I
	.MGC.RestoreDC();
}

//-----------------------------------------------------------------------------
